# SymbolicIndexingInterface.jl: Standardized Symbolic Indexing of Julia

SymbolicIndexingInterface.jl is a set of interface functions for handling containers
of symbolic variables.

## Installation

To install SymbolicIndexingInterface.jl, use the Julia package manager:

```julia
using Pkg
Pkg.add("SymbolicIndexingInterface")
```

## Introduction

The symbolic indexing interface has 2 levels:

1. The user level. At the user level, a modeler or engineer simply uses terms from a
   domain-specific language (DSL) inside of SciML functionality and will receive the requested
   values. For example, if a DSL defines a symbol `x`, then `sol[x]` returns the solution
   value(s) for `x`.
2. The DSL system structure level. This is the structure which defines the symbolic indexing
   for a given problem/solution. DSLs can tag a constructed problem/solution with this
   object in order to endow the SciML tools with the ability to index symbolically according
   to the definitions the DSL writer wants.


## Example

```julia
# Use ModelingToolkit to make a solution

using ModelingToolkit, OrdinaryDiffEq, SymbolicIndexingInterface, Plots
using ModelingToolkit: t_nounits as t, D_nounits as D

@parameters σ ρ β
@variables x(t) y(t) z(t) w(t)

eqs = [D(D(x)) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
    w ~ x + y + z]

@mtkbuild sys = ODESystem(eqs, t)

u0 = [D(x) => 2.0,
    x => 1.0,
    y => 0.0,
    z => 0.0]

p = [σ => 28.0,
    ρ => 10.0,
    β => 8 / 3]

tspan = (0.0, 100.0)
prob = ODEProblem(sys, u0, tspan, p, jac = true)
sol = solve(prob, Tsit5())

# Now index it symbolically

sol[x]
```

using SymbolicIndexingInterface

syss = [
    SymbolCache([:x, :y, :z], [:a, :b, :c], :t),
    SymbolCache([:z, :w, :v], [:c, :e, :f]),
    SymbolCache([:w, :x, :u], [:e, :a, :f]),
]
syms = [
    [:x, :z, :b, :c],
    [:z, :w, :c, :f],
    [:w, :x, :e, :a],
]
probs = [
    ProblemState(; u = [1.0, 2.0, 3.0], p = [0.1, 0.2, 0.3]),
    ProblemState(; u = [4.0, 5.0, 6.0], p = [0.4, 0.5, 0.6]),
    ProblemState(; u = [7.0, 8.0, 9.0], p = [0.7, 0.8, 0.9]),
]

@test_throws ErrorException BatchedInterface((syss[1], [:x, 3]))
@test_throws ErrorException BatchedInterface((syss[1], [:(x + y)]))
@test_throws ErrorException BatchedInterface((syss[1], [:t]))

bi = BatchedInterface(zip(syss, syms)...)
@test variable_symbols(bi) == [:x, :z, :b, :c, :w, :f, :e, :a]
@test variable_index.((bi,), [:a, :b, :c, :e, :f, :x, :y, :z, :w, :v, :u]) ==
    [8, 3, 4, 7, 6, 1, nothing, 2, 5, nothing, nothing]
@test is_variable.((bi,), [:a, :b, :c, :e, :f, :x, :y, :z, :w, :v, :u]) ==
    Bool[1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0]
@test associated_systems(bi) == [1, 1, 1, 1, 2, 2, 3, 3]

getter = getsym(bi)
@test (@inferred getter(probs...)) == [1.0, 3.0, 0.2, 0.3, 5.0, 0.6, 0.7, 0.8]
buf = zeros(8)
@inferred getter(buf, probs...)
@test buf == [1.0, 3.0, 0.2, 0.3, 5.0, 0.6, 0.7, 0.8]

setter! = setsym(bi)
buf .*= 100
setter!(probs..., buf)

@test state_values(probs[1]) == [100.0, 2.0, 300.0]
# :a isn't updated here because it wasn't part of the symbols associated with syss[1] (syms[1])
@test parameter_values(probs[1]) == [0.1, 20.0, 30.0]
@test state_values(probs[2]) == [300.0, 500.0, 6.0]
# Similarly for :e
@test parameter_values(probs[2]) == [30.0, 0.5, 60.0]
@test state_values(probs[3]) == [500.0, 100.0, 9.0]
# Similarly for :f
@test parameter_values(probs[3]) == [70.0, 80.0, 0.9]

buf ./= 100
setter!(probs[1], 1, buf)
@test state_values(probs[1]) == [1.0, 2.0, 3.0]
@test parameter_values(probs[1]) == [0.1, 0.2, 0.3]

@test_throws ErrorException setter!(probs[1], 4, buf)

setter!(probs..., buf)

setter = setsym_oop(bi)

buf .*= 100
vals = setter(probs..., buf)
@test length(vals) == length(probs)
@test vals[1][1] == [100.0, 2.0, 300.0]
@test vals[1][2] == [0.1, 20.0, 30.0]
@test vals[2][1] == [300.0, 500.0, 6.0]
@test vals[2][2] == [30.0, 0.5, 60.0]
@test vals[3][1] == [500.0, 100.0, 9.0]
@test vals[3][2] == [70.0, 80.0, 0.9]

# out-of-place
for i in 1:3
    @test vals[i][1] != state_values(probs[i])
    @test vals[i][2] != parameter_values(probs[i])
end

buf ./= 10
vals = setter(probs[1], 1, buf)
@test length(vals) == 2
@test vals[1] == [10.0, 2.0, 30.0]
@test vals[2] == [0.1, 2.0, 3.0]

@test_throws ErrorException setter(probs[1], 4, buf)

using ModelingToolkit
using ModelingToolkit: t_nounits as t
using SymbolicIndexingInterface

@variables x(t)[1:2] y(t)
@named sys = ODESystem(Equation[], t, [x, y], [])
sys = complete(sys)

u0 = [1.0, 2.0, 3.0]
newu0 = remake_buffer(sys, u0, [x, y], ([5.0, 6.0], 7.0))
@test newu0 == [5.0, 6.0, 7.0]

@setup_workload begin
    indp = SymbolCache([:x, :y], [:a, :b], :t)
    valp = ProblemState(; u = [1.0, 2.0], p = [3.0, 4.0], t = 0.5)

    @compile_workload begin
        variable_symbols(indp)
        state_values(valp)
        parameter_values(valp)
    end
end

using SymbolicIndexingInterface
using Test

indp = SymbolCache([:x, :y], [:a, :b], :t)
valp = ProblemState(; u = [1.0, 2.0], p = [3.0, 4.0], t = 0.5)

@test getsym(indp, :x)(valp) == 1.0
@test getsym(indp, :(x + a + t))(valp) == 4.5
@test getp(indp, [:a, :b])(valp) == [3.0, 4.0]

state_setter = setsym(indp, [:x, :y])
state_setter(valp, [5.0, 6.0])
@test state_values(valp) == [5.0, 6.0]

parameter_setter = setp(indp, [:a, :b])
parameter_setter(valp, [7.0, 8.0])
@test parameter_values(valp) == [7.0, 8.0]

batch = BatchedInterface((indp, [:x, :a]), (indp, [:y, :b]))
@test variable_symbols(batch) == [:x, :a, :y, :b]
@test getsym(batch)(valp, valp) == [5.0, 7.0, 6.0, 8.0]

using ModelingToolkit, SymbolicIndexingInterface
using ModelingToolkit: t_nounits as t, D_nounits as D

@variables x(t)[1:2]
@parameters p[1:2, 1:2] q(t)[1:2] r[1:2]

ev = [x[1] ~ 2.0] => [q ~ -ones(2)]
@mtkbuild sys = ODESystem(
    [D(x) ~ p * x + q + r], t, [x], [p, q, r...]; continuous_events = [ev]
)
@test is_timeseries_parameter(sys, q)
@test !is_timeseries_parameter(sys, p)
@test !is_parameter(sys, r)
@test is_parameter(sys, r[1])
@test is_parameter(sys, r[2])

prob = ODEProblem(
    sys, [x => ones(2)], (0.0, 10.0), [p => ones(2, 2), q => ones(2), r => 2ones(2)]
)
@test prob.ps[q] ≈ ones(2)
@test prob.ps[p] ≈ ones(2, 2)
@test prob.ps[r] ≈ 2ones(2)
@test prob.ps[p * q] ≈ 2ones(2)

@test getu(sys, p)(prob) ≈ ones(2, 2)
@test getu(sys, r)(prob) ≈ 2ones(2)

prob.ps[p] = 2ones(2, 2)
@test prob.ps[p] ≈ 2ones(2, 2)
prob.ps[q] = 2ones(2)
@test prob.ps[q] ≈ 2ones(2)
prob.ps[r] = ones(2)
@test prob.ps[r] ≈ ones(2)

setter = setp_oop(sys, p)
newp = setter(prob, 3ones(2, 2))
@test getp(sys, p)(newp) ≈ 3ones(2, 2)
setter = setp_oop(sys, r)
newp = setter(prob, 3ones(2))
@test getp(sys, r)(newp) ≈ 3ones(2)

setter = setsym_oop(sys, p)
_, newp = setter(prob, 3ones(2, 2))
@test getp(sys, p)(newp) ≈ 3ones(2, 2)
setter = setsym_oop(sys, r)
_, newp = setter(prob, 3ones(2))
@test getp(sys, r)(newp) ≈ 3ones(2)

@test prob[x] ≈ ones(2)
prob[x] = 2ones(2)
@test prob[x] ≈ 2ones(2)

setu(sys, p)(prob, 4ones(2, 2))
@test prob.ps[p] ≈ 4ones(2, 2)
setu(sys, r)(prob, 4ones(2))
@test prob.ps[r] ≈ 4ones(2)

setter = setsym_oop(sys, x)
newu, newp = setter(prob, 3ones(2))
@test getu(sys, x)(newu) ≈ 3ones(2)

module SymbolicIndexingInterfacePrettyTablesExt

using SymbolicIndexingInterface
using SymbolicIndexingInterface: ParameterIndexingProxy, parameter_symbols, symbolic_type,
    ArraySymbolic, getp
using PrettyTables: PrettyTables, pretty_table

# Override the fallback implementation with the PrettyTables version
function SymbolicIndexingInterface.show_params(
        io::IO, pip::ParameterIndexingProxy; num_rows = 20,
        show_all = false, scalarize = true, kwargs...
    )
    params = Any[]
    vals = Any[]
    for p in parameter_symbols(pip.wrapped)
        if symbolic_type(p) === ArraySymbolic() && scalarize
            val = getp(pip.wrapped, p)(pip.wrapped)
            for (_p, _v) in zip(collect(p), val)
                push!(params, _p)
                push!(vals, _v)
            end
        else
            push!(params, p)
            val = getp(pip.wrapped, p)(pip.wrapped)
            push!(vals, val)
        end
    end

    num_shown = if show_all
        length(params)
    else
        if num_rows > length(params)
            length(params)
        else
            num_rows
        end
    end

    pretty_table(
        io, [params[1:num_shown] vals[1:num_shown]];
        column_labels = ["Parameter", "Value"],
        kwargs...
    )

    return if num_shown < length(params)
        println(
            io,
            "$num_shown of $(length(params)) params shown. To show all the parameters, call `show_params(io, ps, show_all = true)`. Adjust the number of rows with the num_rows kwarg. Consult `show_params` docstring for more options."
        )
    end
end

end

"""
    struct SymbolCache
    function SymbolCache(vars, [params, [indepvars]]; defaults = Dict(), timeseries_parameters = nothing)

A struct implementing the index provider interface for a collection of variables,
parameters, and independent variables. `vars` and `params` can be specified as arrays
(in which case the index of a symbol is its index in the array) or `AbstractDict`s
mapping symbols to indices. It is considered time dependent if it contains at least one
independent variable.

It returns `true` for `is_observed(::SymbolCache, sym)` if
`sym isa Union{Expr, Array{Expr}, Tuple{Vararg{Expr}}`. Functions can be generated using
`observed` for `Expr`s involving variables in the `SymbolCache` if it has at most one
independent variable.

`defaults` is an `AbstractDict` mapping variables and/or parameters to their default
initial values. The default initial values can also be other variables/
parameters or expressions of them. `timeseries_parameters` is an `AbstractDict` the
timeseries parameters in `params` to their [`ParameterTimeseriesIndex`](@ref) indexes.

The independent variable may be specified as a single symbolic variable instead of an
array containing a single variable if the system has only one independent variable.
"""
struct SymbolCache{
        V <: Union{Nothing, AbstractDict},
        P <: Union{Nothing, AbstractDict},
        T <: Union{Nothing, AbstractDict},
        I,
        D <: AbstractDict,
    }
    variables::V
    parameters::P
    timeseries_parameters::T
    independent_variables::I
    defaults::D
end

function to_dict_or_nothing(arr::Union{AbstractArray, Tuple})
    eltype(arr) <: Pair && return Dict(arr)
    isempty(arr) && return nothing
    return Dict(v => k for (k, v) in enumerate(arr))
end
to_dict_or_nothing(d::AbstractDict) = d
to_dict_or_nothing(::Nothing) = nothing

function SymbolCache(
        vars = nothing, params = nothing, indepvars = nothing;
        defaults = Dict(), timeseries_parameters = nothing
    )
    vars = to_dict_or_nothing(vars)
    params = to_dict_or_nothing(params)
    timeseries_parameters = to_dict_or_nothing(timeseries_parameters)
    if timeseries_parameters !== nothing
        if indepvars === nothing
            throw(ArgumentError("Independent variable is required for timeseries parameters to exist"))
        end
        for (k, v) in timeseries_parameters
            if !haskey(params, k)
                throw(ArgumentError("Timeseries parameter $k must also be present in parameters."))
            end
            if !isa(v, ParameterTimeseriesIndex)
                throw(
                    TypeError(
                        :SymbolCache, "index of timeseries parameter $k",
                        ParameterTimeseriesIndex, v
                    )
                )
            end
        end
    end
    return SymbolCache{
        typeof(vars), typeof(params), typeof(timeseries_parameters),
        typeof(indepvars), typeof(defaults),
    }(
        vars,
        params,
        timeseries_parameters,
        indepvars,
        defaults
    )
end

function is_variable(sc::SymbolCache, sym)
    sc.variables === nothing && return false
    if symbolic_type(sym) == NotSymbolic()
        return sym in values(sc.variables)
    else
        return haskey(sc.variables, sym)
    end
end
function variable_index(sc::SymbolCache, sym)
    sc.variables === nothing && return nothing
    if symbolic_type(sym) == NotSymbolic()
        return sym
    else
        return get(sc.variables, sym, nothing)
    end
end
function variable_symbols(sc::SymbolCache, i = nothing)
    sc.variables === nothing && return []
    buffer = collect(keys(sc.variables))
    for (k, v) in sc.variables
        buffer[v] = k
    end
    return buffer
end
function is_parameter(sc::SymbolCache, sym)
    sc.parameters === nothing && return false
    if symbolic_type(sym) == NotSymbolic()
        return sym in values(sc.parameters)
    else
        return haskey(sc.parameters, sym)
    end
end
function parameter_index(sc::SymbolCache, sym)
    sc.parameters === nothing && return nothing
    if symbolic_type(sym) == NotSymbolic()
        return sym
    else
        return get(sc.parameters, sym, nothing)
    end
end
function parameter_symbols(sc::SymbolCache)
    return sc.parameters === nothing ? [] : collect(keys(sc.parameters))
end
function is_timeseries_parameter(sc::SymbolCache, sym)
    sc.timeseries_parameters === nothing && return false
    if symbolic_type(sym) == NotSymbolic()
        return sym in values(sc.timeseries_parameters)
    else
        return haskey(sc.timeseries_parameters, sym)
    end
end
function timeseries_parameter_index(sc::SymbolCache, sym)
    sc.timeseries_parameters === nothing && return nothing
    if symbolic_type(sym) == NotSymbolic()
        return sym
    else
        return get(sc.timeseries_parameters, sym, nothing)
    end
end

for symT in [Any, Expr, AbstractArray]
    @eval function get_all_timeseries_indexes(
            ::SymbolCache{Nothing, Nothing, Nothing}, ::$symT
        )
        return Set([ContinuousTimeseries()])
    end
end

function get_all_timeseries_indexes(sc::SymbolCache, sym)
    if is_variable(sc, sym) || is_independent_variable(sc, sym)
        return Set([ContinuousTimeseries()])
    elseif is_timeseries_parameter(sc, sym)
        return Set([timeseries_parameter_index(sc, sym).timeseries_idx])
    else
        return Set()
    end
end
function get_all_timeseries_indexes(sc::SymbolCache, sym::Expr)
    exs = ExpressionSearcher()
    exs(sc, sym)
    return mapreduce(
        Base.Fix1(get_all_timeseries_indexes, sc), union, exs.declared; init = Set()
    )
end
function get_all_timeseries_indexes(sc::SymbolCache, sym::AbstractArray)
    return mapreduce(Base.Fix1(get_all_timeseries_indexes, sc), union, sym; init = Set())
end
function is_independent_variable(sc::SymbolCache, sym)
    sc.independent_variables === nothing && return false
    if symbolic_type(sc.independent_variables) == NotSymbolic()
        return any(isequal(sym), sc.independent_variables)
    elseif symbolic_type(sc.independent_variables) == ScalarSymbolic()
        return isequal(sym, sc.independent_variables)
    else
        return any(isequal(sym), collect(sc.independent_variables))
    end
end
function independent_variable_symbols(sc::SymbolCache)
    sc.independent_variables === nothing && return []
    if symbolic_type(sc.independent_variables) == NotSymbolic()
        return sc.independent_variables
    elseif symbolic_type(sc.independent_variables) == ScalarSymbolic()
        return [sc.independent_variables]
    else
        return collect(sc.independent_variables)
    end
end
is_observed(sc::SymbolCache, sym) = false
is_observed(::SymbolCache, ::Expr) = true
is_observed(::SymbolCache, ::Array{Expr}) = true
is_observed(::SymbolCache, ::Tuple{Vararg{Expr}}) = true

# TODO: Make this less hacky
struct ExpressionSearcher
    parameters::Set{Symbol}
    declared::Set{Symbol}
    fnbody::Expr
end

ExpressionSearcher() = ExpressionSearcher(Set{Symbol}(), Set{Symbol}(), Expr(:block))

function (exs::ExpressionSearcher)(sys, expr::Expr)
    for arg in expr.args
        exs(sys, arg)
    end
    exs(sys, expr.head)
    return nothing
end

function (exs::ExpressionSearcher)(sys, sym::Symbol)
    sym in exs.declared && return
    if is_variable(sys, sym)
        idx = variable_index(sys, sym)
        push!(exs.fnbody.args, :($sym = u[$idx]))
    elseif is_parameter(sys, sym)
        idx = parameter_index(sys, sym)
        push!(exs.parameters, sym)
        push!(exs.fnbody.args, :($sym = parameter_values(p, $idx)))
    elseif is_independent_variable(sys, sym)
        push!(exs.fnbody.args, :($sym = t))
    end
    push!(exs.declared, sym)
    return nothing
end

(::ExpressionSearcher)(sys, sym) = nothing

function observed(sc::SymbolCache, expr::Expr)
    let cache = Dict{Expr, Function}()
        return get!(cache, expr) do
            exs = ExpressionSearcher()
            exs(sc, expr)
            fnexpr = if is_time_dependent(sc)
                :(
                    function (u, p, t)
                        $(exs.fnbody)
                        return $expr
                    end
                )
            else
                :(
                    function (u, p)
                        $(exs.fnbody)
                        return $expr
                    end
                )
            end
            return RuntimeGeneratedFunctions.@RuntimeGeneratedFunction(fnexpr)
        end
    end
end

to_expr(exprs::AbstractArray) = :(reshape([$(exprs...)], $(size(exprs))))
to_expr(exprs::Tuple) = :(($(exprs...),))

function inplace_observed(sc::SymbolCache, exprs::Union{AbstractArray, Tuple})
    let cache = Dict{Expr, Function}()
        return get!(cache, to_expr(exprs)) do
            exs = ExpressionSearcher()
            for expr in exprs
                exs(sc, expr)
            end
            update_expr = Expr(:block)
            for (i, expr) in enumerate(exprs)
                push!(update_expr.args, :(buffer[$i] = $expr))
            end
            fnexpr = if is_time_dependent(sc)
                :(
                    function (buffer, u, p, t)
                        $(exs.fnbody)
                        $update_expr
                        return buffer
                    end
                )
            else
                :(
                    function (buffer, u, p)
                        $(exs.fnbody)
                        $update_expr
                        return buffer
                    end
                )
            end
            return RuntimeGeneratedFunctions.@RuntimeGeneratedFunction(fnexpr)
        end
    end
end

function observed(sc::SymbolCache, exprs::Union{AbstractArray, Tuple})
    for expr in exprs
        if !(expr isa Union{Symbol, Expr})
            throw(TypeError(:observed, "SymbolCache", Union{Symbol, Expr}, expr))
        end
    end
    return observed(sc, to_expr(exprs))
end

function parameter_observed(sc::SymbolCache, expr::Expr)
    if is_time_dependent(sc)
        exs = ExpressionSearcher()
        exs(sc, expr)
        return let fn = observed(sc, expr)
            f1(p, t) = fn(nothing, p, t)
        end
    else
        return let fn = observed(sc, expr)
            f2(p) = fn(nothing, p)
        end
    end
end

function parameter_observed(sc::SymbolCache, exprs::Union{AbstractArray, Tuple})
    for ex in exprs
        if !(ex isa Union{Symbol, Expr})
            throw(TypeError(:parameter_observed, "SymbolCache", Union{Symbol, Expr}, ex))
        end
    end
    if is_time_dependent(sc)
        exs = ExpressionSearcher()
        exs(sc, to_expr(exprs))

        return let oop = observed(sc, to_expr(exprs)), iip = inplace_observed(sc, exprs)
            f1(p, t) = oop(nothing, p, t)
            f1(buffer, p, t) = iip(buffer, nothing, p, t)
        end
    else
        return let oop = observed(sc, to_expr(exprs)), iip = inplace_observed(sc, exprs)
            f2(p) = oop(nothing, p)
            f2(buffer, p) = iip(buffer, nothing, p)
        end
    end
end

function is_time_dependent(sc::SymbolCache)
    sc.independent_variables === nothing && return false
    if symbolic_type(sc.independent_variables) == NotSymbolic()
        return !isempty(sc.independent_variables)
    else
        return true
    end
end
constant_structure(::SymbolCache) = true
all_variable_symbols(sc::SymbolCache) = variable_symbols(sc)
function all_symbols(sc::SymbolCache)
    return vcat(variable_symbols(sc), parameter_symbols(sc), independent_variable_symbols(sc))
end
default_values(sc::SymbolCache) = sc.defaults

function Base.copy(sc::SymbolCache)
    return SymbolCache(
        sc.variables === nothing ? nothing : copy(sc.variables),
        sc.parameters === nothing ? nothing : copy(sc.parameters),
        sc.timeseries_parameters === nothing ? nothing : copy(sc.timeseries_parameters),
        sc.independent_variables isa AbstractArray ? copy(sc.independent_variables) :
            sc.independent_variables, copy(sc.defaults)
    )
end

"""
    struct ProblemState
    function ProblemState(; u = nothing, p = nothing, t = nothing, h = nothing)

A value provider struct which can be used as an argument to the function returned by
[`getsym`](@ref) or [`setsym`](@ref). It stores the state vector, parameter object and
current time, and forwards calls to [`state_values`](@ref), [`parameter_values`](@ref),
[`current_time`](@ref), [`set_state!`](@ref), [`set_parameter!`](@ref) to the contained
objects.

A history function may be provided using the `h` keyword, which will be returned with
[`get_history_function`](@ref).
"""
struct ProblemState{U, P, T, H}
    u::U
    p::P
    t::T
    h::H
end

function ProblemState(; u = nothing, p = nothing, t = nothing, h = nothing)
    return ProblemState(u, p, t, h)
end

state_values(ps::ProblemState) = ps.u
parameter_values(ps::ProblemState) = ps.p
current_time(ps::ProblemState) = ps.t
set_state!(ps::ProblemState, val, idx) = set_state!(ps.u, val, idx)
set_parameter!(ps::ProblemState, val, idx) = set_parameter!(ps.p, val, idx)
get_history_function(ps::ProblemState) = ps.h

struct __InternalInvalidator1 <: Real end
struct __InternalInvalidator2 <: Real end
struct __InternalInvalidator3 <: AbstractVector{Real} end
symbolic_type(::Type{__InternalInvalidator1}) = ScalarSymbolic()
symbolic_type(::Type{__InternalInvalidator2}) = ArraySymbolic()
symbolic_type(::Type{__InternalInvalidator3}) = ScalarSymbolic()
symbolic_type(::Type{Int}) = NotSymbolic()
symbolic_type(::Type{UInt}) = NotSymbolic()
symbolic_type(::Type{Float64}) = NotSymbolic()
symbolic_type(::Type{Vector{Int}}) = NotSymbolic()
symbolic_type(::Type{Matrix{Float64}}) = NotSymbolic()
symbolic_type(::Type{Array{UInt, 3}}) = NotSymbolic()

"""
    getp(indp, sym)

Return a function that takes an value provider, and returns the value of the
parameter `sym`. The value provider has to at least store the values of parameters
in the corresponding index provider. Note that `sym` can be an index, symbolic variable,
or an array/tuple of the aforementioned.

If `sym` is an array/tuple of parameters, then the returned function can also be used
as an in-place getter function. The first argument is the buffer (must be an
`AbstractArray`) to which the parameter values should be written, and the second argument
is the value provider.

Requires that the value provider implement [`parameter_values`](@ref). This function
may not always need to be implemented, and has a default implementation for collections
that implement `getindex`.

If the returned function is used on a timeseries object which saves parameter timeseries,
it can be used to index said timeseries. The timeseries object must implement
[`is_parameter_timeseries`](@ref) and [`get_parameter_timeseries_collection`](@ref).
Additionally, the parameter object must implement
[`with_updated_parameter_timeseries_values`](@ref).

If `sym` is a timeseries parameter, the function will return the timeseries of the
parameter if the value provider is a parameter timeseries object. An additional argument
can be provided to the function indicating the specific indexes in the timeseries at
which to access the values. If `sym` is an array of parameters, the following cases
apply:

- All parameters are non-timeseries parameters: The function returns the value of each
  parameter.
- All parameters are timeseries parameters: All the parameters must belong to the same
  timeseries (otherwise `getp` will error). The function returns the timeseries of all
  parameter values, and can be accessed at specific indices in the timeseries.
- A mix of timeseries and non-timeseries parameters: The function can _only_ be used on
  non-timeseries objects and will return the value of each parameter at in the object.
"""
function getp(sys, p)
    symtype = symbolic_type(p)
    elsymtype = symbolic_type(eltype(p))
    return _getp(sys, symtype, elsymtype, p)
end

struct GetParameterIndex{I} <: AbstractParameterGetIndexer
    idx::I
end

is_indexer_timeseries(::Type{GetParameterIndex{I}}) where {I} = IndexerNotTimeseries()
function is_indexer_timeseries(::Type{GetParameterIndex{I}}) where {
        I <:
        ParameterTimeseriesIndex,
    }
    return IndexerOnlyTimeseries()
end
function indexer_timeseries_index(gpi::GetParameterIndex{<:ParameterTimeseriesIndex})
    return gpi.idx.timeseries_idx
end
function (gpi::GetParameterIndex)(::IsTimeseriesTrait, prob)
    return parameter_values(prob, gpi.idx)
end
function (gpi::GetParameterIndex)(::IsTimeseriesTrait, prob, arg)
    return parameter_values(prob, gpi.idx)
end
function (gpi::GetParameterIndex)(::Timeseries, prob, args)
    return parameter_values(prob, gpi.idx)
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(::Timeseries, prob)
    return get_parameter_timeseries_collection(prob)[gpi.idx]
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        buffer::AbstractArray, ts::Timeseries, prob
    )
    for (buf_idx, ts_idx) in zip(
            eachindex(buffer),
            eachindex(parameter_timeseries(prob, indexer_timeseries_index(gpi)))
        )
        buffer[buf_idx] = gpi(ts, prob, ts_idx)
    end
    return buffer
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        ::Timeseries, prob, i::Union{Int, CartesianIndex}
    )
    return parameter_values(prob, gpi.idx, i)
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(ts::Timeseries, prob, ::Colon)
    return gpi(ts, prob)
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        buffer::AbstractArray, ts::Timeseries, prob, ::Colon
    )
    return gpi(buffer, ts, prob)
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        ts::Timeseries, prob, i::AbstractArray{Bool}
    )
    return map(
        only(
            to_indices(
                parameter_timeseries(prob, indexer_timeseries_index(gpi)), (i,)
            )
        )
    ) do idx
        gpi(ts, prob, idx)
    end
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        buffer::AbstractArray, ts::Timeseries, prob, i::AbstractArray{Bool}
    )
    for (buf_idx, ts_idx) in zip(
            eachindex(buffer),
            only(to_indices(parameter_timeseries(prob, indexer_timeseries_index(gpi)), (i,)))
        )
        buffer[buf_idx] = gpi(ts, prob, ts_idx)
    end
    return buffer
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(ts::Timeseries, prob, i)
    return gpi.((ts,), (prob,), i)
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        buffer::AbstractArray, ts::Timeseries, prob, i
    )
    for (buf_idx, subidx) in zip(eachindex(buffer), i)
        buffer[buf_idx] = gpi(ts, prob, subidx)
    end
    return buffer
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(::NotTimeseries, prob)
    throw(ParameterTimeseriesValueIndexMismatchError{NotTimeseries}(prob, gpi))
end
function (gpi::GetParameterIndex{<:ParameterTimeseriesIndex})(
        ::AbstractArray, ::NotTimeseries, prob
    )
    throw(ParameterTimeseriesValueIndexMismatchError{NotTimeseries}(prob, gpi))
end

function _getp(sys, ::NotSymbolic, ::NotSymbolic, p)
    return GetParameterIndex(p)
end

struct GetParameterTimeseriesIndex{
        I <: GetParameterIndex, J <: GetParameterIndex{<:ParameterTimeseriesIndex},
    } <:
    AbstractParameterGetIndexer
    param_idx::I
    param_timeseries_idx::J
end

is_indexer_timeseries(::Type{G}) where {G <: GetParameterTimeseriesIndex} = IndexerBoth()
function indexer_timeseries_index(gpti::GetParameterTimeseriesIndex)
    return indexer_timeseries_index(gpti.param_timeseries_idx)
end
function as_timeseries_indexer(::IndexerBoth, gpti::GetParameterTimeseriesIndex)
    return gpti.param_timeseries_idx
end
function as_not_timeseries_indexer(::IndexerBoth, gpti::GetParameterTimeseriesIndex)
    return gpti.param_idx
end

function (gpti::GetParameterTimeseriesIndex)(ts::Timeseries, prob, args...)
    return gpti.param_timeseries_idx(ts, prob, args...)
end
function (gpti::GetParameterTimeseriesIndex)(
        buffer::AbstractArray, ts::Timeseries, prob, args...
    )
    return gpti.param_timeseries_idx(buffer, ts, prob, args...)
end
function (gpti::GetParameterTimeseriesIndex)(ts::NotTimeseries, prob)
    return gpti.param_idx(ts, prob)
end

struct GetParameterObserved{I, M, P, F <: Function} <: AbstractParameterGetIndexer
    timeseries_idx::I
    parameter_update_fn::P
    obsfn::F
end

function GetParameterObserved{Multiple}(
        timeseries_idx::I, update_fn::P, obsfn::F
    ) where {Multiple, I, P, F}
    if !isa(Multiple, Bool)
        throw(TypeError(:GetParameterObserved, "{Multiple}", Bool, Multiple))
    end
    return GetParameterObserved{I, Multiple, P, F}(timeseries_idx, update_fn, obsfn)
end

const MultipleGetParameterObserved = GetParameterObserved{I, true} where {I}
const SingleGetParameterObserved = GetParameterObserved{I, false} where {I}

function is_indexer_timeseries(::Type{G}) where {G <: GetParameterObserved{Nothing}}
    return IndexerNotTimeseries()
end
function is_indexer_timeseries(::Type{G}) where {I <: Vector, G <: GetParameterObserved{I}}
    return IndexerMixedTimeseries()
end
is_indexer_timeseries(::Type{G}) where {G <: GetParameterObserved} = IndexerBoth()
indexer_timeseries_index(gpo::GetParameterObserved) = gpo.timeseries_idx
as_timeseries_indexer(::IndexerBoth, gpo::GetParameterObserved) = gpo
as_not_timeseries_indexer(::IndexerBoth, gpo::GetParameterObserved) = gpo
as_not_timeseries_indexer(::IndexerMixedTimeseries, gpo::GetParameterObserved) = gpo

function (gpo::GetParameterObserved{Nothing})(::Timeseries, prob)
    return gpo.obsfn(parameter_values(prob), current_time(prob)[end])
end
function (gpo::GetParameterObserved{Nothing, true})(
        buffer::AbstractArray, ::Timeseries, prob
    )
    gpo.obsfn(buffer, parameter_values(prob), current_time(prob)[end])
    return buffer
end
for argType in [Union{Int, CartesianIndex}, Colon, AbstractArray{Bool}, Any]
    @eval function (gpo::GetParameterObserved{Nothing})(::Timeseries, prob, args::$argType)
        return gpo.obsfn(parameter_values(prob), current_time(prob)[end])
    end
    @eval function (gpo::GetParameterObserved{Nothing, true})(
            buffer::AbstractArray, ::Timeseries, prob, args::$argType
        )
        gpo.obsfn(buffer, parameter_values(prob), current_time(prob)[end])
        return buffer
    end
    @eval function (gpo::GetParameterObserved{<:Vector})(::Timeseries, prob, args::$argType)
        throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(gpo)))
    end
    for multiple in [true, false]
        @eval function (gpo::GetParameterObserved{<:Vector, $multiple})(
                ::AbstractArray, ::Timeseries, prob, args::$argType
            )
            throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(gpo)))
        end
    end
end

function (gpo::GetParameterObserved{<:Vector})(::NotTimeseries, prob)
    # if the method doesn't exist or is an identity function, then `prob` itself
    # is the parameter object, so use that and pass `nothing` for the time expecting
    # it to not be used
    return if hasmethod(parameter_values, Tuple{typeof(prob)}) &&
            (ps = parameter_values(prob)) != prob
        gpo.obsfn(ps, current_time(prob))
    else
        gpo.obsfn(prob, nothing)
    end
end
function (gpo::GetParameterObserved{<:Vector, true})(
        buffer::AbstractArray, ::NotTimeseries, prob
    )
    return if hasmethod(parameter_values, Tuple{typeof(prob)}) &&
            (ps = parameter_values(prob)) != prob
        gpo.obsfn(buffer, ps, current_time(prob))
    else
        gpo.obsfn(buffer, prob, nothing)
    end
end
function (gpo::GetParameterObserved{<:Vector})(::Timeseries, prob)
    throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(gpo)))
end
function (gpo::GetParameterObserved{<:Vector, true})(::AbstractArray, ::Timeseries, prob)
    throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(gpo)))
end
function (gpo::GetParameterObserved{<:Vector, false})(::AbstractArray, ::Timeseries, prob)
    throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(gpo)))
end
function (gpo::GetParameterObserved)(::NotTimeseries, prob)
    return if hasmethod(parameter_values, Tuple{typeof(prob)}) &&
            (ps = parameter_values(prob)) != prob
        gpo.obsfn(ps, current_time(prob))
    else
        gpo.obsfn(prob, nothing)
    end
end
function (gpo::GetParameterObserved)(buffer::AbstractArray, ::NotTimeseries, prob)
    if hasmethod(parameter_values, Tuple{typeof(prob)}) &&
            (ps = parameter_values(prob)) != prob
        gpo.obsfn(buffer, ps, current_time(prob))
    else
        gpo.obsfn(buffer, prob, nothing)
    end
    return buffer
end
function (gpo::GetParameterObserved)(::Timeseries, prob)
    return map(parameter_timeseries(prob, gpo.timeseries_idx)) do t
        gpo.obsfn(gpo.parameter_update_fn(prob, t), t)
    end
end
function (gpo::MultipleGetParameterObserved)(buffer::AbstractArray, ::Timeseries, prob)
    times = parameter_timeseries(prob, gpo.timeseries_idx)
    for (buf_idx, time) in zip(eachindex(buffer), times)
        gpo.obsfn(buffer[buf_idx], gpo.parameter_update_fn(prob, time), time)
    end
    return buffer
end
function (gpo::SingleGetParameterObserved)(buffer::AbstractArray, ::Timeseries, prob)
    times = parameter_timeseries(prob, gpo.timeseries_idx)
    for (buf_idx, time) in zip(eachindex(buffer), times)
        buffer[buf_idx] = gpo.obsfn(gpo.parameter_update_fn(prob, time), time)
    end
    return buffer
end
function (gpo::GetParameterObserved)(::Timeseries, prob, i::Union{Int, CartesianIndex})
    time = parameter_timeseries(prob, gpo.timeseries_idx)[i]
    return gpo.obsfn(gpo.parameter_update_fn(prob, time), time)
end
function (gpo::MultipleGetParameterObserved)(
        buffer::AbstractArray, ::Timeseries, prob, i::Union{Int, CartesianIndex}
    )
    time = parameter_timeseries(prob, gpo.timeseries_idx)[i]
    return gpo.obsfn(buffer, gpo.parameter_update_fn(prob, time), time)
end
function (gpo::GetParameterObserved)(ts::Timeseries, prob, ::Colon)
    return gpo(ts, prob)
end
for gpoType in [MultipleGetParameterObserved, SingleGetParameterObserved]
    @eval function (gpo::$gpoType)(buffer::AbstractArray, ts::Timeseries, prob, ::Colon)
        return gpo(buffer, ts, prob)
    end
end
function (gpo::GetParameterObserved)(ts::Timeseries, prob, i::AbstractArray{Bool})
    return map(only(to_indices(parameter_timeseries(prob, gpo.timeseries_idx), (i,)))) do idx
        gpo(ts, prob, idx)
    end
end
function (gpo::MultipleGetParameterObserved)(
        buffer::AbstractArray, ts::Timeseries, prob, i::AbstractArray{Bool}
    )
    for (buf_idx, time_idx) in zip(
            eachindex(buffer),
            only(to_indices(parameter_timeseries(prob, gpo.timeseries_idx), (i,)))
        )
        gpo(buffer[buf_idx], ts, prob, time_idx)
    end
    return buffer
end
function (gpo::SingleGetParameterObserved)(
        buffer::AbstractArray, ts::Timeseries, prob, i::AbstractArray{Bool}
    )
    for (buf_idx, time_idx) in zip(
            eachindex(buffer),
            only(to_indices(parameter_timeseries(prob, gpo.timeseries_idx), (i,)))
        )
        buffer[buf_idx] = gpo(ts, prob, time_idx)
    end
    return buffer
end
function (gpo::GetParameterObserved)(ts::Timeseries, prob, i)
    return map(i) do idx
        gpo(ts, prob, idx)
    end
end
function (gpo::MultipleGetParameterObserved)(buffer::AbstractArray, ts::Timeseries, prob, i)
    for (buf_idx, time_idx) in zip(eachindex(buffer), i)
        gpo(buffer[buf_idx], ts, prob, time_idx)
    end
    return buffer
end
function (gpo::SingleGetParameterObserved)(buffer::AbstractArray, ts::Timeseries, prob, i)
    for (buf_idx, time_idx) in zip(eachindex(buffer), i)
        buffer[buf_idx] = gpo(ts, prob, time_idx)
    end
    return buffer
end

struct GetParameterObservedNoTime{F <: Function} <: AbstractParameterGetIndexer
    obsfn::F
end

function is_indexer_timeseries(::Type{G}) where {G <: GetParameterObservedNoTime}
    return IndexerNotTimeseries()
end

function (gpo::GetParameterObservedNoTime)(::NotTimeseries, prob)
    return gpo.obsfn(parameter_values(prob))
end
function (gpo::GetParameterObservedNoTime)(buffer::AbstractArray, ::NotTimeseries, prob)
    return gpo.obsfn(buffer, parameter_values(prob))
end

function _getp(sys, ::ScalarSymbolic, ::SymbolicTypeTrait, p)
    if is_parameter(sys, p)
        idx = parameter_index(sys, p)
        if is_timeseries_parameter(sys, p)
            ts_idx = timeseries_parameter_index(sys, p)
            return GetParameterTimeseriesIndex(
                GetParameterIndex(idx), GetParameterIndex(ts_idx)
            )
        else
            return GetParameterIndex(idx)
        end
    elseif is_observed(sys, p)
        pofn = parameter_observed(sys, p)
        if pofn === nothing
            throw(ArgumentError("Index provider does not support `parameter_observed`; cannot use generate function for $p"))
        end
        if !is_time_dependent(sys)
            return GetParameterObservedNoTime(pofn)
        end
        ts_idxs = _postprocess_tsidxs(get_all_timeseries_indexes(sys, p))
        update_fn = Fix1Multiple(parameter_values_at_time, sys)
        return GetParameterObserved{false}(ts_idxs, update_fn, pofn)
    end
    error("Invalid symbol $p for `getp`")
end

struct MultipleParametersGetter{T <: IndexerTimeseriesType, G, I} <:
    AbstractParameterGetIndexer
    getters::G
    timeseries_idx::I
end

function MultipleParametersGetter(getters)
    if isempty(getters)
        return MultipleParametersGetter{IndexerNotTimeseries, typeof(getters), Nothing}(
            getters, nothing
        )
    end
    has_only_timeseries_indexers = any(getters) do g
        is_indexer_timeseries(g) == IndexerOnlyTimeseries()
    end
    has_non_timeseries_indexers = any(getters) do g
        is_indexer_timeseries(g) == IndexerNotTimeseries()
    end
    all_non_timeseries_indexers = all(getters) do g
        is_indexer_timeseries(g) == IndexerNotTimeseries()
    end
    if has_only_timeseries_indexers && has_non_timeseries_indexers
        throw(ArgumentError("Cannot mix timeseries indexes with non-timeseries variables in `$MultipleParametersGetter`"))
    end
    # If any getters are only timeseries, all of them should be
    indexer_type = if has_only_timeseries_indexers
        getters = as_timeseries_indexer.(getters)
        IndexerOnlyTimeseries
        # If all indexers are non-timeseries, so should their combination
    elseif all_non_timeseries_indexers
        IndexerNotTimeseries
    else
        IndexerBoth
    end

    timeseries_idx = if indexer_type == IndexerNotTimeseries
        nothing
    else
        timeseries_idxs = Set(
            Iterators.flatten(
                indexer_timeseries_index(g)
                    for g in getters if is_indexer_timeseries(g) != IndexerNotTimeseries()
            )
        )
        if length(timeseries_idxs) > 1
            indexer_type = IndexerMixedTimeseries
            getters = as_not_timeseries_indexer.(getters)
            collect(timeseries_idxs)
        else
            only(timeseries_idxs)
        end
    end

    return MultipleParametersGetter{indexer_type, typeof(getters), typeof(timeseries_idx)}(
        getters, timeseries_idx
    )
end

const OnlyTimeseriesMPG = MultipleParametersGetter{IndexerOnlyTimeseries}
const BothMPG = MultipleParametersGetter{IndexerBoth}
const NonTimeseriesMPG = MultipleParametersGetter{IndexerNotTimeseries}
const MixedTimeseriesMPG = MultipleParametersGetter{IndexerMixedTimeseries}
const AtLeastTimeseriesMPG = Union{OnlyTimeseriesMPG, BothMPG}

is_indexer_timeseries(::Type{<:MultipleParametersGetter{T}}) where {T} = T()
function indexer_timeseries_index(mpg::MultipleParametersGetter)
    return mpg.timeseries_idx
end
function as_timeseries_indexer(::IndexerBoth, mpg::MultipleParametersGetter)
    return MultipleParametersGetter(as_timeseries_indexer.(mpg.getters))
end
function as_not_timeseries_indexer(::IndexerBoth, mpg::MultipleParametersGetter)
    return MultipleParametersGetter(as_not_timeseries_indexer.(mpg.getters))
end
function as_not_timeseries_indexer(::IndexerMixedTimeseries, mpg::MultipleParametersGetter)
    return mpg
end

function (mpg::MixedTimeseriesMPG)(::Timeseries, prob, args...)
    throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(mpg)))
end
function (mpg::MixedTimeseriesMPG)(::AbstractArray, ::Timeseries, prob, args...)
    throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(mpg)))
end

for (indexerTimeseriesType, timeseriesType) in [
        (IndexerNotTimeseries, IsTimeseriesTrait),
        (IndexerBoth, NotTimeseries),
        (IndexerMixedTimeseries, NotTimeseries),
    ]
    @eval function (mpg::MultipleParametersGetter{$indexerTimeseriesType})(
            ::$timeseriesType, prob
        )
        return _call.(mpg.getters, (prob,))
    end
    @eval function (mpg::MultipleParametersGetter{$indexerTimeseriesType})(
            buffer::AbstractArray, ::$timeseriesType, prob
        )
        for (buf_idx, getter) in zip(eachindex(buffer), mpg.getters)
            buffer[buf_idx] = getter(prob)
        end
        return buffer
    end
end

function (mpg::NonTimeseriesMPG)(::IsTimeseriesTrait, prob, arg)
    return _call.(mpg.getters, (prob,), (arg,))
end
function (mpg::NonTimeseriesMPG)(buffer::AbstractArray, ::IsTimeseriesTrait, prob, arg)
    for (buf_idx, getter) in zip(eachindex(buffer), mpg.getters)
        buffer[buf_idx] = getter(prob)
    end
    return buffer
end

function (mpg::AtLeastTimeseriesMPG)(ts::Timeseries, prob)
    return map(eachindex(parameter_timeseries(prob, indexer_timeseries_index(mpg)))) do i
        mpg(ts, prob, i)
    end
end
function (mpg::AtLeastTimeseriesMPG)(::Timeseries, prob, i::Union{Int, CartesianIndex})
    return CallWith(prob, i).(mpg.getters)
end
function (mpg::AtLeastTimeseriesMPG)(ts::Timeseries, prob, ::Colon)
    return mpg(ts, prob)
end
function (mpg::AtLeastTimeseriesMPG)(ts::Timeseries, prob, i::AbstractArray{Bool})
    return map(
        only(
            to_indices(
                parameter_timeseries(prob, indexer_timeseries_index(mpg)), (i,)
            )
        )
    ) do idx
        mpg(ts, prob, idx)
    end
end
function (mpg::AtLeastTimeseriesMPG)(ts::Timeseries, prob, i)
    return mpg.((ts,), (prob,), i)
end
function (mpg::AtLeastTimeseriesMPG)(buffer::AbstractArray, ts::Timeseries, prob)
    for (buf_idx, ts_idx) in zip(
            eachindex(buffer),
            eachindex(parameter_timeseries(prob, indexer_timeseries_index(mpg)))
        )
        mpg(buffer[buf_idx], ts, prob, ts_idx)
    end
    return buffer
end
function (mpg::AtLeastTimeseriesMPG)(
        buffer::AbstractArray, ::Timeseries, prob, i::Union{Int, CartesianIndex}
    )
    for (buf_idx, getter) in zip(eachindex(buffer), mpg.getters)
        buffer[buf_idx] = getter(prob, i)
    end
    return buffer
end
function (mpg::AtLeastTimeseriesMPG)(buffer::AbstractArray, ts::Timeseries, prob, ::Colon)
    return mpg(buffer, ts, prob)
end
function (mpg::AtLeastTimeseriesMPG)(
        buffer::AbstractArray, ts::Timeseries, prob, i::AbstractArray{Bool}
    )
    return mpg(
        buffer, ts, prob,
        only(to_indices(parameter_timeseries(prob, indexer_timeseries_index(mpg)), (i,)))
    )
end
function (mpg::AtLeastTimeseriesMPG)(buffer::AbstractArray, ts::Timeseries, prob, i)
    for (buf_idx, ts_idx) in zip(eachindex(buffer), i)
        mpg(buffer[buf_idx], ts, prob, ts_idx)
    end
    return buffer
end
function (mpg::OnlyTimeseriesMPG)(::NotTimeseries, prob)
    throw(ParameterTimeseriesValueIndexMismatchError{NotTimeseries}(prob, mpg))
end
function (mpg::OnlyTimeseriesMPG)(
        ::AbstractArray, ::NotTimeseries, prob
    )
    throw(ParameterTimeseriesValueIndexMismatchError{NotTimeseries}(prob, mpg))
end

struct AsParameterTupleWrapper{N, A, G <: AbstractParameterGetIndexer} <:
    AbstractParameterGetIndexer
    getter::G
end

function AsParameterTupleWrapper{N}(getter::G) where {N, G}
    return AsParameterTupleWrapper{N, Nothing, G}(getter)
end
function AsParameterTupleWrapper{N, A}(getter::G) where {N, A, G}
    return AsParameterTupleWrapper{N, A, G}(getter)
end

function is_indexer_timeseries(::Type{AsParameterTupleWrapper{N, A, G}}) where {N, A, G}
    return is_indexer_timeseries(G)
end
function indexer_timeseries_index(atw::AsParameterTupleWrapper)
    return indexer_timeseries_index(atw.getter)
end
function as_timeseries_indexer(
        ::IndexerBoth, atw::AsParameterTupleWrapper{N, A}
    ) where {N, A}
    return AsParameterTupleWrapper{N, A}(as_timeseries_indexer(atw.getter))
end
function as_not_timeseries_indexer(
        ::IndexerBoth, atw::AsParameterTupleWrapper{N, A}
    ) where {N, A}
    return AsParameterTupleWrapper{N, A}(as_not_timeseries_indexer(atw.getter))
end

function wrap_tuple(::AsParameterTupleWrapper{N, Nothing}, val) where {N}
    return ntuple(i -> val[i], Val(N))
end
function wrap_tuple(::AsParameterTupleWrapper{N, A}, val) where {N, A}
    return NamedTuple{A}(ntuple(i -> val[i], Val(N)))
end

function (atw::AsParameterTupleWrapper)(ts::IsTimeseriesTrait, prob, args...)
    return atw(ts, is_indexer_timeseries(atw), prob, args...)
end
function (atw::AsParameterTupleWrapper)(
        ts::IsTimeseriesTrait, ::IndexerMixedTimeseries, prob, args...
    )
    return wrap_tuple(atw, atw.getter(ts, prob, args...))
end
function (atw::AsParameterTupleWrapper)(ts::Timeseries, ::AtLeastTimeseriesIndexer, prob)
    return wrap_tuple.((atw,), atw.getter(ts, prob))
end
function (atw::AsParameterTupleWrapper)(
        ts::Timeseries, ::AtLeastTimeseriesIndexer, prob, i::Union{Int, CartesianIndex}
    )
    return wrap_tuple(atw, atw.getter(ts, prob, i))
end
function (atw::AsParameterTupleWrapper)(ts::Timeseries, ::AtLeastTimeseriesIndexer, prob, i)
    return wrap_tuple.((atw,), atw.getter(ts, prob, i))
end
function (atw::AsParameterTupleWrapper)(
        ts::Timeseries, ::IndexerNotTimeseries, prob, args...
    )
    return wrap_tuple(atw, atw.getter(ts, prob, args...))
end
function (atw::AsParameterTupleWrapper)(
        ts::NotTimeseries, ::AtLeastNotTimeseriesIndexer, prob, args...
    )
    return wrap_tuple(atw, atw.getter(ts, prob, args...))
end
function (atw::AsParameterTupleWrapper)(
        buffer::AbstractArray, ts::IsTimeseriesTrait, prob, args...
    )
    return atw.getter(buffer, ts, prob, args...)
end

is_observed_getter(_) = false
is_observed_getter(::GetParameterObserved) = true
is_observed_getter(::GetParameterObservedNoTime) = true
is_observed_getter(mpg::MultipleParametersGetter) = any(is_observed_getter, mpg.getters)

for (t1, t2) in [
        (ArraySymbolic, Any),
        (ScalarSymbolic, Any),
        (NotSymbolic, Union{<:Tuple, <:NamedTuple, <:AbstractArray}),
    ]
    @eval function _getp(sys, ::NotSymbolic, ::$t1, p::$t2)
        # We need to do it this way because if an `ODESystem` has `p[1], p[2], p[3]` as
        # parameters (all scalarized) then `is_observed(sys, p[2:3]) == true`. Then,
        # `getp` errors on older MTK that doesn't support `parameter_observed`.
        _p = p isa NamedTuple ? Tuple(p) : p
        getters = getp.((sys,), _p)
        num_observed = count(is_observed_getter, getters)
        supports_tuple = supports_tuple_observed(sys)
        p_arr = p isa Union{Tuple, NamedTuple} ? collect(p) : p

        if num_observed == 0
            getter = MultipleParametersGetter(getters)
            if p isa NamedTuple
                getter = AsParameterTupleWrapper{length(p), keys(p)}(getter)
            end
            return getter
        else
            pofn = supports_tuple ? parameter_observed(sys, _p) :
                parameter_observed(sys, p_arr)
            if pofn === nothing
                return MultipleParametersGetter.(getters)
            end
            if is_time_dependent(sys)
                ts_idxs = _postprocess_tsidxs(get_all_timeseries_indexes(sys, p_arr))
                update_fn = Fix1Multiple(parameter_values_at_time, sys)
                getter = GetParameterObserved{true}(ts_idxs, update_fn, pofn)
            else
                getter = GetParameterObservedNoTime(pofn)
            end
            if p isa Tuple && !supports_tuple
                getter = AsParameterTupleWrapper{length(p)}(getter)
            elseif p isa NamedTuple
                getter = AsParameterTupleWrapper{length(p), keys(p)}(getter)
            end
            return getter
        end
    end
end

function _getp(sys, ::ArraySymbolic, ::SymbolicTypeTrait, p)
    if is_parameter(sys, p)
        idx = parameter_index(sys, p)
        if is_timeseries_parameter(sys, p)
            ts_idx = timeseries_parameter_index(sys, p)
            return GetParameterTimeseriesIndex(
                GetParameterIndex(idx), GetParameterIndex(ts_idx)
            )
        else
            return GetParameterIndex(idx)
        end
    end
    return getp(sys, collect(p))
end

struct ParameterHookWrapper{S, O} <: AbstractSetIndexer
    setter::S
    original_index::O
end

function (phw::ParameterHookWrapper)(prob, args...)
    res = phw.setter(prob, args...)
    finalize_parameters_hook!(prob, phw.original_index)
    return res
end

"""
    setp(indp, sym)

Return a function that takes a value provider and a value, and sets the parameter `sym`
to that value. Note that `sym` can be an index, a symbolic variable, or an array/tuple of
the aforementioned.

Requires that the value provider implement [`parameter_values`](@ref) and the returned
collection be a mutable reference to the parameter object. In case `parameter_values`
cannot return such a mutable reference, or additional actions need to be performed when
updating parameters, [`set_parameter!`](@ref) must be implemented.
"""
function setp(sys, p; run_hook = true)
    symtype = symbolic_type(p)
    elsymtype = symbolic_type(eltype(p))
    return if run_hook
        return ParameterHookWrapper(_setp(sys, symtype, elsymtype, p), p)
    else
        _setp(sys, symtype, elsymtype, p)
    end
end

struct SetParameterIndex{I} <: AbstractSetIndexer
    idx::I
end

function (spi::SetParameterIndex)(prob, val)
    return set_parameter!(prob, val, spi.idx)
end

function _setp(sys, ::NotSymbolic, ::NotSymbolic, p)
    return SetParameterIndex(p)
end

function _setp(sys, ::ScalarSymbolic, ::SymbolicTypeTrait, p)
    idx = parameter_index(sys, p)
    return SetParameterIndex(idx)
end

struct MultipleSetters{S} <: AbstractSetIndexer
    setters::S
end

function (ms::MultipleSetters)(prob, val)
    for (s!, v) in zip(ms.setters, val)
        s!(prob, v)
    end
    return
end

for (t1, t2) in [
        (ArraySymbolic, Any),
        (ScalarSymbolic, Any),
        (NotSymbolic, Union{<:Tuple, <:NamedTuple, <:AbstractArray}),
    ]
    @eval function _setp(sys, ::NotSymbolic, ::$t1, p::$t2)
        if p isa NamedTuple
            setters = NamedTuple{keys(p)}(setp.((sys,), values(p); run_hook = false))
            return NamedTupleSetter(setters)
        end
        setters = setp.((sys,), p; run_hook = false)
        return MultipleSetters(setters)
    end
end

function _setp(sys, ::ArraySymbolic, ::SymbolicTypeTrait, p)
    if is_parameter(sys, p)
        idx = parameter_index(sys, p)
        return setp(sys, idx; run_hook = false)
    end
    return setp(sys, collect(p); run_hook = false)
end

"""
    setp_oop(indp, sym)

Return a function which takes a value provider `valp` and a value `val`, and returns
`parameter_values(valp)` with the parameters at `sym` set to `val`. This allows changing
the types of values stored, and leverages [`remake_buffer`](@ref). Note that `sym` can be
an index, a symbolic variable, or an array/tuple of the aforementioned.

Requires that the value provider implement `parameter_values` and `remake_buffer`.
"""
function setp_oop(indp, sym)
    symtype = symbolic_type(sym)
    elsymtype = symbolic_type(eltype(sym))
    return _setp_oop(indp, symtype, elsymtype, sym)
end

function _setp_oop(indp, ::NotSymbolic, ::NotSymbolic, sym)
    return OOPSetter(_root_indp(indp), sym, false)
end

function _setp_oop(indp, ::ScalarSymbolic, ::SymbolicTypeTrait, sym)
    return OOPSetter(_root_indp(indp), parameter_index(indp, sym), false)
end

for (t1, t2) in [
        (ScalarSymbolic, Any),
        (NotSymbolic, Union{<:Tuple, <:AbstractArray}),
    ]
    @eval function _setp_oop(indp, ::NotSymbolic, ::$t1, sym::$t2)
        return OOPSetter(_root_indp(indp), parameter_index.((indp,), sym), false)
    end
end

function _setp_oop(indp, ::ArraySymbolic, ::SymbolicTypeTrait, sym)
    if is_parameter(indp, sym)
        return OOPSetter(_root_indp(indp), parameter_index(indp, sym), false)
    end
    return setp_oop(indp, collect(sym))
end

module SymbolicIndexingInterface

using RuntimeGeneratedFunctions: RuntimeGeneratedFunctions, @RuntimeGeneratedFunction
import StaticArraysCore: MArray, similar_type
import ArrayInterface
using Accessors: @reset

RuntimeGeneratedFunctions.init(@__MODULE__)

export ScalarSymbolic, ArraySymbolic, NotSymbolic, symbolic_type, hasname, getname,
    Timeseries, NotTimeseries, is_timeseries, is_parameter_timeseries
include("trait.jl")

export is_variable, variable_index, variable_symbols, is_parameter, parameter_index,
    is_timeseries_parameter, timeseries_parameter_index, ParameterTimeseriesIndex,
    parameter_symbols, is_independent_variable, independent_variable_symbols,
    is_observed, observed, parameter_observed,
    ContinuousTimeseries, get_all_timeseries_indexes,
    is_time_dependent, is_markovian, constant_structure, symbolic_container,
    all_variable_symbols, all_symbols, solvedvariables, allvariables, default_values,
    symbolic_evaluate
include("index_provider_interface.jl")

export SymbolCache
include("symbol_cache.jl")

export parameter_values, set_parameter!, finalize_parameters_hook!,
    get_parameter_timeseries_collection, with_updated_parameter_timeseries_values,
    state_values, set_state!, current_time, get_history_function
include("value_provider_interface.jl")

export ParameterTimeseriesCollection
include("parameter_timeseries_collection.jl")

export getp, setp, setp_oop
include("parameter_indexing.jl")

export getsym, setsym, getu, setu
include("state_indexing.jl")

export BatchedInterface, setsym_oop, associated_systems
include("batched_interface.jl")

export ProblemState
include("problem_state.jl")

export ParameterIndexingProxy, show_params
include("parameter_indexing_proxy.jl")

export remake_buffer
include("remake.jl")

include("despecialize.jl")

end

using SymbolicIndexingInterface
using SymbolicIndexingInterface: IndexerOnlyTimeseries, IndexerNotTimeseries, IndexerBoth,
    IndexerMixedTimeseries,
    is_indexer_timeseries, indexer_timeseries_index,
    ParameterTimeseriesValueIndexMismatchError,
    MixedParameterTimeseriesIndexError, parameter_values_at_time
using Test
# AllocCheck uses LLVM introspection which can break on pre-release Julia versions
@static if isempty(VERSION.prerelease)
    using AllocCheck
end

arr = [1.0, 2.0, 3.0]
@test parameter_values(arr) == arr
@test current_time(arr) == arr
tp = (1.0, 2.0, 3.0)
@test parameter_values(tp) == tp

struct FakeIntegrator{S, P}
    sys::S
    p::P
    t::Float64
    counter::Ref{Int}
end

function Base.getproperty(fi::FakeIntegrator, s::Symbol)
    return s === :ps ? ParameterIndexingProxy(fi) : getfield(fi, s)
end
SymbolicIndexingInterface.symbolic_container(fp::FakeIntegrator) = fp.sys
SymbolicIndexingInterface.parameter_values(fp::FakeIntegrator) = fp.p
SymbolicIndexingInterface.current_time(fp::FakeIntegrator) = fp.t
function SymbolicIndexingInterface.finalize_parameters_hook!(fi::FakeIntegrator, p)
    return fi.counter[] += 1
end

for sys in [
        SymbolCache([:x, :y, :z], [:a, :b, :c, :d], [:t]),
        SymbolCache(
            [:x, :y, :z],
            [:a, :b, :c, :d],
            [:t],
            timeseries_parameters = Dict(
                :b => ParameterTimeseriesIndex(1, 1), :c => ParameterTimeseriesIndex(2, 1)
            )
        ),
    ]
    has_ts = sys.timeseries_parameters !== nothing
    for pType in [Vector, Tuple]
        p = [1.0, 2.0, 3.0, 4.0]
        fi = FakeIntegrator(sys, pType(copy(p)), 9.0, Ref(0))
        new_p = [4.0, 5.0, 6.0, 7.0]
        for (sym, oldval, newval, check_inference) in [
                (:a, p[1], new_p[1], true),
                (1, p[1], new_p[1], true),
                ([:a, :b], p[1:2], new_p[1:2], !has_ts),
                (1:2, p[1:2], new_p[1:2], true),
                ((1, 2), Tuple(p[1:2]), Tuple(new_p[1:2]), true),
                ([:a, [:b, :c]], [p[1], p[2:3]], [new_p[1], new_p[2:3]], false),
                ([:a, (:b, :c)], [p[1], (p[2], p[3])], [new_p[1], (new_p[2], new_p[3])], false),
                ((:a, [:b, :c]), (p[1], p[2:3]), (new_p[1], new_p[2:3]), true),
                ((:a, (:b, :c)), (p[1], (p[2], p[3])), (new_p[1], (new_p[2], new_p[3])), true),
                ([1, [:b, :c]], [p[1], p[2:3]], [new_p[1], new_p[2:3]], false),
                ([1, (:b, :c)], [p[1], (p[2], p[3])], [new_p[1], (new_p[2], new_p[3])], false),
                ((1, [:b, :c]), (p[1], p[2:3]), (new_p[1], new_p[2:3]), true),
                ((1, (:b, :c)), (p[1], (p[2], p[3])), (new_p[1], (new_p[2], new_p[3])), true),
                (
                    (a = :a, b = [:a, :b], c = (d = :c, e = :a)),
                    (a = p[1], b = p[1:2], c = (d = p[3], e = p[1])),
                    (a = new_p[1], b = new_p[1:2], c = (d = new_p[3], e = new_p[1])), true,
                ),
            ]
            get = getp(sys, sym)
            set! = setp(sys, sym)
            if check_inference
                @inferred get(fi)
            end
            @test get(fi) == fi.ps[sym]
            @test get(fi) == oldval

            if pType === Tuple
                @test_throws MethodError set!(fi, newval)
                continue
            end

            @test fi.counter[] == 0
            if check_inference
                @inferred set!(fi, newval)
            else
                set!(fi, newval)
            end
            @test fi.counter[] == 1

            @test get(fi) == newval
            set!(fi, oldval)
            @test get(fi) == oldval
            @test fi.counter[] == 2

            fi.ps[sym] = newval
            @test get(fi) == newval
            @test fi.counter[] == 3
            fi.ps[sym] = oldval
            @test get(fi) == oldval
            @test fi.counter[] == 4

            if check_inference
                @inferred get(p)
            end
            @test get(p) == oldval
            if check_inference
                @inferred set!(p, newval)
            else
                set!(p, newval)
            end
            @static if isempty(VERSION.prerelease)
                if isconcretetype(eltype(newval))
                    # test only with concrete eltypes, otherwise we have
                    # dynamic dispatch due to the vals
                    @check_allocs test_setp(set!, p, newval) = set!(p, newval)
                    test_setp(set!, p, newval)
                end
            end
            @test get(p) == newval
            set!(p, oldval)
            @test get(p) == oldval
            @test fi.counter[] == 4
            fi.counter[] = 0
        end

        for (sym, val, check_inference) in [
                ([:a, :b, :c, :d], p, true),
                ([:c, :a], p[[3, 1]], !has_ts),
                ((:b, :a), Tuple(p[[2, 1]]), true),
                ((1, :c), Tuple(p[[1, 3]]), true),
                (:(a + b + t), p[1] + p[2] + fi.t, true),
                ([:(a + b + t), :c], [p[1] + p[2] + fi.t, p[3]], true),
                ((:(a + b + t), :c), (p[1] + p[2] + fi.t, p[3]), true),
                ((; a = (; b = :(a + b))), (; a = (; b = p[1] + p[2])), true),
            ]
            get = getp(sys, sym)
            if check_inference
                @inferred get(fi)
            end
            @test get(fi) == val
            if sym isa Union{Array, Tuple}
                buffer = zeros(length(sym))
                if check_inference
                    @inferred get(buffer, fi)
                else
                    get(buffer, fi)
                end
                @test buffer == collect(val)
            end
        end

        for (sym, val, check_inference) in [
                (:(a + b), p[1] + p[2], true),
                ([:(a + b), :(a * b)], [p[1] + p[2], p[1] * p[2]], true),
                ((:(a + b), :(a * b)), (p[1] + p[2], p[1] * p[2]), true),
                ([:(a + c), :(a + b)], [p[1] + p[3], p[1] + p[2]], true),
            ]
            get = getp(sys, sym)
            if check_inference
                @inferred get(parameter_values(fi))
            end
            @test get(parameter_values(fi)) == val
            if sym isa Union{Array, Tuple}
                buffer = zeros(length(sym))
                if check_inference
                    @inferred get(buffer, parameter_values(fi))
                else
                    get(buffer, parameter_values(fi))
                end
                @test buffer == collect(val)
            end
        end

        for sym in [
                :(a + t),
                [:(a + t), :(a * b)],
                (:(a + t), :(a * b)),
            ]
            get = getp(sys, sym)
            @test_throws MethodError get(parameter_values(fi))
            if sym isa Union{Array, Tuple}
                @test_throws MethodError get(zeros(length(sym)), parameter_values(fi))
            end
        end

        getter = getp(sys, [])
        @test getter(fi) == []
        getter = getp(sys, ())
        @test getter(fi) == ()

        for (sym, val) in [
                (:a, 1.0f1),
                (1, 1.0f1),
                ([:a, :b], [1.0f1, 2.0f1]),
                ((:b, :c), (2.0f1, 3.0f1)),
            ]
            setter = setp_oop(fi, sym)
            newp = setter(fi, val)
            getter = getp(sys, sym)
            @test getter(newp) == val
            newp = setter(parameter_values(fi), val)
            @test getter(newp) == val
        end
    end
end

let
    sc = SymbolCache(nothing, nothing, :t)
    fi = FakeIntegrator(sc, nothing, 0.0, Ref(0))
    getter = getp(sc, [])
    @test getter(fi) == []
    getter = getp(sc, ())
    @test getter(fi) == ()
end

struct MyDiffEqArray
    t::Vector{Float64}
    u::Vector{Vector{Float64}}
end
SymbolicIndexingInterface.current_time(mda::MyDiffEqArray) = mda.t
SymbolicIndexingInterface.state_values(mda::MyDiffEqArray) = mda.u
SymbolicIndexingInterface.is_timeseries(::Type{MyDiffEqArray}) = Timeseries()

struct MyParameterObject
    p::Vector{Float64}
    disc_idxs::Vector{Vector{Int}}
end

SymbolicIndexingInterface.parameter_values(mpo::MyParameterObject) = mpo.p
function SymbolicIndexingInterface.with_updated_parameter_timeseries_values(
        ::SymbolCache, mpo::MyParameterObject, args::Pair...
    )
    for (ts_idx, val) in args
        mpo.p[mpo.disc_idxs[ts_idx]] = val
    end
    return mpo
end

Base.getindex(mpo::MyParameterObject, i) = mpo.p[i]

struct FakeSolution
    sys::SymbolCache
    u::Vector{Vector{Float64}}
    t::Vector{Float64}
    p::MyParameterObject
    p_ts::ParameterTimeseriesCollection{Vector{MyDiffEqArray}, MyParameterObject}
end

function Base.getproperty(fs::FakeSolution, s::Symbol)
    return s === :ps ? ParameterIndexingProxy(fs) : getfield(fs, s)
end
SymbolicIndexingInterface.state_values(fs::FakeSolution) = fs.u
SymbolicIndexingInterface.current_time(fs::FakeSolution) = fs.t
SymbolicIndexingInterface.symbolic_container(fs::FakeSolution) = fs.sys
SymbolicIndexingInterface.parameter_values(fs::FakeSolution) = fs.p
SymbolicIndexingInterface.parameter_values(fs::FakeSolution, i) = fs.p[i]
SymbolicIndexingInterface.get_parameter_timeseries_collection(fs::FakeSolution) = fs.p_ts
SymbolicIndexingInterface.is_timeseries(::Type{FakeSolution}) = Timeseries()
SymbolicIndexingInterface.is_parameter_timeseries(::Type{FakeSolution}) = Timeseries()
sys = SymbolCache(
    [:x, :y, :z],
    [:a, :b, :c, :d],
    :t;
    timeseries_parameters = Dict(
        :b => ParameterTimeseriesIndex(1, 1), :c => ParameterTimeseriesIndex(2, 1)
    )
)
b_timeseries = MyDiffEqArray(collect(0:0.1:0.9), [[2.5i] for i in 1:10])
c_timeseries = MyDiffEqArray(collect(0:0.25:0.9), [[3.5i] for i in 1:4])
p = MyParameterObject(
    [20.0, b_timeseries.u[end][1], c_timeseries.u[end][1], 30.0], [[2], [3]]
)
fs = FakeSolution(
    sys,
    [i * ones(3) for i in 1:5],
    [0.2i for i in 1:5],
    p,
    ParameterTimeseriesCollection([b_timeseries, c_timeseries], deepcopy(p))
)
aval = fs.p[1]
bval = getindex.(b_timeseries.u)
cval = getindex.(c_timeseries.u)
dval = fs.p[4]
bidx = timeseries_parameter_index(sys, :b)
cidx = timeseries_parameter_index(sys, :c)

# IndexerNotTimeseries
for (sym, val, buffer, check_inference) in [
        (:a, aval, nothing, true),
        (1, aval, nothing, true),
        ([:a, :d], [aval, dval], zeros(2), true),
        ((:a, :d), (aval, dval), zeros(2), true),
        ([1, 4], [aval, dval], zeros(2), true),
        ((1, 4), (aval, dval), zeros(2), true),
        ([:a, 4], [aval, dval], zeros(2), true),
        ((:a, 4), (aval, dval), zeros(2), true),
        (:(a + d), aval + dval, nothing, true),
        ([:(a + d), :(a * d)], [aval + dval, aval * dval], zeros(2), true),
        ((:(a + d), :(a * d)), (aval + dval, aval * dval), zeros(2), true),
    ]
    getter = getp(fs, sym)
    @test is_indexer_timeseries(getter) isa IndexerNotTimeseries
    test_inplace = buffer !== nothing
    is_observed = sym isa Expr ||
        sym isa Union{AbstractArray, Tuple} && any(x -> x isa Expr, sym)
    if check_inference
        @inferred getter(fs)
        if !is_observed
            @inferred getter(parameter_values(fs))
        end
        if test_inplace
            @inferred getter(deepcopy(buffer), fs)
            if !is_observed
                @inferred getter(deepcopy(buffer), parameter_values(fs))
            end
        end
    end
    @test getter(fs) == val
    if !is_observed
        @test getter(parameter_values(fs)) == val
    end
    if test_inplace
        target = collect(val)
        valps = is_observed ? (fs,) : (fs, parameter_values(fs))
        for valp in valps
            tmp = deepcopy(buffer)
            getter(tmp, valp)
            @test tmp == target
        end
    end
    for subidx in [1, CartesianIndex(1), :, rand(Bool, 4), rand(1:4, 3), 1:2]
        @test getter(fs, subidx) == val
        if test_inplace
            tmp = deepcopy(buffer)
            getter(tmp, fs, subidx)
            @test tmp == collect(val)
        end
    end
end

# IndexerBoth
for (sym, timeseries_index, val, buffer, check_inference) in [
        (:b, 1, bval, zeros(length(bval)), true),
        ([:a, :b], 1, vcat.(aval, bval), map(_ -> zeros(2), bval), false),
        ((:a, :b), 1, tuple.(aval, bval), map(_ -> zeros(2), bval), true),
        ([1, :b], 1, vcat.(aval, bval), map(_ -> zeros(2), bval), false),
        ((1, :b), 1, tuple.(aval, bval), map(_ -> zeros(2), bval), true),
        ([:b, :b], 1, vcat.(bval, bval), map(_ -> zeros(2), bval), true),
        ((:b, :b), 1, tuple.(bval, bval), map(_ -> zeros(2), bval), true),
        (:(a + b), 1, bval .+ aval, zeros(length(bval)), true),
        ([:(a + b), :a], 1, vcat.(bval .+ aval, aval), map(_ -> zeros(2), bval), true),
        ((:(a + b), :a), 1, tuple.(bval .+ aval, aval), map(_ -> zeros(2), bval), true),
        ([:(a + b), :b], 1, vcat.(bval .+ aval, bval), map(_ -> zeros(2), bval), true),
        ((:(a + b), :b), 1, tuple.(bval .+ aval, bval), map(_ -> zeros(2), bval), true),
    ]
    getter = getp(sys, sym)
    @test is_indexer_timeseries(getter) isa IndexerBoth
    @test indexer_timeseries_index(getter) == timeseries_index
    isobs = sym isa Union{AbstractArray, Tuple} ? any(Base.Fix1(is_observed, sys), sym) :
        is_observed(sys, sym)

    if check_inference
        @inferred getter(fs)
        @inferred getter(deepcopy(buffer), fs)
        if !isobs
            @inferred getter(parameter_values(fs))
            if !(eltype(val) <: Number)
                @inferred getter(deepcopy(buffer[1]), parameter_values(fs))
            end
        end
    end

    @test getter(fs) == val
    if eltype(val) <: Number
        target = val
    else
        target = collect.(val)
    end
    tmp = deepcopy(buffer)
    getter(tmp, fs)
    @test tmp == target

    if !isobs
        @test getter(parameter_values(fs)) == val[end]
        if !(eltype(val) <: Number)
            target = collect(val[end])
            tmp = deepcopy(buffer)[end]
            getter(tmp, parameter_values(fs))
            @test tmp == target
        end
    end
    for subidx in [
            1, CartesianIndex(1), :, rand(Bool, length(val)), rand(eachindex(val), 3), 1:2,
        ]
        if check_inference
            @inferred getter(fs, subidx)
            if !isa(val[subidx], Number)
                @inferred getter(deepcopy(buffer[subidx]), fs, subidx)
            end
        end
        @test getter(fs, subidx) == val[subidx]
        tmp = deepcopy(buffer[subidx])
        if val[subidx] isa Number
            continue
        end
        target = val[subidx]
        if eltype(target) <: Number
            target = collect(target)
        else
            target = collect.(target)
        end
        getter(tmp, fs, subidx)
        @test tmp == target
    end
end

# IndexerOnlyTimeseries
for (sym, timeseries_index, val, buffer, check_inference) in [
        (bidx, 1, bval, zeros(length(bval)), true),
        ([bidx, :b], 1, vcat.(bval, bval), map(_ -> zeros(2), bval), true),
        ((bidx, :b), 1, tuple.(bval, bval), map(_ -> zeros(2), bval), true),
        ([bidx, bidx], 1, vcat.(bval, bval), map(_ -> zeros(2), bval), true),
        ((bidx, bidx), 1, tuple.(bval, bval), map(_ -> zeros(2), bval), true),
    ]
    getter = getp(sys, sym)
    @test is_indexer_timeseries(getter) isa IndexerOnlyTimeseries
    @test indexer_timeseries_index(getter) == timeseries_index

    isscalar = eltype(val) <: Number

    if check_inference
        @inferred getter(fs)
        @inferred getter(deepcopy(buffer), fs)
    end

    @test getter(fs) == val
    target = if isscalar
        val
    else
        collect.(val)
    end
    tmp = deepcopy(buffer)
    getter(tmp, fs)
    @test tmp == target

    @test_throws ParameterTimeseriesValueIndexMismatchError{NotTimeseries} getter(parameter_values(fs))
    @test_throws ParameterTimeseriesValueIndexMismatchError{NotTimeseries} getter(
        [], parameter_values(fs)
    )

    for subidx in [
            1, CartesianIndex(1), :, rand(Bool, length(val)), rand(eachindex(val), 3), 1:2,
        ]
        if check_inference
            @inferred getter(fs, subidx)
            if !isa(val[subidx], Number)
                @inferred getter(deepcopy(buffer[subidx]), fs, subidx)
            end
        end
        @test getter(fs, subidx) == val[subidx]
        if val[subidx] isa Number
            continue
        end
        tmp = deepcopy(buffer[subidx])
        target = val[subidx]
        if eltype(target) <: Number
            target = collect(target)
        else
            target = collect.(target)
        end
        getter(tmp, fs, subidx)
        @test tmp == target
    end
end

# IndexerMixedTimeseries
for sym in [
        [:a, :b, :c],
        (:a, :b, :c),
        :(b + c),
        [:(a + b), :c],
        (:(a + b), :c),
    ]
    getter = getp(sys, sym)
    @test_throws MixedParameterTimeseriesIndexError getter(fs)
    @test_throws MixedParameterTimeseriesIndexError getter([], fs)
    for subidx in [1, CartesianIndex(1), :, rand(Bool, 4), rand(1:4, 3), 1:2]
        @test_throws MixedParameterTimeseriesIndexError getter(fs, subidx)
        @test_throws MixedParameterTimeseriesIndexError getter([], fs, subidx)
    end
end

for sym in [[:a, bidx], (:a, bidx), [1, bidx], (1, bidx)]
    @test_throws ArgumentError getp(sys, sym)
end

for (sym, val) in [
        ([:b, :c], [bval[end], cval[end]])
        ((:b, :c), (bval[end], cval[end]))
    ]
    getter = getp(sys, sym)
    @test is_indexer_timeseries(getter) == IndexerMixedTimeseries()
    @test_throws MixedParameterTimeseriesIndexError getter(fs)
    @test getter(parameter_values(fs)) == val
end

xval = getindex.(fs.u, 1)

for (sym, val_is_timeseries, val, check_inference) in [
        (:a, false, aval, true),
        ([:a, :d], false, [aval, dval], true),
        ((:a, :d), false, (aval, dval), true),
        (:b, true, bval, true),
        ([:a, :b], true, vcat.(aval, bval), false),
        ((:a, :b), true, tuple.(aval, bval), true),
        ([:a, :x], true, vcat.(aval, xval), false),
        ((:a, :x), true, tuple.(aval, xval), true),
        (:(2b), true, 2 .* bval, true),
        ([:a, :(2b)], true, vcat.(aval, 2 .* bval), true),
        ((:a, :(2b)), true, tuple.(aval, 2 .* bval), true),
    ]
    getter = getsym(sys, sym)
    if check_inference
        @inferred getter(fs)
    end
    @test getter(fs) == val

    reference = val_is_timeseries ? val : xval
    for subidx in [
            1, CartesianIndex(2), :, rand(Bool, length(reference)),
            rand(eachindex(reference), 3), 1:2,
        ]
        if check_inference
            @inferred getter(fs, subidx)
        end
        target = if val_is_timeseries
            val[subidx]
        else
            val
        end
        @test getter(fs, subidx) == target
    end
end

temp_state = ProblemState(;
    u = fs.u[1],
    p = with_updated_parameter_timeseries_values(
        sys, parameter_values(fs), 1 => fs.p_ts[1, 1], 2 => fs.p_ts[2, 1]
    ),
    t = fs.t[1]
)
_xval = temp_state.u[1]
_bval = bval[1]
_cval = cval[1]

# These getters go through `MultipleGetters`, which always throws when mixing
# timeseries indexes (state variables and parameter timeseries are always
# considered separate indexes), regardless of whether one of them is the
# continuous timeseries.
for (sym, val, check_inference) in [
        ([:x, :b], [_xval, _bval], false),
        ((:x, :c), (_xval, _cval), true),
    ]
    getter = getsym(sys, sym)
    @test_throws MixedParameterTimeseriesIndexError getter(fs)
    for subidx in [1, CartesianIndex(2), :, rand(Bool, 4), rand(1:4, 3), 1:2]
        @test_throws MixedParameterTimeseriesIndexError getter(fs, subidx)
    end
    if check_inference
        @inferred getter(temp_state)
    end
    @test getter(temp_state) == val
end

# These getters go through `TimeDependentObservedFunction`, whose combined
# timeseries indexes include `ContinuousTimeseries()` (since they involve `x`,
# a continuous state variable). Indexing with such a getter on the full
# timeseries object is now allowed, and evaluates the observed function at
# the interpolated/held parameter timeseries values corresponding to each
# point in the continuous timeseries.
bval_at_t = [parameter_values_at_time(sys, fs, t)[2] for t in fs.t]
for (sym, val, tsval, check_inference) in [
        (:(x + b), _xval + _bval, xval .+ bval_at_t, true),
        ([:(2b), :(3x)], [2_bval, 3_xval], vcat.(2 .* bval_at_t, 3 .* xval), true),
        ((:(2b), :(3x)), (2_bval, 3_xval), tuple.(2 .* bval_at_t, 3 .* xval), true),
    ]
    getter = getsym(sys, sym)
    if !(sym isa Tuple)
        # `AsTupleWrapper` (used to wrap tuple-valued observed functions) does
        # not itself implement `is_indexer_timeseries`.
        @test is_indexer_timeseries(getter) == IndexerMixedTimeseries()
    end
    if check_inference
        @inferred getter(fs)
    end
    @test getter(fs) == tsval
    for subidx in [1, CartesianIndex(2), :, rand(Bool, length(tsval)), rand(eachindex(tsval), 3), 1:2]
        if check_inference
            @inferred getter(fs, subidx)
        end
        target = subidx isa Colon ? tsval : tsval[subidx]
        @test getter(fs, subidx) == target
    end

    if check_inference
        @inferred getter(temp_state)
    end
    @test getter(temp_state) == val
end

for sym in [
        :err,
        [:err, :b],
        (:err, :b),
    ]
    @test_throws ErrorException getp(sys, sym)
end

let fs = fs, sys = sys
    getter = getp(sys, [])
    @test getter(fs) == []
    getter = getp(sys, ())
    @test getter(fs) == ()
end

struct FakeNoTimeSolution
    sys::SymbolCache
    u::Vector{Float64}
    p::Vector{Float64}
end

SymbolicIndexingInterface.state_values(fs::FakeNoTimeSolution) = fs.u
SymbolicIndexingInterface.symbolic_container(fs::FakeNoTimeSolution) = fs.sys
SymbolicIndexingInterface.parameter_values(fs::FakeNoTimeSolution) = fs.p
SymbolicIndexingInterface.parameter_values(fs::FakeNoTimeSolution, i) = fs.p[i]

sys = SymbolCache([:x, :y, :z], [:a, :b, :c])
u = [1.0, 2.0, 3.0]
p = [10.0, 20.0, 30.0]
fs = FakeNoTimeSolution(sys, u, p)

for (sym, val, check_inference) in [
        (:a, p[1], true),
        ([:a, :b], p[1:2], true),
        ((:c, :b), (p[3], p[2]), true),
        (:(a + b), p[1] + p[2], true),
        ([:(a + b), :c], [p[1] + p[2], p[3]], true),
        ((:(a + b), :c), (p[1] + p[2], p[3]), true),
    ]
    getter = getp(sys, sym)
    if check_inference
        @inferred getter(fs)
    end
    @test getter(fs) == val

    if sym isa Union{Array, Tuple}
        buffer = zeros(length(sym))
        @inferred getter(buffer, fs)
        @test buffer == collect(val)
    end
end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "Home" => "index.md",
    "Terminology" => "terminology.md",
    "Tutorials" => [
        "Using the SciML Symbolic Indexing Interface" => "usage.md",
        "Simple Demonstration of a Symbolic System Structure" => "simple_sii_sys.md",
        "Implementing the Complete Symbolic Indexing Interface" => "complete_sii.md",
    ],
    "Defining Solution Wrapper Fallbacks" => "solution_wrappers.md",
    "API" => "api.md",
]

using Symbolics
using SymbolicIndexingInterface

@variables x[1:2] y z

syss = [
    SymbolCache([x..., y]),
    SymbolCache([x[1], y, z]),
]
syms = [
    [x, y],
    [x[1], y],
]
probs = [
    ProblemState(; u = [1.0, 2.0, 3.0]),
    ProblemState(; u = [4.0, 5.0, 6.0]),
]

bi = BatchedInterface(zip(syss, syms)...)

@test all(isequal.(variable_symbols(bi), [x..., y]))
@test variable_index.((bi,), [x..., y, z]) == [1, 2, 3, nothing]
@test is_variable.((bi,), [x..., y, z]) == Bool[1, 1, 1, 0]
@test associated_systems(bi) == [1, 1, 1]

getter = getsym(bi)
@test (@inferred getter(probs...)) == [1.0, 2.0, 3.0]
buf = zeros(3)
@inferred getter(buf, probs...)
@test buf == [1.0, 2.0, 3.0]

setter! = setsym(bi)
buf .*= 10
setter!(probs..., buf)

@test state_values(probs[1]) == [10.0, 20.0, 30.0]
@test state_values(probs[2]) == [10.0, 30.0, 6.0]

buf ./= 10

setter!(probs[1], 1, buf)
@test state_values(probs[1]) == [1.0, 2.0, 3.0]

@variables a b[1:2] c

syss = [
    SymbolCache([x..., y], [a, b...]),
    SymbolCache([x[1], y, z], [a, b..., c]),
]
syms = [
    [x, y, a, b...],
    [x[1], y, b[2], c],
]
probs = [
    ProblemState(; u = [1.0, 2.0, 3.0], p = [0.1, 0.2, 0.3]),
    ProblemState(; u = [4.0, 5.0, 6.0], p = [0.1, 0.4, 0.5, 0.6]),
]

bi = BatchedInterface(zip(syss, syms)...)

buf = getsym(bi)(probs...)
buf .*= 100
setter = setsym_oop(bi)
vals = setter(probs..., buf)
@test length(vals) == length(probs)
@test vals[1][1] == [100.0, 200.0, 300.0]
@test vals[1][2] == [10.0, 20.0, 30.0]
@test vals[2][1] == [100.0, 300.0, 6.0]
@test vals[2][2] == [0.1, 0.4, 30.0, 60.0]

buf ./= 10
vals = setter(probs[1], 1, buf)
@test length(vals) == 2
@test vals[1] == [10.0, 20.0, 30.0]
@test vals[2] == [1.0, 2.0, 3.0]

"""
    symbolic_container(indp)

Using `indp`, return an object that implements the index provider interface. In case `indp`
itself implements the interface, `indp` can be returned as-is. All index provider interface
methods fall back to calling the same method on `symbolic_container(indp)`, so this may be
used for trivial implementations of the interface that forward all calls to another object.

Note that this method is optional. Thus the correct method to check for a fallback is:
```julia
hasmethod(symbolic_container, Tuple{typeof(indp)}) && symbolic_container(indp) != indp
```
"""
function symbolic_container end

"""
    is_variable(indp, sym)

Check whether the given `sym` is a variable in `indp`.
"""
is_variable(indp, sym) = is_variable(symbolic_container(indp), sym)

"""
    variable_index(indp, sym, [i])

Return the index of the given variable `sym` in `indp`, or `nothing` otherwise. If
[`constant_structure`](@ref) is `false`, this accepts the current time index as an
additional parameter `i`.
"""
variable_index(indp, sym) = variable_index(symbolic_container(indp), sym)
variable_index(indp, sym, i) = variable_index(symbolic_container(indp), sym, i)

"""
    variable_symbols(indp, [i])

Return a vector of the symbolic variables being solved for in the index provider `indp`.
If `constant_structure(sys) == false` this accepts an additional parameter indicating
the current time index. The returned vector should not be mutated.

For types that implement `Base.getindex` with symbolic indices using this interface,
the shorthand `valp[solvedvariables]` can be used as shorthand for
`valp[variable_symbols(sys)]`. See: [`solvedvariables`](@ref).
"""
variable_symbols(indp) = variable_symbols(symbolic_container(indp))
variable_symbols(indp, i) = variable_symbols(symbolic_container(indp), i)

"""
    is_parameter(indp, sym)

Check whether the given `sym` is a parameter in `indp`.
"""
is_parameter(indp, sym) = is_parameter(symbolic_container(indp), sym)

"""
    parameter_index(indp, sym)

Return the index of the given parameter `sym` in `indp`, or `nothing` otherwise.
"""
parameter_index(indp, sym) = parameter_index(symbolic_container(indp), sym)

"""
    is_timeseries_parameter(indp, sym)

Check whether the given `sym` is a timeseries parameter in `indp`.
"""
function is_timeseries_parameter(indp, sym)
    if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        is_timeseries_parameter(sc, sym)
    else
        return false
    end
end

"""
    struct ParameterTimeseriesIndex
    function ParameterTimeseriesIndex(timeseries_idx, parameter_idx)

A struct storing the index of the timeseries of a timeseries parameter in a parameter
timeseries object. `timeseries_idx` refers to an index that identifies the timeseries
that the parameter belongs to. `parameter_idx` refers to the index of the parameter's
timeseries in that timeseries object. Note that `parameter_idx` may be different from
the object returned by [`parameter_index`](@ref) for a given parameter. The two fields in
this struct are `timeseries_idx` and `parameter_idx`.
"""
struct ParameterTimeseriesIndex{T, I}
    timeseries_idx::T
    parameter_idx::I
end

"""
    timeseries_parameter_index(indp, sym)

Return the index of timeseries parameter `sym` in `indp`. Must return this index as a
[`ParameterTimeseriesIndex`](@ref) object. Return `nothing` if `sym` is not a timeseries
parameter in `indp`. Defaults to returning `nothing`. Respects the
[`symbolic_container`](@ref) fallback for `indp` if present.
"""
function timeseries_parameter_index(indp, sym)
    if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        timeseries_parameter_index(symbolic_container(indp), sym)
    else
        return nothing
    end
end

"""
    parameter_observed(indp, sym)

Return the observed function of `sym` in `indp`. This functions similarly to
[`observed`](@ref) except that `u` is not an argument of the returned function. For time-
dependent systems, the returned function must have the signature `(p, t) -> [values...]`.
For time-independent systems, the returned function must have the signature
`(p) -> [values...]`.

By default, this function returns `nothing`, indicating that the index provider does not
support generating parameter observed functions.
"""
function parameter_observed(indp, sym)
    if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        return parameter_observed(symbolic_container(indp), sym)
    else
        return nothing
    end
end

"""
    struct ContinuousTimeseries end

A singleton struct corresponding to the timeseries index of the continuous timeseries.
"""
struct ContinuousTimeseries end

"""
    get_all_timeseries_indexes(indp, sym)

Return a `Set` of all unique timeseries indexes of variables in symbolic variable
`sym`. `sym` may be a symbolic variable or expression, an array of symbolics, an index,
or an array of indices. Continuous variables correspond to the
[`ContinuousTimeseries`](@ref) timeseries index. Non-timeseries parameters do not have a
timeseries index. Timeseries parameters have the same timeseries index as that returned by
[`timeseries_parameter_index`](@ref). Note that the independent variable corresponds to
the `ContinuousTimeseries` timeseries index.

Any ambiguities should be resolved in favor of variables. For example, if `1` could refer
to the variable at index `1` or parameter at index `1`, it should be interpreted as the
variable.

By default, this function returns `Set([ContinuousTimeseries()])`.
"""
function get_all_timeseries_indexes(indp, sym)
    if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        return get_all_timeseries_indexes(symbolic_container(indp), sym)
    else
        return Set([ContinuousTimeseries()])
    end
end

"""
    parameter_symbols(indp)

Return a vector of the symbolic parameters of the given index provider `indp`. The returned
vector should not be mutated.
"""
parameter_symbols(indp) = parameter_symbols(symbolic_container(indp))

"""
    is_independent_variable(indp, sym)

Check whether the given `sym` is an independent variable in `indp`. The returned vector
should not be mutated.
"""
is_independent_variable(indp, sym) = is_independent_variable(symbolic_container(indp), sym)

"""
    independent_variable_symbols(indp)

Return a vector of the symbolic independent variables of the given index provider `indp`.
"""
independent_variable_symbols(indp) = independent_variable_symbols(symbolic_container(indp))

"""
    is_observed(indp, sym)

Check whether the given `sym` is an observed value in `indp`.
"""
is_observed(indp, sym) = is_observed(symbolic_container(indp), sym)

"""
    observed(indp, sym, [states])

Return the observed function of the given `sym` in `indp`. The returned function should
have the signature `(u, p) -> [values...]` where `u` and `p` is the current state and
parameter object, respectively. If `istimedependent(indp) == true`, the function should
accept the current time `t` as its third parameter. If `constant_structure(indp) == false`,
`observed` accepts a third parameter, which can either be a vector of symbols indicating
the order of states or a time index, which identifies the order of states. This function
does not need to be defined if [`is_observed`](@ref) always returns `false`. Thus,
it is mandatory to always check `is_observed` before using this function.

If `!is_markovian(indp)`, the returned function must have the signature
`(u, h, p, t) -> [values...]` where `h` is the history function, which can be called
to obtain past values of the state. The exact signature and semantics of `h` depend
on how it is used inside the returned function. `h` is obtained from a value
provider using [`get_history_function`](@ref).

See also: [`is_time_dependent`](@ref), [`is_markovian`](@ref), [`constant_structure`](@ref).
"""
observed(indp, sym) = observed(symbolic_container(indp), sym)
observed(indp, sym, states) = observed(symbolic_container(indp), sym, states)

"""
    supports_tuple_observed(indp)

Check if the given index provider supports generating observed functions for tuples of
symbolic variables. Falls back using `symbolic_container`, and returns `false` by
default.

See also: [`observed`](@ref), [`parameter_observed`](@ref), [`symbolic_container`](@ref).
"""
function supports_tuple_observed(indp)
    return if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) !== indp
        supports_tuple_observed(sc)
    else
        false
    end
end

"""
    is_time_dependent(indp)

Check if `indp` has time as (one of) its independent variables.
"""
is_time_dependent(indp) = is_time_dependent(symbolic_container(indp))

"""
    is_markovian(indp)

Check if an index provider represents a Markovian system. Markovian systems do not require
knowledge of past states to simulate. This function is only applicable to
index providers for which `is_time_dependent(indp)` returns `true`.

Non-Markovian index providers return [`observed`](@ref) functions with a different signature.
All value providers associated with a non-markovian index provider must implement
[`get_history_function`](@ref).

Returns `true` by default.
"""
function is_markovian(indp)
    return if hasmethod(symbolic_container, Tuple{typeof(indp)})
        is_markovian(symbolic_container(indp))
    else
        true
    end
end

"""
    constant_structure(indp)

Check if `indp` has a constant structure. Constant structure index providers do not change
the number of variables or parameters over time.
"""
constant_structure(indp) = constant_structure(symbolic_container(indp))

"""
    all_variable_symbols(indp)

Return a vector of variable symbols in the system, including observed quantities.

For types that implement `Base.getindex` with symbolic indices using this interface,
The shorthand `sys[allvariables]` can be used as shorthand for
`valp[all_variable_symbols(indp)]`.

See: [`allvariables`](@ref).
"""
all_variable_symbols(indp) = all_variable_symbols(symbolic_container(indp))

"""
    all_symbols(indp)

Return an array of all symbols in the index provider. This includes parameters and
independent variables.
"""
all_symbols(indp) = all_symbols(symbolic_container(indp))

"""
    default_values(indp)

Return a dictionary mapping symbols in the index provider to their default value, if any.
This includes parameter symbols. The dictionary must be mutable.
"""
function default_values(indp)
    return if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        default_values(symbolic_container(indp))
    else
        Dict()
    end
end

struct SolvedVariables end

"""
    const solvedvariables = SolvedVariables()

This singleton is used as a shortcut to allow indexing of all solution variables
(excluding observed quantities). It has a [`symbolic_type`](@ref) of
[`ScalarSymbolic`](@ref). See: [`variable_symbols`](@ref).
"""
const solvedvariables = SolvedVariables()
symbolic_type(::Type{SolvedVariables}) = ScalarSymbolic()

struct AllVariables end

"""
    const allvariables = AllVariables()

This singleton is used as a shortcut to allow indexing of all solution variables
(including observed quantities). It has a [`symbolic_type`](@ref) of
[`ScalarSymbolic`](@ref). See [`all_variable_symbols`](@ref).
"""
const allvariables = AllVariables()
symbolic_type(::Type{AllVariables}) = ScalarSymbolic()

using SymbolicIndexingInterface
using Test

@test all(
    symbolic_type.([Int, Float64, String, Bool, UInt, Complex{Float64}]) .==
        (NotSymbolic(),)
)
@test symbolic_type(Symbol) == ScalarSymbolic()
@test hasname(:x)
@test getname(:x) == :x
@test !hasname(1)
@test !hasname(1.0)
@test !hasname("x")

using SymbolicIndexingInterface
using Test

sc = SymbolCache(
    [:x, :y, :z], [:a, :b], [:t]; defaults = Dict(:x => 1, :y => :(2b), :b => :(2a + x))
)

@test all(is_variable.((sc,), [:x, :y, :z]))
@test all(.!is_variable.((sc,), [:a, :b, :t, :q]))
@test variable_index.((sc,), [:x, :y, :z, :a]) == [1, 2, 3, nothing]
@test all(is_parameter.((sc,), [:a, :b]))
@test all(.!is_parameter.((sc,), [:x, :y, :z, :t, :q]))
@test parameter_index.((sc,), [:a, :b, :x]) == [1, 2, nothing]
@test is_independent_variable(sc, :t)
@test all(.!is_independent_variable.((sc,), [:x, :y, :z, :a, :b, :q]))
@test all(.!is_observed.((sc,), [:x, :y, :z, :a, :b, :t, :q]))
@test is_time_dependent(sc)
@test constant_structure(sc)
@test variable_symbols(sc) == [:x, :y, :z]
@test sort(parameter_symbols(sc)) == [:a, :b]
@test independent_variable_symbols(sc) == [:t]
@test all_variable_symbols(sc) == [:x, :y, :z]
@test sort(sort(all_symbols(sc))) == [:a, :b, :t, :x, :y, :z]
@test default_values(sc)[:x] == 1
@test default_values(sc)[:y] == :(2b)
@test default_values(sc)[:b] == :(2a + x)

@test symbolic_evaluate(:x, default_values(sc)) == 1
@test symbolic_evaluate(:y, default_values(sc)) == :(2 * (2a + 1))
@test symbolic_evaluate(:(x + y), merge(default_values(sc), Dict(:a => 2))) == 11

@test is_observed(sc, :(x + a + t))
obsfn = observed(sc, :(x + a + t))
@test obsfn(ones(3), 2ones(2), 3.0) == 6.0
obsfn2 = observed(sc, :(x + a + t))
@test obsfn === obsfn2

@test is_observed(sc, [:(x + a), :(a + t)])
obsfn3 = observed(sc, [:(x + a), :(a + t)])
@test obsfn3(ones(3), 2ones(2), 3.0) ≈ [3.0, 5.0]
@test is_observed(sc, [:(x + a) :(y + b); :(x + y) :(a + b)])
obsfn4 = observed(sc, [:(x + a) :(y + b); :(x + y) :(a + b)])
@test size(obsfn4(ones(3), 2ones(2), 3.0)) == (2, 2)
@test obsfn4(ones(3), 2ones(2), 3.0) ≈ [3.0 3.0; 2.0 4.0]
@test is_observed(sc, (:(x + a), :(y + b)))
obsfn5 = observed(sc, (:(x + a), :(y + b)))
@test all(obsfn5(ones(3), 2ones(2), 3.0) .≈ (3.0, 3.0))

@test_throws TypeError observed(sc, [:(x + a), 2])
@test_throws TypeError observed(sc, (:(x + a), 2))

pobsfn1 = parameter_observed(sc, :(a + b + t))
@test pobsfn1(2ones(2), 3.0) == 7.0
pobsfn2 = parameter_observed(sc, [:(a + b + t), :(a + t)])
@test pobsfn2(2ones(2), 3.0) == [7.0, 5.0]
buffer = zeros(2)
pobsfn2(buffer, 2ones(2), 3.0)
@test buffer == [7.0, 5.0]
pobsfn3 = parameter_observed(sc, (:(a + b + t), :(a + t)))
@test pobsfn3(2ones(2), 3.0) == (7.0, 5.0)
buffer = zeros(2)
pobsfn3(buffer, 2ones(2), 3.0)
@test buffer == [7.0, 5.0]

@test_throws TypeError parameter_observed(sc, [:(a + b), 4])
@test_throws TypeError parameter_observed(sc, (:(a + b), 4))

sc = SymbolCache(
    [:x, :y], [:a, :b, :c], :t;
    timeseries_parameters = Dict(
        :b => ParameterTimeseriesIndex(1, 1), :c => ParameterTimeseriesIndex(2, 1)
    )
)
@test only(get_all_timeseries_indexes(sc, :(a + c))) == 2
@test only(get_all_timeseries_indexes(sc, [:a, :c])) == 2
@test isempty(get_all_timeseries_indexes(sc, :(2a)))
@test isempty(get_all_timeseries_indexes(sc, [:(2a), :(3a)]))
@test sort(collect(get_all_timeseries_indexes(sc, [:b, :c]))) == [1, 2]

@test_throws ArgumentError SymbolCache(
    [:x, :y], [:a, :b], :t;
    timeseries_parameters = Dict(:c => ParameterTimeseriesIndex(1, 1))
)
@test_throws TypeError SymbolCache(
    [:x, :y], [:a, :c], :t; timeseries_parameters = Dict(:c => (1, 1))
)
@test_nowarn SymbolCache(
    [:x, :y], [:a, :c], :t;
    timeseries_parameters = Dict(:c => ParameterTimeseriesIndex(1, 1))
)

sc = SymbolCache([:x, :y], [:a, :b])
@test !is_time_dependent(sc)
@test sort(all_symbols(sc)) == [:a, :b, :x, :y]
@test is_observed(sc, :(x + b))
obsfn = observed(sc, :(x + b))
@test obsfn(ones(2), 2ones(2)) == 3.0
# make sure the constructor works
@test_nowarn SymbolCache([:x, :y])

@test_throws ArgumentError SymbolCache(
    [:x, :y], [:a, :b]; timeseries_parameters = Dict(:b => ParameterTimeseriesIndex(1, 1))
)

sc = SymbolCache()
@test all(.!is_variable.((sc,), [:x, :y, :a, :b, :t]))
@test all(variable_index.((sc,), [:x, :y, :a, :b, :t]) .== nothing)
@test variable_symbols(sc) == []
@test all(.!is_parameter.((sc,), [:x, :y, :a, :b, :t]))
@test all(parameter_index.((sc,), [:x, :y, :a, :b, :t]) .== nothing)
@test parameter_symbols(sc) == []
@test all(.!is_independent_variable.((sc,), [:x, :y, :a, :b, :t]))
@test independent_variable_symbols(sc) == []
@test !is_time_dependent(sc)
@test all_variable_symbols(sc) == []
@test all_symbols(sc) == []
@test isempty(default_values(sc))

sc = SymbolCache(nothing, nothing, :t)
@test all(.!is_independent_variable.((sc,), [:x, :y, :a, :b]))
@test is_independent_variable(sc, :t)
@test independent_variable_symbols(sc) == [:t]
@test is_time_dependent(sc)
@test all_variable_symbols(sc) == []
@test all_symbols(sc) == [:t]
@test isempty(default_values(sc))

sc = SymbolCache(nothing, nothing, [:t1, :t2, :t3])
@test all(is_independent_variable.((sc,), [:t1, :t2, :t3]))
@test independent_variable_symbols(sc) == [:t1, :t2, :t3]

sc2 = copy(sc)
@test sc.variables == sc2.variables
@test sc.parameters == sc2.parameters
@test sc.independent_variables == sc2.independent_variables

sc = SymbolCache()
for sym in [1, :a, :(a + b), "foo", [:a, :b], [:(a + b), :c]]
    @test only(get_all_timeseries_indexes(sc, sym)) == ContinuousTimeseries()
end

using SymbolicIndexingInterface
using StaticArrays

sys = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)

for (buf, newbuf, idxs, vals) in [
        # standard operation
        ([1.0, 2.0, 3.0], [2.0, 3.0, 4.0], [:x, :y, :z], [2.0, 3.0, 4.0]),
        # buffer type "demotion"
        ([1.0, 2.0, 3.0], [2, 2, 3], [:x], [2]),
        # buffer type promotion
        ([1, 2, 3], [2.0, 2.0, 3.0], [:x], [2.0]),
        # value type promotion
        ([1, 2, 3], [2.0, 3.0, 4.0], [:x, :y, :z], Real[2, 3.0, 4.0]),
        # standard operation
        ([1.0, 2.0, 3.0], [2.0, 3.0, 4.0], [:a, :b, :c], [2.0, 3.0, 4.0]),
        # buffer type "demotion"
        ([1.0, 2.0, 3.0], [2, 2, 3], [:a], [2]),
        # buffer type promotion
        ([1, 2, 3], [2.0, 2.0, 3.0], [:a], [2.0]),
        # value type promotion
        ([1, 2, 3], [2, 3.0, 4.0], [:a, :b, :c], Real[2, 3.0, 4.0]),
        # skip non-parameters
        ([1, 2, 3], [2.0, 3.0, 3.0], [:a, :b, :(a + b)], [2.0, 3.0, 5.0]),
    ]
    @test_deprecated remake_buffer(sys, buf, Dict(idxs .=> vals))
    for varmap in [Dict(idxs .=> vals), Dict{Any, Any}(idxs .=> vals)]
        _newbuf = remake_buffer(sys, buf, keys(varmap), values(varmap))
        @test _newbuf != buf
        @test newbuf == _newbuf
        @test typeof(newbuf) == typeof(_newbuf)
    end
    for arrType in [Vector, SVector{3}, MVector{3}, SizedVector{3}]
        buf = arrType(buf)
        newbuf = arrType(newbuf)
        _newbuf = remake_buffer(sys, buf, idxs, vals)

        @test _newbuf != buf # should not alias
        @test newbuf == _newbuf # test values
        @test typeof(newbuf) == typeof(_newbuf) # ensure appropriate type
    end
end

for (buf, newbuf, idxs, vals) in [
        # standard operation
        ((1.0, 2.0, 3.0), (2.0, 3.0, 4.0), [:a, :b, :c], [2.0, 3.0, 4.0]),
        # buffer type "demotion"
        ((1.0, 2.0, 3.0), (2, 3, 4), [:a, :b, :c], [2, 3, 4]),
        # buffer type promotion
        ((1, 2, 3), (2.0, 3.0, 4.0), [:a, :b, :c], [2.0, 3.0, 4.0]),
        # value type promotion
        ((1, 2, 3), (2, 3.0, 4.0), [:a, :b, :c], Real[2, 3.0, 4.0]),
        # standard operation
        ((1.0, 2.0, 3.0), (2.0, 3.0, 4.0), [:x, :y, :z], [2.0, 3.0, 4.0]),
        # buffer type "demotion"
        ((1.0, 2.0, 3.0), (2, 3, 4), [:x, :y, :z], [2, 3, 4]),
        # buffer type promotion
        ((1, 2, 3), (2.0, 3.0, 4.0), [:x, :y, :z], [2.0, 3.0, 4.0]),
        # value type promotion
        ((1, 2, 3), (2, 3.0, 4.0), [:x, :y, :z], Real[2, 3.0, 4.0]),
        # skip non-variables
        ([1, 2, 3], [2.0, 3.0, 3.0], [:x, :y, :(x + y)], [2.0, 3.0, 5.0]),
    ]
    @test_deprecated remake_buffer(sys, buf, Dict(idxs .=> vals))
    for varmap in [Dict(idxs .=> vals), Dict{Any, Any}(idxs .=> vals)]
        _newbuf = remake_buffer(sys, buf, keys(varmap), values(varmap))
        @test newbuf == _newbuf
        @test typeof(newbuf) == typeof(_newbuf)
    end
    _newbuf = remake_buffer(sys, buf, idxs, vals)
    @test newbuf == _newbuf # test values
    @test typeof(newbuf) == typeof(_newbuf) # ensure appropriate type
end

@test isnothing(remake_buffer(sys, nothing, [], []))

@testset "`remake_buffer` with `Dict`" begin
    sys = nothing
    buf = Dict("a" => 1, "b" => 2)
    buf2 = remake_buffer(sys, buf, collect(keys(buf)), collect(values(buf)))
    @test isequal(buf, buf2)
    buf2 = remake_buffer(sys, buf, keys(buf), values(buf))
    @test isequal(buf, buf2)
end

"""
    struct ParameterTimeseriesCollection{T}
    function ParameterTimeseriesCollection(collection)

A utility struct that helps in storing multiple parameter timeseries. It expects a
collection of timseries objects ([`is_timeseries`](@ref) returns [`Timeseries`](@ref))
for each. Each of the timeseries objects should implement [`state_values`](@ref) and
[`current_time`](@ref). Effectively, the "states" of each contained timeseries object are
the parameter values it stores the timeseries of.

The collection is expected to implement `Base.eachindex`, `Base.iterate` and
`Base.getindex`. The indexes of the collection should agree with the timeseries indexes
returned by calling [`timeseries_parameter_index`](@ref) on the corresponding index
provider.

This type forwards `eachindex`, `iterate` and `length` to the contained `collection`. It
implements `Base.parent` to allow access to the contained `collection`, and has the
following `getindex` methods:

- `getindex(ptc::ParameterTimeseriesCollection, idx) = ptc.collection[idx]`.
- `getindex(::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex)` returns the
  timeseries of the parameter referred to by `idx`.
- `getindex(::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex, subidx)`
  returns the value of the parameter referred to by `idx` at the time index `subidx`.
- Apart from these cases, if multiple indexes are provided the first is treated as a
  timeseries index, the second the time index in the timeseries, and the (optional)
  third the index of the parameter in an element of the timeseries.

The three-argument version of [`parameter_values`](@ref) is implemented for this type.
The single-argument version of `parameter_values` returns the cached parameter object.
This type does not implement any traits.
"""
struct ParameterTimeseriesCollection{T, P}
    collection::T
    paramcache::P

    function ParameterTimeseriesCollection(collection::T, paramcache::P) where {T, P}
        if any(x -> is_timeseries(x) == NotTimeseries(), collection)
            throw(
                ArgumentError(
                    """
                        All objects in the collection `ParameterTimeseriesCollection` must be \
                    timeseries objects.
                    """
                )
            )
        end
        return new{T, P}(collection, paramcache)
    end
end

Base.eachindex(ptc::ParameterTimeseriesCollection) = eachindex(ptc.collection)

Base.iterate(ptc::ParameterTimeseriesCollection, args...) = iterate(ptc.collection, args...)

Base.length(ptc::ParameterTimeseriesCollection) = length(ptc.collection)

Base.parent(ptc::ParameterTimeseriesCollection) = ptc.collection

Base.getindex(ptc::ParameterTimeseriesCollection, idx) = ptc.collection[idx]
function Base.getindex(ptc::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex)
    timeseries = ptc.collection[idx.timeseries_idx]
    return getindex.(state_values(timeseries), (idx.parameter_idx,))
end
function Base.getindex(
        ptc::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex, subidx::Union{
            Int, CartesianIndex,
        }
    )
    timeseries = ptc.collection[idx.timeseries_idx]
    return state_values(timeseries, subidx)[idx.parameter_idx]
end
function Base.getindex(
        ptc::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex, ::Colon
    )
    return ptc[idx]
end
function Base.getindex(
        ptc::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex, subidx::AbstractArray{Bool}
    )
    timeseries = ptc.collection[idx.timeseries_idx]
    return map(only(to_indices(current_time(timeseries), (subidx,)))) do i
        state_values(timeseries, i)[idx.parameter_idx]
    end
end
function Base.getindex(
        ptc::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex, subidx
    )
    timeseries = ptc.collection[idx.timeseries_idx]
    return getindex.(state_values.((timeseries,), subidx), idx.parameter_idx)
end
function Base.getindex(ptc::ParameterTimeseriesCollection, ts_idx, subidx)
    return state_values(ptc.collection[ts_idx], subidx)
end
function Base.getindex(ptc::ParameterTimeseriesCollection, ts_idx, subidx, param_idx)
    return ptc[ParameterTimeseriesIndex(ts_idx, param_idx), subidx]
end

function parameter_values(ptc::ParameterTimeseriesCollection)
    return ptc.paramcache
end

function parameter_values(
        ptc::ParameterTimeseriesCollection, idx::ParameterTimeseriesIndex, subidx
    )
    return ptc[idx, subidx]
end
function parameter_values(prob, i::ParameterTimeseriesIndex, j)
    return parameter_values(get_parameter_timeseries_collection(prob), i, j)
end
function parameter_timeseries(ptc::ParameterTimeseriesCollection, idx)
    return current_time(ptc[idx])
end

function _timeseries_value(ptc::ParameterTimeseriesCollection, ts_idx, t)
    ts_obj = ptc[ts_idx]
    time_idx = searchsortedlast(current_time(ts_obj), t)
    value = state_values(ts_obj, time_idx)
    return value
end

"""
    parameter_values_at_time(indp, valp, t)

Return an indexable collection containing the value of all parameters in `valp` at time
`t`. Note that `t` here is a floating-point time, and not an index into a timeseries.

This has a default implementation relying on [`get_parameter_timeseries_collection`](@ref)
and [`with_updated_parameter_timeseries_values`](@ref).
"""
function parameter_values_at_time(indp, valp, t)
    ptc = get_parameter_timeseries_collection(valp)
    return with_updated_parameter_timeseries_values(
        indp, ptc.paramcache,
        (ts_idx => _timeseries_value(ptc, ts_idx, t) for ts_idx in eachindex(ptc))...
    )
end

"""
    parameter_timeseries(valp, i)

Return a vector of the time steps at which the parameter values in the parameter
timeseries at index `i` are saved. This is only required for objects where
`is_parameter_timeseries(valp) === Timeseries()`. It will not be called otherwise. It is
assumed that the timeseries is sorted in increasing order.

See also: [`is_parameter_timeseries`](@ref).
"""
function parameter_timeseries end

function parameter_timeseries(valp, i)
    return parameter_timeseries(get_parameter_timeseries_collection(valp), i)
end

function set_state!(sys, val, idx)
    return state_values(sys)[idx] = val
end

"""
    getsym(indp, sym)

Return a function that takes a value provider and returns the value of the symbolic
variable `sym`. If `sym` is not an observed quantity, the returned function can also
directly be called with an array of values representing the state vector. `sym` can be an
index into the state vector, a symbolic variable, a symbolic expression involving symbolic
variables in the index provider `indp`, a parameter symbol, the independent variable
symbol, or an array/tuple of the aforementioned. If the returned function is called with
a timeseries object, it can also be given a second argument representing the index at
which to return the value of `sym`.

At minimum, this requires that the value provider implement [`state_values`](@ref). To
support symbolic expressions, the value provider must implement [`observed`](@ref),
[`parameter_values`](@ref) and [`current_time`](@ref).

This function typically does not need to be implemented, and has a default implementation
relying on the above functions.

If the value provider is a parameter timeseries object, the same rules apply as
[`getp`](@ref). The difference here is that `sym` may also contain non-parameter symbols,
and the values are always returned corresponding to the state timeseries.
"""
function getsym(sys, sym)
    symtype = symbolic_type(sym)
    elsymtype = symbolic_type(eltype(sym))
    return _getsym(sys, symtype, elsymtype, sym)
end

struct GetStateIndex{I} <: AbstractStateGetIndexer
    idx::I
end
function (gsi::GetStateIndex)(::Timeseries, prob)
    return getindex.(state_values(prob), (gsi.idx,))
end
function (gsi::GetStateIndex)(::Timeseries, prob, i::Union{Int, CartesianIndex})
    return getindex(state_values(prob, i), gsi.idx)
end
function (gsi::GetStateIndex)(::Timeseries, prob, i)
    # Wrap `gsi.idx` in a 1-tuple so it broadcasts as a scalar across the
    # `state_values(prob, i)` collection. Without the wrap, an array-valued
    # `gsi.idx` (e.g. `Vector{Int}` from an array-symbolic) is broadcast
    # element-wise and errors with a shape mismatch against the time axis.
    return getindex.(state_values(prob, i), (gsi.idx,))
end
function (gsi::GetStateIndex)(::NotTimeseries, prob)
    return state_values(prob, gsi.idx)
end

function _getsym(sys, ::NotSymbolic, ::NotSymbolic, sym)
    return GetStateIndex(sym)
end

struct GetIndepvar <: AbstractStateGetIndexer end

(::GetIndepvar)(::IsTimeseriesTrait, prob) = current_time(prob)
(::GetIndepvar)(::Timeseries, prob, i) = current_time(prob, i)

struct TimeDependentObservedFunction{I, F, H} <: AbstractStateGetIndexer
    ts_idxs::I
    obsfn::F
end

function TimeDependentObservedFunction{H}(ts_idxs, obsfn) where {H}
    return TimeDependentObservedFunction{typeof(ts_idxs), typeof(obsfn), H}(ts_idxs, obsfn)
end

const NonMarkovianObservedFunction = TimeDependentObservedFunction{I, F, false} where {I, F}

indexer_timeseries_index(t::TimeDependentObservedFunction) = t.ts_idxs
function is_indexer_timeseries(::Type{G}) where {
        G <:
        TimeDependentObservedFunction{ContinuousTimeseries},
    }
    return IndexerBoth()
end
function is_indexer_timeseries(::Type{G}) where {
        G <:
        TimeDependentObservedFunction{<:Vector},
    }
    return IndexerMixedTimeseries()
end
function (o::TimeDependentObservedFunction)(ts::IsTimeseriesTrait, prob, args...)
    return o(ts, is_indexer_timeseries(o), prob, args...)
end

function (o::TimeDependentObservedFunction)(::Timeseries, ::IndexerBoth, prob)
    return o.obsfn.(
        state_values(prob),
        (parameter_values(prob),),
        current_time(prob)
    )
end
function (o::NonMarkovianObservedFunction)(::Timeseries, ::IndexerBoth, prob)
    return o.obsfn.(
        state_values(prob),
        (get_history_function(prob),),
        (parameter_values(prob),),
        current_time(prob)
    )
end
function (o::TimeDependentObservedFunction)(
        ::Timeseries, ::IndexerBoth, prob, i::Union{Int, CartesianIndex}
    )
    return o.obsfn(state_values(prob, i), parameter_values(prob), current_time(prob, i))
end
function (o::NonMarkovianObservedFunction)(
        ::Timeseries, ::IndexerBoth, prob, i::Union{Int, CartesianIndex}
    )
    return o.obsfn(
        state_values(prob, i), get_history_function(prob),
        parameter_values(prob), current_time(prob, i)
    )
end
function (o::TimeDependentObservedFunction)(ts::Timeseries, ::IndexerBoth, prob, ::Colon)
    return o(ts, prob)
end
function (o::TimeDependentObservedFunction)(
        ts::Timeseries, ::IndexerBoth, prob, i::AbstractArray{Bool}
    )
    return map(only(to_indices(current_time(prob), (i,)))) do idx
        o(ts, prob, idx)
    end
end
function (o::TimeDependentObservedFunction)(ts::Timeseries, ::IndexerBoth, prob, i)
    return o.((ts,), (prob,), i)
end
function (o::TimeDependentObservedFunction)(::NotTimeseries, ::IndexerBoth, prob)
    return o.obsfn(state_values(prob), parameter_values(prob), current_time(prob))
end
function (o::NonMarkovianObservedFunction)(::NotTimeseries, ::IndexerBoth, prob)
    return o.obsfn(
        state_values(prob), get_history_function(prob),
        parameter_values(prob), current_time(prob)
    )
end

function (o::TimeDependentObservedFunction)(::Timeseries, ::IndexerMixedTimeseries, prob)
    if !(ContinuousTimeseries() in o.ts_idxs)
        throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(o)))
    end
    mapfn = let inner = o.obsfn, indp = prob, valp = prob
        function __mapfn(u, t)
            cur_p = parameter_values_at_time(indp, valp, t)
            return inner(u, cur_p, t)
        end
    end
    return map(mapfn, state_values(prob), current_time(prob))
end
function (o::NonMarkovianObservedFunction)(::Timeseries, ::IndexerMixedTimeseries, prob)
    if !(ContinuousTimeseries() in o.ts_idxs)
        throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(o)))
    end
    mapfn = let inner = o.obsfn, indp = prob, valp = prob, h = get_history_function(prob)
        function __mapfn(u, t)
            cur_p = parameter_values_at_time(indp, valp, t)
            return inner(u, h, cur_p, t)
        end
    end
    return map(mapfn, state_values(prob), current_time(prob))
end
function (o::TimeDependentObservedFunction)(
        ::Timeseries, ::IndexerMixedTimeseries, prob, i::Union{Int, CartesianIndex}
    )
    if !(ContinuousTimeseries() in o.ts_idxs)
        throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(o)))
    end
    t = current_time(prob, i)
    cur_p = parameter_values_at_time(prob, prob, t)
    return o.obsfn(state_values(prob, i), cur_p, t)
end
function (o::NonMarkovianObservedFunction)(
        ::Timeseries, ::IndexerMixedTimeseries, prob, i::Union{Int, CartesianIndex}
    )
    if !(ContinuousTimeseries() in o.ts_idxs)
        throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(o)))
    end
    t = current_time(prob, i)
    cur_p = parameter_values_at_time(prob, prob, t)
    return o.obsfn(state_values(prob, i), get_history_function(prob), cur_p, t)
end
function (o::TimeDependentObservedFunction)(
        ts::Timeseries, ::IndexerMixedTimeseries, prob, ::Colon
    )
    return o(ts, prob)
end
function (o::TimeDependentObservedFunction)(
        ts::Timeseries, ::IndexerMixedTimeseries, prob, i::AbstractArray{Bool}
    )
    return map(only(to_indices(current_time(prob), (i,)))) do idx
        o(ts, prob, idx)
    end
end
function (o::TimeDependentObservedFunction)(ts::Timeseries, ::IndexerMixedTimeseries, prob, i)
    return o.((ts,), (prob,), i)
end
function (o::TimeDependentObservedFunction)(
        ::NotTimeseries, ::IndexerMixedTimeseries, prob, args...
    )
    return o.obsfn(state_values(prob), parameter_values(prob), current_time(prob))
end
function (o::NonMarkovianObservedFunction)(
        ::NotTimeseries, ::IndexerMixedTimeseries, prob, args...
    )
    return o.obsfn(
        state_values(prob), get_history_function(prob),
        parameter_values(prob), current_time(prob)
    )
end

struct TimeIndependentObservedFunction{F} <: AbstractStateGetIndexer
    obsfn::F
end

function (o::TimeIndependentObservedFunction)(::IsTimeseriesTrait, prob)
    return o.obsfn(state_values(prob), parameter_values(prob))
end

function _getsym(sys, ::ScalarSymbolic, ::SymbolicTypeTrait, sym)
    if is_variable(sys, sym)
        idx = variable_index(sys, sym)
        # Directly create GetStateIndex instead of recursive getsym call
        # to avoid type instability from variable_index returning Union{Nothing, Int}
        return GetStateIndex(idx)
    elseif is_parameter(sys, sym)
        return getp(sys, sym)
    elseif is_independent_variable(sys, sym)
        return GetIndepvar()
    elseif is_observed(sys, sym)
        if !is_time_dependent(sys)
            return TimeIndependentObservedFunction(observed(sys, sym))
        end

        ts_idxs = get_all_timeseries_indexes(sys, sym)
        if ContinuousTimeseries() in ts_idxs
            if length(ts_idxs) == 1
                ts_idxs = only(ts_idxs)
            else
                ts_idxs = collect(ts_idxs)
            end
            fn = observed(sys, sym)
            return TimeDependentObservedFunction{is_markovian(sys)}(ts_idxs, fn)
        else
            return getp(sys, sym)
        end
    end
    error("Invalid symbol $sym for `getsym`")
end

struct MultipleGetters{I, G} <: AbstractStateGetIndexer
    ts_idxs::I
    getters::G
end

indexer_timeseries_index(mg::MultipleGetters) = mg.ts_idxs
function is_indexer_timeseries(::Type{G}) where {G <: MultipleGetters{ContinuousTimeseries}}
    return IndexerBoth()
end
function is_indexer_timeseries(::Type{G}) where {G <: MultipleGetters{<:Vector}}
    return IndexerMixedTimeseries()
end
function is_indexer_timeseries(::Type{G}) where {G <: MultipleGetters{Nothing}}
    return IndexerNotTimeseries()
end

function (mg::MultipleGetters)(ts::IsTimeseriesTrait, prob, args...)
    return mg(ts, is_indexer_timeseries(mg), prob, args...)
end

function (mg::MultipleGetters)(ts::Timeseries, ::IndexerBoth, prob)
    return mg.((ts,), (prob,), eachindex(current_time(prob)))
end
function (mg::MultipleGetters)(
        ::Timeseries, ::IndexerBoth, prob, i::Union{Int, CartesianIndex}
    )
    return map(CallWith(prob, i), mg.getters)
end
function (mg::MultipleGetters)(ts::Timeseries, ::IndexerBoth, prob, ::Colon)
    return mg(ts, prob)
end
function (mg::MultipleGetters)(ts::Timeseries, ::IndexerBoth, prob, i::AbstractArray{Bool})
    return map(only(to_indices(current_time(prob), (i,)))) do idx
        mg(ts, prob, idx)
    end
end
function (mg::MultipleGetters)(ts::Timeseries, ::IndexerBoth, prob, i)
    return mg.((ts,), (prob,), i)
end
function (mg::MultipleGetters)(
        ::NotTimeseries, ::Union{IndexerBoth, IndexerNotTimeseries}, prob
    )
    return map(g -> g(prob), mg.getters)
end

function (mg::MultipleGetters)(::Timeseries, ::IndexerMixedTimeseries, prob, args...)
    throw(MixedParameterTimeseriesIndexError(prob, indexer_timeseries_index(mg)))
end
function (mg::MultipleGetters)(::NotTimeseries, ::IndexerMixedTimeseries, prob, args...)
    return map(g -> g(prob), mg.getters)
end

struct AsTupleWrapper{N, A, G} <: AbstractStateGetIndexer
    getter::G
end

AsTupleWrapper{N}(getter::G) where {N, G} = AsTupleWrapper{N, Nothing, G}(getter)
AsTupleWrapper{N, A}(getter::G) where {N, A, G} = AsTupleWrapper{N, A, G}(getter)

wrap_tuple(::AsTupleWrapper{N, Nothing}, val) where {N} = ntuple(i -> val[i], Val(N))
function wrap_tuple(::AsTupleWrapper{N, A}, val) where {N, A}
    return NamedTuple{A}(ntuple(i -> val[i], Val(N)))
end

function (atw::AsTupleWrapper)(::Timeseries, prob)
    return wrap_tuple.((atw,), atw.getter(prob))
end
function (atw::AsTupleWrapper)(::Timeseries, prob, i::Union{Int, CartesianIndex})
    return wrap_tuple(atw, atw.getter(prob, i))
end
function (atw::AsTupleWrapper)(::Timeseries, prob, i)
    return wrap_tuple.((atw,), atw.getter(prob, i))
end
function (atw::AsTupleWrapper)(::NotTimeseries, prob)
    return wrap_tuple(atw, atw.getter(prob))
end

for (t1, t2) in [
        (ScalarSymbolic, Any),
        (ArraySymbolic, Any),
        (NotSymbolic, Union{<:Tuple, <:NamedTuple, <:AbstractArray}),
    ]
    @eval function _getsym(sys, ::NotSymbolic, elt::$t1, sym::$t2)
        if isempty(sym)
            return MultipleGetters(ContinuousTimeseries(), sym)
        end
        sym_arr = sym isa Union{Tuple, NamedTuple} ? collect(sym) : sym
        supports_tuple = supports_tuple_observed(sys)
        num_observed = 0
        for s in sym
            num_observed += is_observed(sys, s)
            num_observed > 1 && break # exit early, we only need to know whether 0, 1, or more
        end
        if !is_time_dependent(sys)
            if num_observed == 0 || num_observed == 1 && sym isa Tuple
                return MultipleGetters(nothing, getsym.((sys,), sym))
            else
                obs = supports_tuple ? observed(sys, sym) : observed(sys, sym_arr)
                getter = TimeIndependentObservedFunction(obs)
                if sym isa Tuple
                    getter = AsTupleWrapper{length(sym)}(getter)
                elseif sym isa NamedTuple
                    getter = AsTupleWrapper{length(sym), keys(sym)}(getter)
                end
                return getter
            end
        end
        ts_idxs = get_all_timeseries_indexes(sys, sym_arr)
        if !(ContinuousTimeseries() in ts_idxs)
            return getp(sys, sym)
        end
        if length(ts_idxs) == 1
            ts_idxs = only(ts_idxs)
        else
            ts_idxs = collect(ts_idxs)
        end

        if num_observed == 0 || num_observed == 1 && sym isa Union{Tuple, NamedTuple}
            _sym = sym isa NamedTuple ? Tuple(sym) : sym
            getters = getsym.((sys,), _sym)
            getter = MultipleGetters(ts_idxs, getters)
            if sym isa NamedTuple
                getter = AsTupleWrapper{length(sym), keys(sym)}(getter)
            end
            return getter
        else
            obs = supports_tuple ? observed(sys, sym) : observed(sys, sym_arr)
            getter = if is_time_dependent(sys)
                TimeDependentObservedFunction{is_markovian(sys)}(ts_idxs, obs)
            else
                TimeIndependentObservedFunction(obs)
            end
            if sym isa Tuple && !supports_tuple
                getter = AsTupleWrapper{length(sym)}(getter)
            elseif sym isa NamedTuple
                getter = AsTupleWrapper{length(sym), keys(sym)}(getter)
            end
            return getter
        end
    end
end

function _getsym(sys, ::ArraySymbolic, ::SymbolicTypeTrait, sym)
    if is_variable(sys, sym)
        idx = variable_index(sys, sym)
        # Directly create GetStateIndex instead of recursive getsym call
        # to avoid type instability from variable_index returning Union{Nothing, Int}
        return GetStateIndex(idx)
    elseif is_parameter(sys, sym)
        return getp(sys, sym)
    end
    return getsym(sys, collect(sym))
end

# setsym doesn't need the same `let` blocks to be inferred for some reason

"""
    setsym(sys, sym)

Return a function that takes a value provider and a value, and sets the the state `sym` to
that value. Note that `sym` can be an index, a symbolic variable, or an array/tuple of the
aforementioned.

Requires that the value provider implement [`state_values`](@ref) and the returned
collection be a mutable reference to the state vector in the value provider. Alternatively,
if this is not possible or additional actions need to be performed when updating state,
[`set_state!`](@ref) can be defined. This function does not work on types for which
[`is_timeseries`](@ref) is [`Timeseries`](@ref).
"""
function setsym(sys, sym)
    symtype = symbolic_type(sym)
    elsymtype = symbolic_type(eltype(sym))
    return _setsym(sys, symtype, elsymtype, sym)
end

struct SetStateIndex{I} <: AbstractSetIndexer
    idx::I
end

function (ssi::SetStateIndex)(prob, val)
    return set_state!(prob, val, ssi.idx)
end

function _setsym(sys, ::NotSymbolic, ::NotSymbolic, sym)
    return SetStateIndex(sym)
end

function _setsym(sys, ::ScalarSymbolic, ::SymbolicTypeTrait, sym)
    if is_variable(sys, sym)
        idx = variable_index(sys, sym)
        return SetStateIndex(idx)
    elseif is_parameter(sys, sym)
        return setp(sys, sym)
    end
    error("Invalid symbol $sym for `setsym`")
end

struct NamedTupleSetter{S <: NamedTuple} <: AbstractSetIndexer
    setter::S
end

function (nts::NamedTupleSetter)(prob, val)
    return _generated_setter(nts, prob, val)
end

@generated function _generated_setter(
        nts::NamedTupleSetter{<:NamedTuple{N1}}, prob, val::NamedTuple{N2}
    ) where {N1, N2}
    expr = Expr(:block)
    for (i, name) in enumerate(N2)
        idx = findfirst(isequal(name), N1)
        if idx === nothing
            throw(
                ArgumentError(
                    """
                    Invalid name $(name) in value. Must be one of $(N1).
                    """
                )
            )
        end
        push!(expr.args, :(nts.setter[$idx](prob, val[$i])))
    end
    return expr
end

for (t1, t2) in [
        (ScalarSymbolic, Any),
        (ArraySymbolic, Any),
        (NotSymbolic, Union{<:Tuple, <:NamedTuple, <:AbstractArray}),
    ]
    @eval function _setsym(sys, ::NotSymbolic, ::$t1, sym::$t2)
        if sym isa NamedTuple
            setters = NamedTuple{keys(sym)}(setsym.((sys,), values(sym)))
            return NamedTupleSetter(setters)
        end
        setters = setsym.((sys,), sym)
        return MultipleSetters(setters)
    end
end

function _setsym(sys, ::ArraySymbolic, ::SymbolicTypeTrait, sym)
    if is_variable(sys, sym)
        idx = variable_index(sys, sym)
        if idx isa AbstractArray
            return MultipleSetters(SetStateIndex.(idx))
        else
            return SetStateIndex(idx)
        end
    elseif is_parameter(sys, sym)
        return setp(sys, sym)
    end
    return setsym(sys, collect(sym))
end

"""
    getu(indp, sym)

Compatibility alias for [`getsym`](@ref).
"""
const getu = getsym

"""
    setu(indp, sym)

Compatibility alias for [`setsym`](@ref).
"""
const setu = setsym

"""
    setsym_oop(indp, sym)

Return a function which takes a value provider `valp` and a value `val`, and returns
`state_values(valp), parameter_values(valp)` with the states/parameters in `sym` set to the
corresponding values in `val`. This allows changing the types of values stored, and leverages
[`remake_buffer`](@ref). Note that `sym` can be an index, a symbolic variable, or an
array/tuple of the aforementioned. All entries `s` in `sym` must satisfy `is_variable(indp, s)`
or `is_parameter(indp, s)`.

Requires that the value provider implement `state_values`, `parameter_values` and `remake_buffer`.
"""
function setsym_oop(indp, sym)
    symtype = symbolic_type(sym)
    elsymtype = symbolic_type(eltype(sym))
    return _setsym_oop(indp, symtype, elsymtype, sym)
end

struct FullSetter{S, P, I, J}
    state_setter::S
    param_setter::P
    state_split::I
    param_split::J
end

FullSetter(ssetter, psetter) = FullSetter(ssetter, psetter, nothing, nothing)

function (fs::FullSetter)(valp, val)
    check_both_state_and_parameter_provider(valp)

    return fs.state_setter(valp, val[fs.state_split]),
        fs.param_setter(valp, val[fs.param_split])
end

function (fs::FullSetter{Nothing})(valp, val)
    check_both_state_and_parameter_provider(valp)

    return state_values(valp), fs.param_setter(valp, val)
end

function (fs::(FullSetter{S, Nothing} where {S}))(valp, val)
    check_both_state_and_parameter_provider(valp)

    return fs.state_setter(valp, val), parameter_values(valp)
end

function (fs::(FullSetter{Nothing, Nothing}))(valp, val)
    check_both_state_and_parameter_provider(valp)

    return state_values(valp), parameter_values(valp)
end

function _setsym_oop(indp, ::NotSymbolic, ::NotSymbolic, sym)
    return FullSetter(OOPSetter(_root_indp(indp), sym, true), nothing)
end

function _setsym_oop(indp, ::ScalarSymbolic, ::SymbolicTypeTrait, sym)
    if (idx = variable_index(indp, sym)) !== nothing
        return FullSetter(OOPSetter(_root_indp(indp), idx, true), nothing)
    elseif (idx = parameter_index(indp, sym)) !== nothing
        return FullSetter(nothing, OOPSetter(_root_indp(indp), idx, false))
    end
    throw(NotVariableOrParameter("setsym_oop", sym))
end

for (t1, t2) in [
        (ScalarSymbolic, Any),
        (NotSymbolic, Union{<:Tuple, <:AbstractArray}),
    ]
    @eval function _setsym_oop(indp, ::NotSymbolic, ::$t1, sym::$t2)
        vars = []
        state_split = eltype(eachindex(sym))[]
        pars = []
        param_split = eltype(eachindex(sym))[]
        for (i, s) in enumerate(sym)
            if (idx = variable_index(indp, s)) !== nothing
                push!(vars, idx)
                push!(state_split, i)
            elseif (idx = parameter_index(indp, s)) !== nothing
                push!(pars, idx)
                push!(param_split, i)
            else
                throw(NotVariableOrParameter("setsym_oop", s))
            end
        end
        if sym isa Tuple
            vars = Tuple(vars)
            pars = Tuple(pars)
        end
        indp = _root_indp(indp)
        return FullSetter(
            isempty(vars) ? nothing : OOPSetter(indp, identity.(vars), true),
            isempty(pars) ? nothing : OOPSetter(indp, identity.(pars), false),
            state_split, param_split
        )
    end
end

function _setsym_oop(indp, ::ArraySymbolic, ::SymbolicTypeTrait, sym)
    if (idx = variable_index(indp, sym)) !== nothing
        return setsym_oop(indp, idx)
    elseif (idx = parameter_index(indp, sym)) !== nothing
        return FullSetter(
            nothing, OOPSetter(indp, idx, false)
        )
    end
    return setsym_oop(indp, collect(sym))
end

using SymbolicIndexingInterface
using Test

struct Wrapper{W}
    wrapped::W
end

SymbolicIndexingInterface.symbolic_container(w::Wrapper) = w.wrapped

sc = SymbolCache([:x, :y, :z], [:a, :b], [:t])
sys = Wrapper(sc)

all_syms = [:x, :y, :z, :a, :b, :t]
@test is_variable.((sys,), all_syms) == is_variable.((sc,), all_syms)
@test variable_index.((sys,), all_syms) == variable_index.((sc,), all_syms)
@test is_parameter.((sys,), all_syms) == is_parameter.((sc,), all_syms)
@test parameter_index.((sys,), all_syms) == parameter_index.((sc,), all_syms)
@test is_independent_variable.((sys,), all_syms) ==
    is_independent_variable.((sc,), all_syms)
@test is_observed.((sys,), all_syms) == is_observed.((sc,), all_syms)
@test is_time_dependent(sys) == is_time_dependent(sc)
@test constant_structure(sys) == constant_structure(sc)
@test variable_symbols(sys) == variable_symbols(sc)
@test parameter_symbols(sys) == parameter_symbols(sc)
@test independent_variable_symbols(sys) == independent_variable_symbols(sc)
@test all_variable_symbols(sys) == variable_symbols(sc)
@test all_symbols(sys) == all_symbols(sc)

abstract type SymbolicTypeTrait end

"""
    struct ScalarSymbolic <: SymbolicTypeTrait end

Trait indicating a type is a scalar symbolic variable.

See also: [`ArraySymbolic`](@ref), [`NotSymbolic`](@ref), [`symbolic_type`](@ref)
"""
struct ScalarSymbolic <: SymbolicTypeTrait end

"""
    struct ArraySymbolic <: SymbolicTypeTrait end

Trait indicating type is a symbolic array. Calling `collect` on a symbolic array must
return an `AbstractArray` containing `ScalarSymbolic` variables for each element in the
array, in the same shape as the represented array. For example, if `a` is a symbolic array
representing a 2x2 matrix, `collect(a)` must return a 2x2 array of scalar symbolic variables.

See also: [`ScalarSymbolic`](@ref), [`NotSymbolic`](@ref), [`symbolic_type`](@ref)
"""
struct ArraySymbolic <: SymbolicTypeTrait end

"""
    struct NotSymbolic <: SymbolicTypeTrait end

Trait indicating a type is not symbolic.

See also: [`ScalarSymbolic`](@ref), [`ArraySymbolic`](@ref), [`symbolic_type`](@ref)
"""
struct NotSymbolic <: SymbolicTypeTrait end

"""
    symbolic_type(x) = symbolic_type(typeof(x))
    symbolic_type(::Type)

Get the symbolic type trait of a type. Default to [`NotSymbolic`](@ref) for all types
except `Symbol` and `Expr`, both of which are [`ScalarSymbolic`](@ref).

See also: [`ScalarSymbolic`](@ref), [`ArraySymbolic`](@ref), [`NotSymbolic`](@ref)
"""
symbolic_type(x) = symbolic_type(typeof(x))
symbolic_type(::Type) = NotSymbolic()
symbolic_type(::Type{Symbol}) = ScalarSymbolic()
symbolic_type(::Type{Expr}) = ScalarSymbolic()

"""
    hasname(x)

Check whether the given symbolic variable (for which `symbolic_type(x) != NotSymbolic()`) has a valid name as per `getname`. Defaults to `true` for `x::Symbol`.
"""
function hasname end

hasname(::Symbol) = true
hasname(::Any) = false

"""
    getname(x)::Symbol

Get the name of a symbolic variable as a `Symbol`. Acts as the identity function for
`x::Symbol`.
"""
function getname end
getname(x::Symbol) = x

"""
    symbolic_evaluate(expr, syms::Dict; kwargs...)

Return the value of symbolic expression `expr` where the values of variables involved are
obtained from the dictionary `syms`. The keys of `syms` are symbolic variables (not
expressions of variables). The values of `syms` can be values or symbolic
expressions.

The returned value should either be a value or an expression involving symbolic variables
not present as keys in `syms`.

The function can take additional keyword arguments to control implementation-specific
behavior.

This is already implemented for 
`symbolic_evaluate(expr::Union{Symbol, Expr}, syms::Dict)`.
"""
function symbolic_evaluate(expr::Union{Symbol, Expr}, syms::Dict)
    while (newexpr = _symbolic_evaluate_helper(expr, syms)) != expr
        expr = newexpr
    end
    return try
        eval(expr)
    catch
        expr
    end
end

function _symbolic_evaluate_helper(expr, syms::Dict)
    if (res = get(syms, expr, nothing)) !== nothing
        return res
    end
    expr isa Expr || return expr

    newexpr = Expr(expr.head)
    sizehint!(newexpr.args, length(expr.args))
    for arg in expr.args
        push!(newexpr.args, _symbolic_evaluate_helper(arg, syms))
    end
    return newexpr
end

############ IsTimeseriesTrait

abstract type IsTimeseriesTrait end

"""
    struct Timeseries <: IsTimeseriesTrait end

Trait indicating a type contains timeseries data. This affects the behaviour of
functions such as [`state_values`](@ref) and [`current_time`](@ref).

See also: [`NotTimeseries`](@ref), [`is_timeseries`](@ref)
"""
struct Timeseries <: IsTimeseriesTrait end

"""
    struct NotTimeseries <: IsTimeseriesTrait end

Trait indicating a type does not contain timeseries data. This affects the behaviour
of functions such as [`state_values`](@ref) and [`current_time`](@ref). Note that
if a type is `NotTimeseries` this only implies that it does not _store_ timeseries
data. It may still be time-dependent. For example, an `ODEProblem` only stores
the initial state of a system, so it is `NotTimeseries`, but still time-dependent.
This is the default trait variant for all types.

See also: [`Timeseries`](@ref), [`is_timeseries`](@ref).
"""
struct NotTimeseries <: IsTimeseriesTrait end

"""
    is_timeseries(x) = is_timeseries(typeof(x))
    is_timeseries(::Type)

Get the timeseries trait of a type. Defaults to [`NotTimeseries`](@ref) for all types.
A type for which `is_timeseries(T) == Timeseries()` may also have a parameter timeseries.
This is determined by the [`is_parameter_timeseries`](@ref) trait.

See also: [`Timeseries`](@ref), [`NotTimeseries`](@ref), [`is_parameter_timeseries`](@ref).
"""
function is_timeseries end

is_timeseries(x) = is_timeseries(typeof(x))
is_timeseries(::Type) = NotTimeseries()

"""
    is_parameter_timeseries(x) = is_parameter_timeseries(typeof(x))
    is_parameter_timeseries(::Type)

Get the parameter timeseries trait of a type. Defaults to [`NotTimeseries`](@ref) for all
types. A type for which `is_parameter_timeseries(T) == Timeseries()` must also have
`is_timeseries(T) == Timeseries()`.

See also: [`Timeseries`](@ref), [`NotTimeseries`](@ref), [`is_timeseries`](@ref).
"""
function is_parameter_timeseries end

is_parameter_timeseries(x) = is_parameter_timeseries(typeof(x))
is_parameter_timeseries(::Type) = NotTimeseries()

using SymbolicIndexingInterface
using SymbolicIndexingInterface: NotVariableOrParameter, IndexerMixedTimeseries,
    is_indexer_timeseries, MixedParameterTimeseriesIndexError, parameter_values_at_time,
    TimeDependentObservedFunction
# AllocCheck uses LLVM introspection which can break on pre-release Julia versions
@static if isempty(VERSION.prerelease)
    using AllocCheck
end

struct FakeIntegrator{S, U, P, T}
    sys::S
    u::U
    p::P
    t::T
end

SymbolicIndexingInterface.symbolic_container(fp::FakeIntegrator) = fp.sys
SymbolicIndexingInterface.state_values(fp::FakeIntegrator) = fp.u
SymbolicIndexingInterface.parameter_values(fp::FakeIntegrator) = fp.p
SymbolicIndexingInterface.current_time(fp::FakeIntegrator) = fp.t

sys = SymbolCache([:x, :y, :z], [:a, :b, :c], [:t])

@test_throws ErrorException getsym(sys, :q)
@test_throws ErrorException setsym(sys, :q)

u = [1.0, 2.0, 3.0]
p = [11.0, 12.0, 13.0]
t = 0.5
fi = FakeIntegrator(sys, copy(u), copy(p), t)
# checking inference for non-concretely typed arrays will always fail
for (sym, val, newval, check_inference) in [
        (:x, u[1], 4.0, true)
        (:y, u[2], 4.0, true)
        (:z, u[3], 4.0, true)
        (1, u[1], 4.0, true)
        ([:x, :y], u[1:2], 4ones(2), true)
        ([1, 2], u[1:2], 4ones(2), true)
        ((:z, :y), (u[3], u[2]), (4.0, 5.0), true)
        ((3, 2), (u[3], u[2]), (4.0, 5.0), true)
        (
            [:x, [:y, :z]], [u[1], u[2:3]],
            [4.0, [5.0, 6.0]], false,
        )
        (
            [:x, 2:3], [u[1], u[2:3]],
            [4.0, [5.0, 6.0]], false,
        )
        (
            [:x, (:y, :z)], [u[1], (u[2], u[3])],
            [4.0, (5.0, 6.0)], false,
        )
        (
            [:x, Tuple(2:3)], [u[1], (u[2], u[3])],
            [4.0, (5.0, 6.0)], false,
        )
        (
            [:x, [:y], (:z,)], [u[1], [u[2]], (u[3],)],
            [4.0, [5.0], (6.0,)], false,
        )
        (
            [:x, [:y], (3,)], [u[1], [u[2]], (u[3],)],
            [4.0, [5.0], (6.0,)], false,
        )
        (
            (:x, [:y, :z]), (u[1], u[2:3]),
            (4.0, [5.0, 6.0]), true,
        )
        (
            (:x, (:y, :z)), (u[1], (u[2], u[3])),
            (4.0, (5.0, 6.0)), true,
        )
        (
            (1, (:y, :z)), (u[1], (u[2], u[3])),
            (4.0, (5.0, 6.0)), true,
        )
        (
            (:x, [:y], (:z,)), (u[1], [u[2]], (u[3],)),
            (4.0, [5.0], (6.0,)), true,
        )
        (
            (a = :x, b = [:x, :y], c = (d = :z, e = :x)),
            (
                a = u[1], b = u[1:2],
                c = (d = u[3], e = u[1]),
            ),
            (
                a = 4.0, b = [4.0, 5.0],
                c = (d = 6.0, e = 4.0),
            ), true,
        )
    ]
    get = getsym(sys, sym)
    set! = setsym(sys, sym)
    if check_inference
        @inferred get(fi)
    end
    @test get(fi) == val
    if check_inference
        @inferred set!(fi, newval)
    else
        set!(fi, newval)
    end
    @test get(fi) == newval

    new_states = copy(state_values(fi))

    set!(fi, val)
    @test get(fi) == val

    if check_inference
        @inferred get(u)
    end
    @test get(u) == val
    if check_inference
        @inferred set!(u, newval)
    else
        set!(u, newval)
    end
    @test get(u) == newval
    set!(u, val)
    @test get(u) == val

    # Test that getter/setter usage has zero allocations for single symbol cases
    # (array/tuple getters allocate a new array for the result)
    @static if isempty(VERSION.prerelease)
        if check_inference && isconcretetype(eltype(newval)) && sym isa Union{Symbol, Int}
            @check_allocs test_getsym(get, u) = get(u)
            test_getsym(get, u)
            @check_allocs test_setsym(set!, u, newval) = set!(u, newval)
            test_setsym(set!, u, newval)
            # Restore val after @check_allocs test
            set!(u, val)
        end
    end

    if sym isa Union{Vector, Tuple} && any(x -> x isa Union{AbstractArray, Tuple}, sym)
        continue
    end

    if !(sym isa NamedTuple)
        setter = setsym_oop(sys, sym)
        svals, pvals = setter(fi, newval)
        @test svals ≈ new_states
        @test pvals == parameter_values(fi)
        @test_throws ArgumentError setter(state_values(fi), newval)
        @test_throws ArgumentError setter(parameter_values(fi), newval)
    end
end

for (sym, val, check_inference) in [
        (:(x + y), u[1] + u[2], true),
        ([:(x + y), :z], [u[1] + u[2], u[3]], false),
        ((:(x + y), :(z + y)), (u[1] + u[2], u[2] + u[3]), false),
    ]
    get = getsym(sys, sym)
    if check_inference
        @inferred get(fi)
    end
    @test get(fi) == val
end

let fi = fi, sys = sys
    getter = getsym(sys, [])
    @test getter(fi) == []
    getter = getsym(sys, ())
    @test getter(fi) == ()
    sc = SymbolCache(nothing, [:a, :b], :t)
    fi = FakeIntegrator(sys, nothing, [1.0, 2.0], 3.0)
    getter = getsym(sc, [])
    @test getter(fi) == []
    getter = getsym(sc, ())
    @test getter(fi) == ()
end

for (sym, oldval, newval, check_inference) in [
        (:a, p[1], 4.0, true)
        (:b, p[2], 5.0, true)
        (:c, p[3], 6.0, true)
        ([:a, :b], p[1:2], [4.0, 5.0], true)
        ((:c, :b), (p[3], p[2]), (6.0, 5.0), true)
        ([:x, :a], [u[1], p[1]], [4.0, 5.0], false)
        ((:y, :b), (u[2], p[2]), (5.0, 6.0), true)
    ]
    get = getsym(fi, sym)
    set! = setsym(fi, sym)
    if check_inference
        @inferred get(fi)
    end
    @test get(fi) == oldval
    if check_inference
        @inferred set!(fi, newval)
    else
        set!(fi, newval)
    end
    @test get(fi) == newval

    newu = copy(state_values(fi))
    newp = copy(parameter_values(fi))

    set!(fi, oldval)
    @test get(fi) == oldval

    oop_setter = setsym_oop(sys, sym)
    uvals, pvals = oop_setter(fi, newval)
    @test uvals ≈ newu
    @test pvals ≈ newp
    @test_throws ArgumentError oop_setter(state_values(fi), newval)
    @test_throws ArgumentError oop_setter(parameter_values(fi), newval)
end

for (sym, val, check_inference) in [
        (:t, t, true),
        ([:x, :a, :t], [u[1], p[1], t], false),
        ((:x, :a, :t), (u[1], p[1], t), false),
    ]
    get = getsym(fi, sym)
    if check_inference
        @inferred get(fi)
    end
    @test get(fi) == val

    @test_throws NotVariableOrParameter setsym_oop(fi, sym)
end

struct FakeSolution{S, U, P, T}
    sys::S
    u::U
    p::P
    t::T
end

SymbolicIndexingInterface.is_timeseries(::Type{<:FakeSolution}) = Timeseries()
function SymbolicIndexingInterface.is_timeseries(
        ::Type{
            <:FakeSolution{
                S, U, P, Nothing,
            },
        }
    ) where {S, U, P}
    return NotTimeseries()
end
SymbolicIndexingInterface.symbolic_container(fp::FakeSolution) = fp.sys
SymbolicIndexingInterface.state_values(fp::FakeSolution) = fp.u
SymbolicIndexingInterface.parameter_values(fp::FakeSolution) = fp.p
SymbolicIndexingInterface.current_time(fp::FakeSolution) = fp.t

sys = SymbolCache([:x, :y, :z], [:a, :b, :c], [:t])
u = [[1.0, 2.0, 3.0], [4.0, 5.0, 6.0], [7.0, 8.0, 9.0], [10.0, 11.0, 12.0]]
t = [1.5, 2.0, 2.3, 4.0]
sol = FakeSolution(sys, u, p, t)

xvals = getindex.(sol.u, 1)
yvals = getindex.(sol.u, 2)
zvals = getindex.(sol.u, 3)

for (sym, ans, check_inference) in [
        (:x, xvals, true)
        (:y, yvals, true)
        (:z, zvals, true)
        (1, xvals, true)
        ([:x, :y], vcat.(xvals, yvals), true)
        (1:2, vcat.(xvals, yvals), true)
        ([:x, 2], vcat.(xvals, yvals), true)
        ((:z, :y), tuple.(zvals, yvals), true)
        ((3, 2), tuple.(zvals, yvals), true)
        (
            [:x, [:y, :z]],
            vcat.(xvals, [[x] for x in vcat.(yvals, zvals)]),
            false,
        )
        (
            [:x, (:y, :z)],
            vcat.(xvals, tuple.(yvals, zvals)), false,
        )
        (
            [1, (:y, :z)],
            vcat.(xvals, tuple.(yvals, zvals)), false,
        )
        (
            [:x, [:y, :z], (:x, :z)],
            vcat.(
                xvals, [[x] for x in vcat.(yvals, zvals)],
                tuple.(xvals, zvals)
            ),
            false,
        )
        (
            [:x, [:y, 3], (1, :z)],
            vcat.(
                xvals, [[x] for x in vcat.(yvals, zvals)],
                tuple.(xvals, zvals)
            ),
            false,
        )
        (
            (:x, [:y, :z]),
            tuple.(xvals, vcat.(yvals, zvals)), true,
        )
        (
            (:x, (:y, :z)),
            tuple.(xvals, tuple.(yvals, zvals)), true,
        )
        (
            (:x, [:y, :z], (:z, :y)),
            tuple.(
                xvals, vcat.(yvals, zvals),
                tuple.(zvals, yvals)
            ),
            true,
        )
        ([:x, :a], vcat.(xvals, p[1]), false)
        ((:y, :b), tuple.(yvals, p[2]), true)
        (:t, t, true)
        ([:x, :a, :t], vcat.(xvals, p[1], t), false)
        ((:x, :a, :t), tuple.(xvals, p[1], t), true)
    ]
    get = getsym(sys, sym)
    if check_inference
        @inferred get(sol)
    end
    @test get(sol) == ans
    for i in [
            rand(eachindex(u)), CartesianIndex(1), :,
            rand(Bool, length(u)), rand(eachindex(u), 3), 1:3,
        ]
        if check_inference
            @inferred get(sol, i)
        end
        @test get(sol, i) == ans[i]
    end
end

for (sym, val, check_inference) in [
        (:(x + y), xvals .+ yvals, true),
        ([:(x + y), :z], vcat.(xvals .+ yvals, zvals), false),
        ((:(x + y), :(z + y)), tuple.(xvals .+ yvals, yvals .+ zvals), false),
    ]
    get = getsym(sys, sym)
    if check_inference
        @inferred get(sol)
    end
    @test get(sol) == val
    for i in [
            rand(eachindex(u)), CartesianIndex(1), :,
            rand(Bool, length(u)), rand(eachindex(u), 3), 1:3,
        ]
        if check_inference
            @inferred get(sol, i)
        end
        @test get(sol, i) == val[i]
    end
end

for (sym, val) in [
        (:a, p[1])
        (:b, p[2])
        (:c, p[3])
        ([:a, :b], p[1:2])
        ((:c, :b), (p[3], p[2]))
    ]
    get = getsym(sys, sym)
    @inferred get(sol)
    @test get(sol) == val
end

let sol = sol, sys = sys
    getter = getsym(sys, [])
    @test getter(sol) == [[] for _ in 1:length(sol.t)]
    getter = getsym(sys, ())
    @test getter(sol) == [() for _ in 1:length(sol.t)]
    sc = SymbolCache(nothing, [:a, :b], :t)
    sol = FakeSolution(sys, [], [1.0, 2.0], [])
    getter = getsym(sc, [])
    @test getter(sol) == []
    getter = getsym(sc, ())
    @test getter(sol) == []
end

# A single `GetStateIndex` with a `Vector{Int}` idx — the shape downstream
# packages construct when binding an array-valued symbolic (e.g. `x(t)[1:3]`)
# to a single set of consecutive state indices. The non-`Int`/`CartesianIndex`
# `i` overload must broadcast the idx vector as a scalar across the timeseries
# rather than zipping it elementwise (otherwise a length-N timeseries against
# a length-K idx vector errors with `DimensionMismatch`).
let sol = sol
    idx = [1, 2]
    gsi = SymbolicIndexingInterface.GetStateIndex(idx)
    expected = [u_t[idx] for u_t in sol.u]
    @test gsi(Timeseries(), sol) == expected
    @test gsi(Timeseries(), sol, :) == expected
    @test gsi(Timeseries(), sol, 1:length(sol.u)) == expected
    @test gsi(Timeseries(), sol, eachindex(sol.u)) == expected
    @test gsi(Timeseries(), sol, trues(length(sol.u))) == expected
    @test gsi(Timeseries(), sol, 2) == sol.u[2][idx]
end

sys = SymbolCache([:x, :y, :z], [:a, :b, :c])
u = [1.0, 2.0, 3.0]
p = [10.0, 20.0, 30.0]
fs = FakeSolution(sys, u, p, nothing)
@test is_timeseries(fs) == NotTimeseries()

for (sym, val, check_inference) in [
        (:x, u[1], true),
        (1, u[1], true),
        ([:x, :y], u[1:2], true),
        ((:x, :y), Tuple(u[1:2]), true),
        (1:2, u[1:2], true),
        ([:x, 2], u[1:2], true),
        ((:x, 2), Tuple(u[1:2]), true),
        ([1, 2], u[1:2], true),
        ((1, 2), Tuple(u[1:2]), true),
        (:a, p[1], true),
        ([:a, :b], p[1:2], true),
        ((:a, :b), Tuple(p[1:2]), true),
        ([:x, :a], [u[1], p[1]], false),
        ((:x, :a), (u[1], p[1]), true),
        ([1, :a], [u[1], p[1]], false),
        ((1, :a), (u[1], p[1]), true),
        (:(x + y + a + b), u[1] + u[2] + p[1] + p[2], true),
        ([:(x + a), :(y + b)], [u[1] + p[1], u[2] + p[2]], true),
        ((:(x + a), :(y + b)), (u[1] + p[1], u[2] + p[2]), true),
    ]
    getter = getsym(sys, sym)
    if check_inference
        @inferred getter(fs)
    end
    @test getter(fs) == val
end

struct NonMarkovianWrapper{S <: SymbolCache}
    sys::S
end

SymbolicIndexingInterface.symbolic_container(hw::NonMarkovianWrapper) = hw.sys
SymbolicIndexingInterface.is_markovian(::NonMarkovianWrapper) = false
function SymbolicIndexingInterface.observed(hw::NonMarkovianWrapper, sym)
    return let inner = observed(hw.sys, sym)
        fn(u, h, p, t) = inner(u .+ h(t - 0.1), p, t)
    end
end
function SymbolicIndexingInterface.get_history_function(fs::FakeSolution)
    return t -> t .* ones(length(fs.u[1]))
end
function SymbolicIndexingInterface.get_history_function(fi::FakeIntegrator)
    return t -> t .* ones(length(fi.u))
end

sys = NonMarkovianWrapper(SymbolCache([:x, :y, :z], [:a, :b, :c], :t))
u0 = [1.0, 2.0, 3.0]
u = [u0 .* i for i in 1:11]
p = [10.0, 20.0, 30.0]
ts = 0.0:0.1:1.0

fi = FakeIntegrator(sys, u0, p, ts[1])
fs = FakeSolution(sys, u, p, ts)
getter = getsym(sys, :(x + y))
@test getter(fi) ≈ 2.8
@test getter(fs) ≈ [3.0i + 2(ts[i] - 0.1) for i in 1:11]
@test getter(fs, 1) ≈ 2.8

pstate = ProblemState(; u = u0, p = p, t = ts[1], h = t -> t .* ones(length(u0)))
@test getter(pstate) ≈ 2.8

struct TupleObservedWrapper{S}
    sys::S
end
SymbolicIndexingInterface.symbolic_container(t::TupleObservedWrapper) = t.sys
SymbolicIndexingInterface.supports_tuple_observed(::TupleObservedWrapper) = true

@testset "Tuple observed" begin
    sc = SymbolCache([:x, :y, :z], [:a, :b, :c])
    sys = TupleObservedWrapper(sc)
    ps = ProblemState(; u = [1.0, 2.0, 3.0], p = [0.1, 0.2, 0.3])
    getter = getsym(sys, (:(x + y), :(y + z)))
    @test all(getter(ps) .≈ (3.0, 5.0))
    @test getter(ps) isa Tuple
    @test_nowarn @inferred getter(ps)
    getter = getsym(sys, (:(a + b), :(b + c)))
    @test all(getter(ps) .≈ (0.3, 0.5))
    @test getter(ps) isa Tuple
    @test_nowarn @inferred getter(ps)

    sc = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)
    sys = TupleObservedWrapper(sc)
    ps = ProblemState(; u = [1.0, 2.0, 3.0], p = [0.1, 0.2, 0.3], t = 0.1)
    getter = getsym(sys, (:(x + y), :(y + t)))
    @test all(getter(ps) .≈ (3.0, 2.1))
    @test getter(ps) isa Tuple
    @test_nowarn @inferred getter(ps)
    getter = getsym(sys, (:(a + b), :(b + c)))
    @test all(getter(ps) .≈ (0.3, 0.5))
    @test getter(ps) isa Tuple
    @test_nowarn @inferred getter(ps)
end

struct MixedTSDiffEqArray
    t::Vector{Float64}
    u::Vector{Vector{Float64}}
end
SymbolicIndexingInterface.current_time(mda::MixedTSDiffEqArray) = mda.t
SymbolicIndexingInterface.state_values(mda::MixedTSDiffEqArray) = mda.u
SymbolicIndexingInterface.is_timeseries(::Type{MixedTSDiffEqArray}) = Timeseries()

struct MixedTSParameterObject
    p::Vector{Float64}
end
SymbolicIndexingInterface.parameter_values(mpo::MixedTSParameterObject) = mpo.p
function SymbolicIndexingInterface.with_updated_parameter_timeseries_values(
        ::SymbolCache, mpo::MixedTSParameterObject, args::Pair...
    )
    for (ts_idx, val) in args
        mpo.p[1 + ts_idx] = only(val)
    end
    return mpo
end
Base.getindex(mpo::MixedTSParameterObject, i) = mpo.p[i]

# A timeseries solution object with both continuous states and a parameter
# timeseries, used to test indexing observed variables that mix the two.
struct MixedTSSolution{S}
    sys::S
    u::Vector{Vector{Float64}}
    t::Vector{Float64}
    p::MixedTSParameterObject
    p_ts::ParameterTimeseriesCollection
end
SymbolicIndexingInterface.state_values(fs::MixedTSSolution) = fs.u
SymbolicIndexingInterface.current_time(fs::MixedTSSolution) = fs.t
SymbolicIndexingInterface.symbolic_container(fs::MixedTSSolution) = fs.sys
SymbolicIndexingInterface.parameter_values(fs::MixedTSSolution) = fs.p
SymbolicIndexingInterface.parameter_values(fs::MixedTSSolution, i) = fs.p[i]
SymbolicIndexingInterface.get_parameter_timeseries_collection(fs::MixedTSSolution) = fs.p_ts
SymbolicIndexingInterface.is_timeseries(::Type{<:MixedTSSolution}) = Timeseries()
SymbolicIndexingInterface.is_parameter_timeseries(::Type{<:MixedTSSolution}) = Timeseries()
SymbolicIndexingInterface.get_history_function(fs::MixedTSSolution) = t -> t .* ones(3)

@testset "Indexing mixed timeseries vars when one is continuous" begin
    sc = SymbolCache(
        [:x, :y, :z], [:a, :b], :t;
        timeseries_parameters = Dict(:b => ParameterTimeseriesIndex(1, 1))
    )
    b_ts = MixedTSDiffEqArray(collect(0.0:0.1:0.9), [[2.5i] for i in 1:10])
    p0 = MixedTSParameterObject([20.0, b_ts.u[end][1]])

    for sys in [sc, NonMarkovianWrapper(sc)]
        markovian = sys === sc
        u = [i * ones(3) for i in 1:5]
        t = [0.2i for i in 1:5]
        ptc = ParameterTimeseriesCollection([deepcopy(b_ts)], deepcopy(p0))
        fs = MixedTSSolution(sys, u, t, deepcopy(p0), ptc)

        xval = getindex.(fs.u, 1)
        bval_at_t = [parameter_values_at_time(sys, fs, ti)[2] for ti in fs.t]
        # `NonMarkovianWrapper`'s observed function adds `h(t - 0.1)` to the
        # state before calling the underlying observed function.
        hval_at_t = markovian ? zeros(length(fs.t)) : [ti - 0.1 for ti in fs.t]
        expected = xval .+ hval_at_t .+ bval_at_t

        getter = getsym(sys, :(x + b))
        @test is_indexer_timeseries(getter) == IndexerMixedTimeseries()
        @test getter(fs) ≈ expected
        for subidx in [
                1, CartesianIndex(2), :, rand(Bool, length(fs.t)),
                rand(eachindex(fs.t), 3), 1:3,
            ]
            target = subidx isa Colon ? expected : expected[subidx]
            @test getter(fs, subidx) ≈ target
        end
    end

    # A `TimeDependentObservedFunction` is only ever constructed by `getsym`
    # when its combined timeseries indexes include `ContinuousTimeseries()`
    # (that's the only case where it makes sense to hold parameter timeseries
    # values fixed while iterating over the continuous timeseries). Directly
    # constructing one without `ContinuousTimeseries()` in `ts_idxs` should
    # still throw, since there is no continuous timeseries to iterate over.
    o = TimeDependentObservedFunction{true}([1, 2], (u, p, t) -> u[1] + p[2])
    b_ts = MixedTSDiffEqArray(collect(0.0:0.1:0.9), [[2.5i] for i in 1:10])
    p0 = MixedTSParameterObject([20.0, b_ts.u[end][1]])
    fs = MixedTSSolution(
        sc, [i * ones(3) for i in 1:5], [0.2i for i in 1:5], deepcopy(p0),
        ParameterTimeseriesCollection([deepcopy(b_ts)], deepcopy(p0))
    )
    @test_throws MixedParameterTimeseriesIndexError o(Timeseries(), fs)
end

using SymbolicIndexingInterface
using Test

sys = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)
prob = ProblemState(;
    u = [1.0, 2.0, 3.0], p = [0.1, 0.2, 0.3], t = 0.5, h = Returns(ones(3))
)

for (i, sym) in enumerate(variable_symbols(sys))
    @test getsym(sys, sym)(prob) == prob.u[i]
end
for (i, sym) in enumerate(parameter_symbols(sys))
    @test getp(sys, sym)(prob) == prob.p[i]
end
@test getsym(sys, :t)(prob) == prob.t

@test getsym(sys, :(x + a + t))(prob) == 1.6

@test get_history_function(prob) !== nothing

"""
    remake_buffer(indp, oldbuffer, idxs, vals)

Return a copy of the buffer `oldbuffer` with at (optionally symbolic) indexes `idxs`
replaced by corresponding values from `vals`. Both `idxs` and `vals` must be iterables of
the same length. `idxs` may contain symbolic variables whose index in the buffer is
determined using `indp`. The types of values in `vals` may not match the types of values
stored at the corresponding indexes in the buffer, in which case the type of the buffer
should be promoted accordingly. In general, this method should attempt to preserve the
types of values stored in `vals` as much as possible. Types can be promoted for
type-stability, to maintain performance. The returned buffer should be of the same type
(ignoring type-parameters) as `oldbuffer`.

This method is already implemented for `oldbuffer::AbstractArray` and `oldbuffer::Tuple`,
and supports static arrays as well.

The deprecated version of this method which takes a `Dict` mapping symbols to values
instead of `idxs` and `vals` will dispatch to the new method. In addition if
no `remake_buffer` method exists with the new signature, it will call
`remake_buffer(sys, oldbuffer, Dict(idxs .=> vals))`.

Note that the new method signature allows `idxs` to be indexes, instead of requiring
that they be symbolic variables. Thus, any type which implements the new method must
also support indexes in `idxs`.
"""
function remake_buffer(sys, oldbuffer::AbstractArray, idxs, vals)
    # similar when used with an `MArray` and nonconcrete eltype returns a
    # SizedArray. `similar_type` still returns an `MArray`
    if ArrayInterface.ismutable(oldbuffer) && !isa(oldbuffer, MArray)
        elT = Union{}
        for val in vals
            if val isa AbstractArray
                valT = eltype(val)
            else
                valT = typeof(val)
            end
            elT = promote_type(elT, valT)
        end

        newbuffer = similar(oldbuffer, elT)
        copyto!(newbuffer, oldbuffer)
        for (k, v) in zip(idxs, vals)
            is_variable(sys, k) || is_parameter(sys, k) || continue
            if v isa AbstractArray
                v = elT.(v)
            else
                v = elT(v)
            end
            setsym(sys, k)(newbuffer, v)
        end
    else
        mutbuffer = remake_buffer(sys, collect(oldbuffer), idxs, vals)
        newbuffer = similar_type(oldbuffer, eltype(mutbuffer))(mutbuffer)
    end
    return newbuffer
end

# We don't support `Dict`s as value providers. If we get a `Dict`,
# assume it is non-symbolic.
function remake_buffer(sys, oldbuffer::Dict, idxs, vals)
    return Dict(idxs .=> vals)
end

remake_buffer(sys, ::Nothing, idxs, vals) = nothing

function remake_buffer(sys, oldbuffer, idxs, vals)
    return remake_buffer(sys, oldbuffer, Dict(idxs .=> vals))
end

mutable struct TupleRemakeWrapper
    t::Tuple
end

function set_parameter!(sys::TupleRemakeWrapper, val, idx)
    tp = sys.t
    @reset tp[idx] = val
    return sys.t = tp
end

function set_state!(sys::TupleRemakeWrapper, val, idx)
    tp = sys.t
    @reset tp[idx] = val
    return sys.t = tp
end

function remake_buffer(sys, oldbuffer::Tuple, idxs, vals)
    wrap = TupleRemakeWrapper(oldbuffer)
    for (idx, val) in zip(idxs, vals)
        setsym(sys, idx)(wrap, val)
    end
    return wrap.t
end

@deprecate remake_buffer(sys, oldbuffer, vals::Dict) remake_buffer(
    sys, oldbuffer, keys(vals), values(vals)
)
@deprecate remake_buffer(sys, oldbuffer::Tuple, vals::Dict) remake_buffer(
    sys, oldbuffer, keys(vals), values(vals)
)

using SymbolicIndexingInterface
using SciMLTesting
using Test

# ExplicitImports only sees an extension module once its trigger package is loaded, so
# load every weakdep here to bring the extensions into the QA scan.
using PrettyTables

# ExplicitImports silently skips an extension that fails to load, so assert the
# extension modules actually exist rather than trusting a green run_qa.
@testset "Extensions loaded" begin
    @test Base.get_extension(SymbolicIndexingInterface, :SymbolicIndexingInterfacePrettyTablesExt) !== nothing
end

run_qa(
    SymbolicIndexingInterface;
    ei_kwargs = (;
        all_explicit_imports_are_public = (; ignore = (:similar_type,)),
    ),
)

###########
# Parameter Indexing
###########

"""
    parameter_values(valp)
    parameter_values(valp, i)

Return an indexable collection containing the value of each parameter in `valp`. The two-
argument version of this function returns the parameter value at index `i`. The
two-argument version of this function will default to returning
`parameter_values(valp)[i]`.

If this function is called with an `AbstractArray` or `Tuple`, it will return the same
array/tuple.
"""
function parameter_values end

parameter_values(arr::AbstractArray) = arr
parameter_values(arr::Tuple) = arr
parameter_values(arr::AbstractArray, i) = arr[i]
parameter_values(arr::Tuple, i) = arr[i]
parameter_values(prob, i) = parameter_values(parameter_values(prob), i)

"""
    get_parameter_timeseries_collection(valp)

Return the [`ParameterTimeseriesCollection`](@ref) contained in timeseries value provider
`valp`. Valid only for value providers where [`is_parameter_timeseries`](@ref) returns
[`Timeseries`](@ref).
"""
function get_parameter_timeseries_collection end

"""
    with_updated_parameter_timeseries_values(indp, params, args::Pair...)

Return an indexable collection containing the value of all parameters in `params`, with
parameters belonging to specific timeseries updated to different values. Each element in
`args...` contains the timeseries index as the first value, and the saved parameter values
in that partition. Not all parameter timeseries have to be updated using this method. If
an in-place update can be performed, it should be done and the modified `params` returned.
This method falls back on the basis of `symbolic_container(indp)`.

Note that here `params` is the parameter object.
"""
function with_updated_parameter_timeseries_values(indp, params, args...)
    return with_updated_parameter_timeseries_values(
        symbolic_container(indp), params, args...
    )
end

"""
    set_parameter!(valp, val, idx)

Set the parameter at index `idx` to `val` for value provider `valp`. This defaults to
modifying `parameter_values(valp)`. If any additional bookkeeping needs to be performed
or the default implementation does not work for a particular type, this method needs to
be defined to enable the proper functioning of [`setp`](@ref).

See: [`parameter_values`](@ref)
"""
function set_parameter! end

# Tuple only included for the error message
function set_parameter!(sys::Union{AbstractArray, Tuple}, val, idx)
    return sys[idx] = val
end
set_parameter!(sys, val, idx) = set_parameter!(parameter_values(sys), val, idx)

"""
    finalize_parameters_hook!(valp, sym)

This is a callback run one for each call to the function returned by [`setp`](@ref)
which can be used to update internal data structures when parameters are modified.
This is in contrast to [`set_parameter!`](@ref) which is run once for each parameter
that is updated.
"""
finalize_parameters_hook!(valp, sym) = nothing

###########
# State Indexing
###########

"""
    state_values(valp)
    state_values(valp, i)

Return an indexable collection containing the values of all states in the value provider
`p`. If `is_timeseries(valp)` is [`Timeseries`](@ref), return a vector of arrays,
each of which contain the state values at the corresponding timestep. In this case, the
two-argument version of the function can also be implemented to efficiently return
the state values at timestep `i`. By default, the two-argument method calls
`state_values(valp)[i]`. If `i` consists of multiple indices (for example, `Colon`,
`AbstractArray{Int}`, `AbstractArray{Bool}`) specialized methods may be defined for
efficiency. By default, `state_values(valp, ::Colon) = state_values(valp)` to avoid
copying the timeseries.

If this function is called with an `AbstractArray`, it will return the same array.

See: [`is_timeseries`](@ref)
"""
function state_values end

state_values(arr::AbstractArray) = arr
state_values(arr, i) = state_values(arr)[i]
state_values(arr, ::Colon) = state_values(arr)

"""
    set_state!(valp, val, idx)

Set the state at index `idx` to `val` for value provider `valp`. This defaults to modifying
`state_values(valp)`. If any additional bookkeeping needs to be performed or the
default implementation does not work for a particular type, this method needs to be
defined to enable the proper functioning of [`setsym`](@ref).

See: [`state_values`](@ref)
"""
function set_state! end

"""
    current_time(valp)
    current_time(valp, i)

Return the current time in the value provider `valp`. If
`is_timeseries(valp)` is [`Timeseries`](@ref), return the vector of timesteps at which
the state value is saved. In this case, the two-argument version of the function can
also be implemented to efficiently return the time at timestep `i`. By default, the two-
argument method calls `current_time(p)[i]`. It is assumed that the timeseries is sorted
in increasing order.

If `i` consists of multiple indices (for example, `Colon`, `AbstractArray{Int}`,
`AbstractArray{Bool}`) specialized methods may be defined for efficiency. By default,
`current_time(valp, ::Colon) = current_time(valp)` to avoid copying the timeseries.

By default, the single-argument version acts as the identity function if
`valp isa AbstractVector`.

See: [`is_timeseries`](@ref)
"""
function current_time end

current_time(arr::AbstractVector) = arr
current_time(valp, i) = current_time(valp)[i]
current_time(valp, ::Colon) = current_time(valp)

"""
    get_history_function(valp)

Return the history function for a value provider. This is required for all value providers
associated with an index provider `indp` for which `!is_markovian(indp)`.

See also: [`is_markovian`](@ref).
"""
function get_history_function end

###########
# Utilities
###########

abstract type AbstractIndexer end

abstract type AbstractGetIndexer <: AbstractIndexer end
abstract type AbstractStateGetIndexer <: AbstractGetIndexer end
abstract type AbstractParameterGetIndexer <: AbstractGetIndexer end
abstract type AbstractSetIndexer <: AbstractIndexer end

(ai::AbstractStateGetIndexer)(prob) = ai(is_timeseries(prob), prob)
(ai::AbstractStateGetIndexer)(prob, i) = ai(is_timeseries(prob), prob, i)
(ai::AbstractParameterGetIndexer)(prob) = ai(is_parameter_timeseries(prob), prob)
(ai::AbstractParameterGetIndexer)(prob, i) = ai(is_parameter_timeseries(prob), prob, i)
function (ai::AbstractParameterGetIndexer)(buffer::AbstractArray, prob)
    # It's ambiguous whether `buffer` is the value provider or `prob`. `getter(sol, 4)`
    # hits this method because `DiffEqArray <: AbstractArray`.
    if is_parameter_timeseries(buffer) isa Timeseries
        return ai(Timeseries(), buffer, prob)
    else
        return ai(buffer, is_parameter_timeseries(prob), prob)
    end
end
function (ai::AbstractParameterGetIndexer)(buffer::AbstractArray, prob, i)
    return ai(buffer, is_parameter_timeseries(prob), prob, i)
end

abstract type IndexerTimeseriesType end

# Can only index parameter timeseries
struct IndexerOnlyTimeseries <: IndexerTimeseriesType end
# Can only index non-timeseries objects
struct IndexerMixedTimeseries <: IndexerTimeseriesType end
# Can index timeseres and non-timeseries objects, has the same value at all times
struct IndexerNotTimeseries <: IndexerTimeseriesType end
# Value changes over time, can index timeseries and non-timeseries objects
struct IndexerBoth <: IndexerTimeseriesType end

is_indexer_timeseries(x) = is_indexer_timeseries(typeof(x))
function indexer_timeseries_index end

const AtLeastTimeseriesIndexer = Union{IndexerOnlyTimeseries, IndexerBoth}
const AtLeastNotTimeseriesIndexer = Union{IndexerNotTimeseries, IndexerBoth}

as_timeseries_indexer(x) = as_timeseries_indexer(is_indexer_timeseries(x), x)
as_timeseries_indexer(::IndexerOnlyTimeseries, x) = x
as_timeseries_indexer(::IndexerNotTimeseries, x) = x
as_not_timeseries_indexer(x) = as_not_timeseries_indexer(is_indexer_timeseries(x), x)
as_not_timeseries_indexer(::IndexerNotTimeseries, x) = x

function _postprocess_tsidxs(ts_idxs)
    delete!(ts_idxs, ContinuousTimeseries())
    if isempty(ts_idxs)
        return nothing
    elseif length(ts_idxs) == 1
        return only(ts_idxs)
    else
        return collect(ts_idxs)
    end
end

struct CallWith{A}
    args::A

    CallWith(args...) = new{typeof(args)}(args)
end

function (cw::CallWith)(arg)
    return arg(cw.args...)
end

function _call(f, args...)
    return f(args...)
end

struct Fix1Multiple{F, A}
    f::F
    arg::A
end

function (fn::Fix1Multiple)(args...)
    return fn.f(fn.arg, args...)
end

struct OOPSetter{S, I, D}
    indp::I
    idxs::D
end

"""
    TypeGroupedIndexes(idxs::AbstractVector)

Indexes from an abstractly-typed vector partitioned into concretely typed
groups, preserving first-occurrence order. Each group is a tuple of the
concretely typed index vector, the positions of its entries in the original
collection, and the same positions encoded as a `Val` so `Tuple`s of values
can be subset type-stably. `remake_buffer` implementations that compute
buffer eltype promotion from `eltype(idxs)` (e.g. for `MTKParameters`)
require concretely typed index collections; applying `remake_buffer` once
per group satisfies that without splatting the indexes into a `Tuple`, whose
length would scale codegen with the number of indexes.
"""
struct TypeGroupedIndexes{G <: Tuple}
    groups::G
end

# Contiguous position runs are stored as a `UnitRange` so their `Val`-encoded
# form does not scale the setter's type size with the number of indexes.
function _compact_positions(positions::Vector{Int})
    r = first(positions):last(positions)
    return positions == r ? r : positions
end

function TypeGroupedIndexes(idxs::AbstractVector)
    group_idxs = []
    group_positions = Vector{Int}[]
    for (i, idx) in enumerate(idxs)
        gi = findfirst(g -> typeof(first(g)) == typeof(idx), group_idxs)
        if gi === nothing
            push!(group_idxs, [idx])
            push!(group_positions, [i])
        else
            push!(group_idxs[gi], idx)
            push!(group_positions[gi], i)
        end
    end
    groups = map(group_idxs, group_positions) do gidxs, positions
        positions = _compact_positions(positions)
        (gidxs, positions, Val(positions isa UnitRange ? positions : Tuple(positions)))
    end
    return TypeGroupedIndexes(Tuple(groups))
end

function OOPSetter(indp, idxs, isstate)
    if idxs isa AbstractVector && !isconcretetype(eltype(idxs)) && !isempty(idxs)
        idxs = TypeGroupedIndexes(idxs)
    end
    return OOPSetter{isstate, typeof(indp), typeof(idxs)}(indp, idxs)
end

_subset_values(val::AbstractArray, positions, _) = val[positions]
# subsetting a (possibly heterogeneous) `Tuple` of values is only inferrable
# with the positions available as compile-time constants, hence the `Val`
function _subset_values(val::Tuple, positions, ::Val{P}) where {P}
    return ntuple(i -> val[P[i]], Val(length(P)))
end

_remake_buffer_grouped(indp, buffer, ::Tuple{}, val) = buffer
function _remake_buffer_grouped(indp, buffer, groups::Tuple, val)
    idxs, positions, static_positions = first(groups)
    vals = _subset_values(val, positions, static_positions)
    buffer = remake_buffer(indp, buffer, idxs, vals)
    return _remake_buffer_grouped(indp, buffer, Base.tail(groups), val)
end

function (os::OOPSetter{true})(valp, val)
    buffer = hasmethod(state_values, Tuple{typeof(valp)}) ? state_values(valp) : valp
    return remake_buffer(os.indp, buffer, (os.idxs,), (val,))
end

function (os::OOPSetter{false})(valp, val)
    buffer = hasmethod(parameter_values, Tuple{typeof(valp)}) ? parameter_values(valp) :
        valp
    return remake_buffer(os.indp, buffer, (os.idxs,), (val,))
end

function (os::OOPSetter{true})(valp, val::Union{Tuple, AbstractArray})
    buffer = hasmethod(state_values, Tuple{typeof(valp)}) ? state_values(valp) : valp
    if os.idxs isa Union{Tuple, AbstractArray}
        return remake_buffer(os.indp, buffer, os.idxs, val)
    else
        return remake_buffer(os.indp, buffer, (os.idxs,), (val,))
    end
end

function (os::OOPSetter{false})(valp, val::Union{Tuple, AbstractArray})
    buffer = hasmethod(parameter_values, Tuple{typeof(valp)}) ? parameter_values(valp) :
        valp
    if os.idxs isa Union{Tuple, AbstractArray}
        return remake_buffer(os.indp, buffer, os.idxs, val)
    else
        return remake_buffer(os.indp, buffer, (os.idxs,), (val,))
    end
end

function (os::OOPSetter{true, I, <:TypeGroupedIndexes})(
        valp, val::Union{Tuple, AbstractArray}
    ) where {I}
    buffer = hasmethod(state_values, Tuple{typeof(valp)}) ? state_values(valp) : valp
    return _remake_buffer_grouped(os.indp, buffer, os.idxs.groups, val)
end

function (os::OOPSetter{false, I, <:TypeGroupedIndexes})(
        valp, val::Union{Tuple, AbstractArray}
    ) where {I}
    buffer = hasmethod(parameter_values, Tuple{typeof(valp)}) ? parameter_values(valp) :
        valp
    return _remake_buffer_grouped(os.indp, buffer, os.idxs.groups, val)
end

function _root_indp(indp)
    if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        return _root_indp(sc)
    else
        return indp
    end
end

###########
# Errors
###########

struct ParameterTimeseriesValueIndexMismatchError{P <: IsTimeseriesTrait} <: Exception
    valp::Any
    indexer::Any
    args::Any

    function ParameterTimeseriesValueIndexMismatchError{Timeseries}(valp, indexer, args)
        if is_parameter_timeseries(valp) != Timeseries()
            throw(
                ArgumentError(
                    """
                        This should never happen. Expected parameter timeseries value provider, \
                    got $(valp). Open an issue in SymbolicIndexingInterface.jl with an MWE.
                    """
                )
            )
        end
        return new{Timeseries}(valp, indexer, args)
    end
    function ParameterTimeseriesValueIndexMismatchError{NotTimeseries}(valp, indexer)
        if is_parameter_timeseries(valp) != NotTimeseries()
            throw(
                ArgumentError(
                    """
                        This should never happen. Expected non-parameter timeseries value \
                    provider, got $(valp). Open an issue in SymbolicIndexingInterface.jl \
                    with an MWE.
                    """
                )
            )
        end
        if is_indexer_timeseries(indexer) != IndexerOnlyTimeseries()
            throw(
                ArgumentError(
                    """
                        This should never happen. Expected timeseries indexer, got $(indexer). \
                    Open an issue in SymbolicIndexingInterface.jl with an MWE.
                    """
                )
            )
        end
        return new{NotTimeseries}(valp, indexer, nothing)
    end
end

function Base.showerror(io::IO, err::ParameterTimeseriesValueIndexMismatchError{Timeseries})
    return print(
        io, """
            Invalid indexing operation: tried to access object of type $(typeof(err.valp)) \
        (which is a parameter timeseries object) with non-timeseries indexer \
        $(err.indexer) at index $(err.args) in the timeseries.
        """
    )
end

function Base.showerror(
        io::IO, err::ParameterTimeseriesValueIndexMismatchError{NotTimeseries}
    )
    return print(
        io, """
            Invalid indexing operation: tried to access object of type $(typeof(err.valp)) \
        (which is not a parameter timeseries object) using timeseries indexer \
        $(err.indexer).
        """
    )
end

struct MixedParameterTimeseriesIndexError <: Exception
    obj::Any
    ts_idxs::Any
end

function Base.showerror(io::IO, err::MixedParameterTimeseriesIndexError)
    return print(
        io, """
            Invalid indexing operation: tried to access object of type $(typeof(err.obj)) \
        (which is a parameter timeseries object) with variables having mixed timeseries \
        indexes $(err.ts_idxs).
        """
    )
end

struct NotVariableOrParameter <: Exception
    fn::Any
    sym::Any
end

function Base.showerror(io::IO, err::NotVariableOrParameter)
    return print(
        io, """
            `$(err.fn)` requires that the symbolic variable(s) passed to it satisfy `is_variable`
            or `is_parameter`. Got `$(err.sym)` which is neither.
        """
    )
end

function MustBeBothStateAndParameterProviderError(missing_state::Bool)
    return ArgumentError(
        """
        A setter returned from `setsym_oop` must be called with a value provider that \
        contains both states and parameters. The given value provided does not \
        implement `$(missing_state ? "state_values" : "parameter_values")`.
        """
    )
end

function check_both_state_and_parameter_provider(valp)
    if !hasmethod(state_values, Tuple{typeof(valp)}) || state_values(valp) === valp
        throw(MustBeBothStateAndParameterProviderError(true))
    end
    return if !hasmethod(parameter_values, Tuple{typeof(valp)}) || parameter_values(valp) === valp
        throw(MustBeBothStateAndParameterProviderError(false))
    end
end

"""
    struct ParameterIndexingProxy

This struct wraps any struct implementing the value provider and index provider interfaces.
It allows `getindex` and `setindex!` operations to get/set parameter values. Requires that
the wrapped type support [`getp`](@ref) and [`setp`](@ref) for getting and setting
parameter values respectively.
"""
struct ParameterIndexingProxy{T}
    wrapped::T
end

function Base.getindex(p::ParameterIndexingProxy, idx, args...)
    return getp(p.wrapped, idx)(p.wrapped, args...)
end

function Base.setindex!(p::ParameterIndexingProxy, val, idx)
    return setp(p.wrapped, idx)(p.wrapped, val)
end

function Base.show(io::IO, ::MIME"text/plain", pip::ParameterIndexingProxy)
    return show_params(io, pip; num_rows = 20, show_all = false, scalarize = true)
end

"""
    show_params(io::IO, pip::ParameterIndexingProxy; num_rows = 20, show_all = false, scalarize = true, kwargs...)

Method for customizing the table output. Keyword args:
- num_rows
- show_all: whether to show all parameters. Overrides `num_rows`.
- scalarize: whether to scalarize array symbolics in the table output.
- kwargs... are passed to the pretty_table call (if PrettyTables is loaded).
"""
show_params(io, pip; kwargs...) = _show_params(io, pip; kwargs...)

# Fallback implementation when PrettyTables is not loaded
function _show_params(
        io::IO, pip::ParameterIndexingProxy; num_rows = 20,
        show_all = false, scalarize = true, kwargs...
    )
    params = Any[]
    vals = Any[]
    for p in parameter_symbols(pip.wrapped)
        if symbolic_type(p) === ArraySymbolic() && scalarize
            val = getp(pip.wrapped, p)(pip.wrapped)
            for (_p, _v) in zip(collect(p), val)
                push!(params, _p)
                push!(vals, _v)
            end
        else
            push!(params, p)
            val = getp(pip.wrapped, p)(pip.wrapped)
            push!(vals, val)
        end
    end

    num_shown = if show_all
        length(params)
    else
        if num_rows > length(params)
            length(params)
        else
            num_rows
        end
    end

    # Fallback implementation without PrettyTables
    println(io, "Parameter Indexing Proxy")
    println(io, "="^50)
    println(io, "Parameter                | Value")
    println(io, "-"^50)
    for i in 1:num_shown
        println(io, rpad(string(params[i]), 24) * " | " * string(vals[i]))
    end

    return if num_shown < length(params)
        println(
            io,
            "$num_shown of $(length(params)) params shown. To show all the parameters, call `show_params(io, ps, show_all = true)`. Adjust the number of rows with the num_rows kwarg. Consult `show_params` docstring for more options."
        )
    end
end

using SymbolicIndexingInterface
using SymbolicIndexingInterface: parameter_timeseries
using Test

struct MyDiffEqArray
    t::Vector{Float64}
    u::Vector{Vector{Float64}}
end
SymbolicIndexingInterface.current_time(mda::MyDiffEqArray) = mda.t
SymbolicIndexingInterface.state_values(mda::MyDiffEqArray) = mda.u
SymbolicIndexingInterface.is_timeseries(::Type{MyDiffEqArray}) = Timeseries()

ps = ones(3)
@test_throws ArgumentError ParameterTimeseriesCollection((ones(3), 2ones(3)), ps)

a_timeseries = MyDiffEqArray(collect(0:0.1:0.9), [[2.5i, sin(0.2i)] for i in 1:10])
b_timeseries = MyDiffEqArray(collect(0:0.25:0.9), [[3.5i, log(1.3i)] for i in 1:4])
c_timeseries = MyDiffEqArray(collect(0:0.17:0.9), [[4.3i] for i in 1:5])
collection = (a_timeseries, b_timeseries, c_timeseries)
ptc = ParameterTimeseriesCollection(collection, ps)

@test collect(eachindex(ptc)) == [1, 2, 3]
@test [x for x in ptc] == [a_timeseries, b_timeseries, c_timeseries]
@test length(ptc) == 3
@test parent(ptc) === collection
@test parameter_values(ptc) === ps

for i in 1:3
    @test ptc[i] === collection[i]
    @test parameter_timeseries(ptc, i) == collection[i].t
    for j in eachindex(collection[i].u[1])
        pti = ParameterTimeseriesIndex(i, j)
        @test ptc[pti] == getindex.(collection[i].u, j)
        for k in eachindex(collection[i].u)
            rhs = collection[i].u[k][j]
            @test ptc[pti, CartesianIndex(k)] == rhs
            @test ptc[pti, k] == rhs
            @test ptc[i, k] == collection[i].u[k]
            @test ptc[i, k, j] == rhs
            @test parameter_values(ptc, pti, k) == rhs
        end
        allidxs = eachindex(collection[i].u)
        for subidx in [:, rand(allidxs, 3), rand(Bool, length(allidxs))]
            rhs = getindex.(collection[i].u[subidx], j)
            @test ptc[pti, subidx] == rhs
            @test ptc[i, subidx, j] == rhs
            @test parameter_values(ptc, pti, subidx) == rhs
        end
    end
end

"""
    struct BatchedInterface{S <: AbstractVector, I}
    function BatchedInterface(indp_syms::Tuple...)

A struct which stores information for batched calls to [`getsym`](@ref) or [`setsym`](@ref).
Given `Tuple`s, where the first element of each tuple is an index provider and the second
an array of symbolic variables (either states or parameters) in the index provider,
`BatchedInterface` will compute the union of all symbols and associate each symbol with
the first index provider with which it occurs.

For example, given two index providers `s1 = SymbolCache([:x, :y, :z])` and
`s2 = SymbolCache([:y, :z, :w])`, `BatchedInterface((s1, [:x, :y]), (s2, [:y, :z]))` will
associate `:x` and `:y` with `s1` and `:z` with `s2`. The information that `s1` had
associated symbols `:x` and `:y` and `s2` had associated symbols `:y` and `:z` will also
be retained internally.

`BatchedInterface` implements [`variable_symbols`](@ref), [`is_variable`](@ref),
[`variable_index`](@ref) to query the order of symbols in the union.

See [`getsym`](@ref) and [`setsym`](@ref) for further details.

See also: [`associated_systems`](@ref).
"""
struct BatchedInterface{S <: AbstractVector, I, T, P}
    "Order of symbols in the union."
    symbol_order::S
    "Index of the index provider each symbol in the union is associated with."
    associated_systems::Vector{Int}
    "Index of symbol in the index provider it is associated with."
    associated_indexes::I
    "Whether the symbol is a state in the index provider it is associated with."
    isstate::BitVector
    "Map from index provider to indexes of its symbols in the union."
    system_to_symbol_subset::Vector{Vector{Int}}
    "Map from index provider to indexes of its symbols in the index provider."
    system_to_symbol_indexes::Vector{Vector{T}}
    "Map from index provider to whether each of its symbols is a state in the index provider."
    system_to_isstate::Vector{BitVector}
    "Index providers, in order"
    index_providers::Vector{P}
end

function BatchedInterface(syssyms::Tuple...)
    symbol_order = []
    associated_systems = Int[]
    associated_indexes = []
    isstate = BitVector()
    system_to_symbol_subset = Vector{Int}[]
    system_to_symbol_indexes = []
    system_to_isstate = BitVector[]
    index_providers = []
    for (i, (sys, syms)) in enumerate(syssyms)
        symbol_subset = Int[]
        symbol_indexes = []
        system_isstate = BitVector()
        allsyms = []
        root_indp = sys
        while applicable(symbolic_container, root_indp) &&
                (sc = symbolic_container(root_indp)) != root_indp
            root_indp = sc
        end
        push!(index_providers, root_indp)
        for sym in syms
            if symbolic_type(sym) === NotSymbolic()
                error("Only symbolic variables allowed in BatchedInterface.")
            end
            if symbolic_type(sym) === ArraySymbolic()
                append!(allsyms, collect(sym))
            else
                push!(allsyms, sym)
            end
        end
        for sym in allsyms
            if !is_variable(sys, sym) && !is_parameter(sys, sym)
                error("Only variables and parameters allowed in BatchedInterface.")
            end
            if !any(isequal(sym), symbol_order)
                push!(symbol_order, sym)
                push!(associated_systems, i)
                push!(isstate, is_variable(sys, sym))
                if isstate[end]
                    push!(associated_indexes, variable_index(sys, sym))
                else
                    push!(associated_indexes, parameter_index(sys, sym))
                end
            end
            push!(symbol_subset, findfirst(isequal(sym), symbol_order))
            push!(system_isstate, is_variable(sys, sym))
            push!(
                symbol_indexes,
                system_isstate[end] ? variable_index(sys, sym) : parameter_index(sys, sym)
            )
        end
        push!(system_to_symbol_subset, symbol_subset)
        push!(system_to_symbol_indexes, identity.(symbol_indexes))
        push!(system_to_isstate, system_isstate)
    end
    symbol_order = identity.(symbol_order)
    associated_indexes = identity.(associated_indexes)
    system_to_symbol_indexes = identity.(system_to_symbol_indexes)

    return BatchedInterface{
        typeof(symbol_order), typeof(associated_indexes),
        eltype(eltype(system_to_symbol_indexes)), eltype(index_providers),
    }(
        symbol_order, associated_systems, associated_indexes, isstate,
        system_to_symbol_subset, system_to_symbol_indexes, system_to_isstate,
        identity.(index_providers)
    )
end

variable_symbols(bi::BatchedInterface) = bi.symbol_order
variable_index(bi::BatchedInterface, sym) = findfirst(isequal(sym), bi.symbol_order)
is_variable(bi::BatchedInterface, sym) = variable_index(bi, sym) !== nothing

"""
    associated_systems(bi::BatchedInterface)

Return an array of integers of the same length as `variable_symbols(bi)` where each value
is the index of the index provider associated with the corresponding symbol in
`variable_symbols(bi)`.
"""
associated_systems(bi::BatchedInterface) = bi.associated_systems

"""
    getsym(bi::BatchedInterface)

Given a [`BatchedInterface`](@ref) composed from `n` index providers (and corresponding
symbols), return a function which takes `n` corresponding value providers and returns an
array of the values of the symbols in the union. The returned function can also be passed
an `AbstractArray` of the appropriate `eltype` and size as its first argument, in which
case the operation will populate the array in-place with the values of the symbols in the
union.

Note that all of the value providers passed to the function returned by `getsym` must satisfy
`is_timeseries(prob) === NotTimeseries()`.

The value of the `i`th symbol in the union (obtained through `variable_symbols(bi)[i]`) is
obtained from the problem corresponding to the associated index provider (i.e. the value
provider at index `associated_systems(bi)[i]`).

See also: [`variable_symbols`](@ref), [`associated_systems`](@ref), [`is_timeseries`](@ref),
[`NotTimeseries`](@ref).
"""
function getsym(bi::BatchedInterface)
    numprobs = length(bi.system_to_symbol_subset)
    probnames = [Symbol(:prob, i) for i in 1:numprobs]

    fnbody = quote end
    for (i, (prob, idx, isstate)) in enumerate(
            zip(
                bi.associated_systems, bi.associated_indexes, bi.isstate
            )
        )
        symname = Symbol(:sym, i)
        getter = isstate ? state_values : parameter_values
        probname = probnames[prob]
        push!(fnbody.args, :($symname = $getter($probname, $idx)))
    end

    oop_expr = Expr(:vect)
    for i in 1:length(bi.symbol_order)
        push!(oop_expr.args, Symbol(:sym, i))
    end

    iip_expr = quote end
    for i in 1:length(bi.symbol_order)
        symname = Symbol(:sym, i)
        push!(iip_expr.args, :(out[$i] = $symname))
    end

    oopfn = Expr(
        :function,
        Expr(:tuple, probnames...),
        quote
            $fnbody
            $oop_expr
        end
    )
    iipfn = Expr(
        :function,
        Expr(:tuple, :out, probnames...),
        quote
            $fnbody
            $iip_expr
            out
        end
    )

    return let oop = @RuntimeGeneratedFunction(oopfn),
            iip = @RuntimeGeneratedFunction(iipfn)

        _getter(probs...) = oop(probs...)
        _getter(out::AbstractArray, probs...) = iip(out, probs...)
        _getter
    end
end

"""
    setsym(bi::BatchedInterface)

Given a [`BatchedInterface`](@ref) composed from `n` index providers (and corresponding
symbols), return a function which takes `n` corresponding problems and an array of the
values, and updates each of the problems with the values of the corresponding symbols.

Note that all of the value providers passed to the function returned by `setsym` must satisfy
`is_timeseries(prob) === NotTimeseries()`.

Note that if any subset of the `n` index providers share common symbols (among those passed
to `BatchedInterface`) then all of the corresponding value providers in the subset will be
updated with the values of the common symbols.

See also: [`is_timeseries`](@ref), [`NotTimeseries`](@ref).
"""
function setsym(bi::BatchedInterface)
    numprobs = length(bi.system_to_symbol_subset)
    probnames = [Symbol(:prob, i) for i in 1:numprobs]

    full_update_fnexpr = let fnbody = quote end
        for (sys_idx, subset) in enumerate(bi.system_to_symbol_subset)
            probname = probnames[sys_idx]
            for (idx_in_subset, idx_in_union) in enumerate(subset)
                idx = bi.system_to_symbol_indexes[sys_idx][idx_in_subset]
                isstate = bi.system_to_isstate[sys_idx][idx_in_subset]
                setter = isstate ? set_state! : set_parameter!
                push!(fnbody.args, :($setter($probname, vals[$idx_in_union], $idx)))
            end
            # also run hook
            if !all(bi.system_to_isstate[sys_idx])
                paramidxs = [
                    bi.system_to_symbol_indexes[sys_idx][idx_in_subset]
                        for idx_in_subset in 1:length(subset)
                        if !bi.system_to_isstate[sys_idx][idx_in_subset]
                ]
                push!(fnbody.args, :($finalize_parameters_hook!($probname, $paramidxs)))
            end
        end
        push!(fnbody.args, :(return vals))
        Expr(
            :function,
            Expr(:tuple, probnames..., :vals),
            fnbody
        )
    end

    partial_update_fnexpr = let fnbody = quote end
        curfnbody = fnbody
        for (sys_idx, subset) in enumerate(bi.system_to_symbol_subset)
            newcurfnbody = if sys_idx == 1
                Expr(:if, :(idx == $sys_idx))
            else
                Expr(:elseif, :(idx == $sys_idx))
            end
            push!(curfnbody.args, newcurfnbody)
            curfnbody = newcurfnbody

            ifbody = quote end
            push!(curfnbody.args, ifbody)

            probname = :prob
            for (idx_in_subset, idx_in_union) in enumerate(subset)
                idx = bi.system_to_symbol_indexes[sys_idx][idx_in_subset]
                isstate = bi.system_to_isstate[sys_idx][idx_in_subset]
                setter = isstate ? set_state! : set_parameter!
                push!(ifbody.args, :($setter($probname, vals[$idx_in_union], $idx)))
            end
            # also run hook
            if !all(bi.system_to_isstate[sys_idx])
                paramidxs = [
                    bi.system_to_symbol_indexes[sys_idx][idx_in_subset]
                        for idx_in_subset in 1:length(subset)
                        if !bi.system_to_isstate[sys_idx][idx_in_subset]
                ]
                push!(ifbody.args, :($finalize_parameters_hook!($probname, $paramidxs)))
            end
        end
        push!(curfnbody.args, :(error("Invalid problem index $idx")))
        push!(fnbody.args, :(return nothing))
        Expr(
            :function,
            Expr(:tuple, :prob, :idx, :vals),
            fnbody
        )
    end
    return let full_update = @RuntimeGeneratedFunction(full_update_fnexpr),
            partial_update = @RuntimeGeneratedFunction(partial_update_fnexpr)

        setter!(args...) = full_update(args...)
        setter!(prob, idx::Int, vals::AbstractVector) = partial_update(prob, idx, vals)
        setter!
    end
end

"""
    setsym_oop(bi::BatchedInterface)

Given a [`BatchedInterface`](@ref) composed from `n` index providers (and corresponding
symbols), return a function which takes `n` corresponding value providers and an array of
values, and returns an `n`-tuple where each element is a 2-tuple consisting of the updated
state values and parameter values of the corresponding value provider. Requires that the
value provider implement [`state_values`](@ref), [`parameter_values`](@ref). The updates are
performed out-of-place using [`remake_buffer`](@ref).

Note that all of the value providers passed to the returned function must satisfy
`is_timeseries(prob) === NotTimeseries()`.

Note that if any subset of the `n` index providers share common symbols (among those passed
to `BatchedInterface`) then all of the corresponding value providers in the subset will be
updated with the values of the common symbols.

See also: [`is_timeseries`](@ref), [`NotTimeseries`](@ref).
"""
function setsym_oop(bi::BatchedInterface)
    numprobs = length(bi.system_to_symbol_subset)
    probnames = [Symbol(:prob, i) for i in 1:numprobs]
    arg = :vals
    full_update = Expr(:block)

    function push_remake_expr!(curexpr, outsym, sys_i, buffer_expr, idxs, vals_idxs, prefix)
        idxs = identity.(idxs)
        if isconcretetype(eltype(idxs))
            idxssym = Symbol(prefix, :_idxs_, sys_i)
            valssym = Symbol(prefix, :_vals_, sys_i)
            push!(curexpr.args, :($idxssym = $idxs))
            push!(curexpr.args, :($valssym = $view($arg, $vals_idxs)))
            push!(
                curexpr.args,
                :(
                    $outsym = $remake_buffer(
                        syss[$sys_i], $buffer_expr, $idxssym, $valssym
                    )
                )
            )
        else
            # mixed index types: apply `remake_buffer` once per concretely typed
            # group, since implementations that promote buffer eltypes from
            # `eltype(idxs)` require concrete index collections
            push!(curexpr.args, :($outsym = $buffer_expr))
            for (gidxs, positions, _) in TypeGroupedIndexes(idxs).groups
                push!(
                    curexpr.args,
                    :(
                        $outsym = $remake_buffer(
                            syss[$sys_i], $outsym, $gidxs,
                            $view($arg, $(vals_idxs[positions]))
                        )
                    )
                )
            end
        end
        return nothing
    end

    function get_update_expr(prob::Symbol, sys_i::Int)
        union_idxs = bi.system_to_symbol_subset[sys_i]
        indp_idxs = bi.system_to_symbol_indexes[sys_i]
        isstate = bi.system_to_isstate[sys_i]
        indp = bi.index_providers[sys_i]
        curexpr = Expr(:block)

        statessym = Symbol(:states_, sys_i)
        if all(.!isstate)
            push!(curexpr.args, :($statessym = $state_values($prob)))
        else
            push_remake_expr!(
                curexpr, statessym, sys_i, :($state_values($prob)),
                indp_idxs[isstate], union_idxs[isstate], :state
            )
        end

        paramssym = Symbol(:params_, sys_i)
        if all(isstate)
            push!(curexpr.args, :($paramssym = $parameter_values($prob)))
        else
            push_remake_expr!(
                curexpr, paramssym, sys_i, :($parameter_values($prob)),
                indp_idxs[.!isstate], union_idxs[.!isstate], :param
            )
        end

        return curexpr, statessym, paramssym
    end

    full_update_expr = Expr(:block)
    full_update_retval = Expr(:tuple)
    partial_update_expr = Expr(:block)
    cur_partial_update_expr = partial_update_expr
    for i in 1:numprobs
        update_expr, statesym, paramsym = get_update_expr(probnames[i], i)
        push!(full_update_expr.args, update_expr)
        push!(full_update_retval.args, Expr(:tuple, statesym, paramsym))

        cur_ifexpr = Expr(i == 1 ? :if : :elseif, :(idx == $i))
        update_expr, statesym, paramsym = get_update_expr(:prob, i)
        push!(update_expr.args, :(return ($statesym, $paramsym)))
        push!(cur_ifexpr.args, update_expr)
        push!(cur_partial_update_expr.args, cur_ifexpr)
        cur_partial_update_expr = cur_ifexpr
    end
    push!(full_update_expr.args, :(return $full_update_retval))
    push!(cur_partial_update_expr.args, :(error("Invalid problem index $idx")))

    full_update_fnexpr = Expr(
        :function, Expr(:tuple, :syss, probnames..., arg), full_update_expr
    )
    partial_update_fnexpr = Expr(
        :function, Expr(:tuple, :syss, :prob, :idx, arg), partial_update_expr
    )

    return let full_update = @RuntimeGeneratedFunction(full_update_fnexpr),
            partial_update = @RuntimeGeneratedFunction(partial_update_fnexpr),
            syss = Tuple(bi.index_providers)

        setter(args...) = full_update(syss, args...)
        setter(prob, idx::Int, vals::AbstractVector) = partial_update(syss, prob, idx, vals)
        setter
    end
end

using Documenter, SymbolicIndexingInterface

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

include("pages.jl")

makedocs(
    sitename = "SymbolicIndexingInterface.jl",
    authors = "Chris Rackauckas",
    modules = [SymbolicIndexingInterface],
    clean = true,
    format = Documenter.HTML(
        analytics = "UA-90474609-3",
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/SymbolicIndexingInterface/stable/"
    ),
    pages = pages,
    checkdocs = :exports
)

deploydocs(
    repo = "github.com/SciML/SymbolicIndexingInterface.jl.git";
    push_preview = true
)

using SymbolicIndexingInterface
using Zygote

sys = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)
pstate = ProblemState(; u = rand(3), p = rand(3), t = rand())

getter = getsym(sys, :x)
@test Zygote.gradient(getter, pstate)[1].u == [1.0, 0.0, 0.0]

getter = getsym(sys, [:x, :z])
@test Zygote.gradient(sum ∘ getter, pstate)[1].u == [1.0, 0.0, 1.0]

getter = getsym(sys, :a)
@test Zygote.gradient(getter, pstate)[1].p == [1.0, 0.0, 0.0]

getter = getsym(sys, [:a, :c])
@test Zygote.gradient(sum ∘ getter, pstate)[1].p == [1.0, 0.0, 1.0]

using SymbolicIndexingInterface
using JET
using Test

@testset "JET static analysis" begin
    sc = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)

    struct TestProblem
        u::Vector{Float64}
        p::Vector{Float64}
        t::Float64
    end

    SymbolicIndexingInterface.symbolic_container(sp::TestProblem) = sc
    SymbolicIndexingInterface.state_values(sp::TestProblem) = sp.u
    SymbolicIndexingInterface.parameter_values(sp::TestProblem) = sp.p
    SymbolicIndexingInterface.current_time(sp::TestProblem) = sp.t
    SymbolicIndexingInterface.is_time_dependent(::TestProblem) = true

    prob = TestProblem([1.0, 2.0, 3.0], [4.0, 5.0, 6.0], 0.0)

    @testset "Interface functions" begin
        rep = JET.report_call(is_variable, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(is_parameter, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(variable_index, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(parameter_index, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(is_observed, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(symbolic_type, (Symbol,))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(variable_symbols, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(parameter_symbols, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        # Additional interface functions
        rep = JET.report_call(is_independent_variable, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(independent_variable_symbols, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(all_variable_symbols, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(all_symbols, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(is_time_dependent, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(constant_structure, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(default_values, (typeof(sc),))
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "Getter/setter construction" begin
        rep = JET.report_call(getp, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(setp, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        # State getter/setter construction
        rep = JET.report_call(getsym, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(setsym, (typeof(sc), Symbol))
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "Getter/setter execution" begin
        getter_a = getp(sc, :a)
        rep = JET.report_call(getter_a, (TestProblem,))
        @test length(JET.get_reports(rep)) == 0

        getter_x = getsym(sc, :x)
        rep = JET.report_call(getter_x, (TestProblem,))
        @test length(JET.get_reports(rep)) == 0

        # Setter execution
        setter_a = setp(sc, :a)
        rep = JET.report_call(setter_a, (TestProblem, Float64))
        @test length(JET.get_reports(rep)) == 0

        setter_x = setsym(sc, :x)
        rep = JET.report_call(setter_x, (TestProblem, Float64))
        @test length(JET.get_reports(rep)) == 0

        # Array getters
        getter_ab = getp(sc, [:a, :b])
        rep = JET.report_call(getter_ab, (TestProblem,))
        @test length(JET.get_reports(rep)) == 0

        getter_xy = getsym(sc, [:x, :y])
        rep = JET.report_call(getter_xy, (TestProblem,))
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "Type optimization" begin
        @test_opt target_modules = (SymbolicIndexingInterface,) is_variable(sc, :x)
        @test_opt target_modules = (SymbolicIndexingInterface,) is_parameter(sc, :a)
        @test_opt target_modules = (SymbolicIndexingInterface,) symbolic_type(:x)
        @test_opt target_modules = (SymbolicIndexingInterface,) variable_symbols(sc)
        @test_opt target_modules = (SymbolicIndexingInterface,) parameter_symbols(sc)

        # Additional type optimization tests
        @test_opt target_modules = (SymbolicIndexingInterface,) is_independent_variable(
            sc, :t
        )
        @test_opt target_modules = (SymbolicIndexingInterface,) independent_variable_symbols(sc)
        @test_opt target_modules = (SymbolicIndexingInterface,) all_variable_symbols(sc)
        @test_opt target_modules = (SymbolicIndexingInterface,) all_symbols(sc)
        @test_opt target_modules = (SymbolicIndexingInterface,) is_time_dependent(sc)
        @test_opt target_modules = (SymbolicIndexingInterface,) constant_structure(sc)
    end

    @testset "Getter execution type optimization" begin
        getter_a = getp(sc, :a)
        getter_x = getsym(sc, :x)

        @test_opt target_modules = (SymbolicIndexingInterface,) getter_a(prob)
        @test_opt target_modules = (SymbolicIndexingInterface,) getter_x(prob)

        # Array getter optimization
        getter_ab = getp(sc, [:a, :b])
        getter_xy = getsym(sc, [:x, :y])

        @test_opt target_modules = (SymbolicIndexingInterface,) getter_ab(prob)
        @test_opt target_modules = (SymbolicIndexingInterface,) getter_xy(prob)
    end

    @testset "ProblemState static analysis" begin
        ps = ProblemState(; u = prob.u, p = prob.p, t = prob.t)

        rep = JET.report_call(state_values, (typeof(ps),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(parameter_values, (typeof(ps),))
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(current_time, (typeof(ps),))
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "remake_buffer static analysis" begin
        rep = JET.report_call(
            remake_buffer, (typeof(sc), Vector{Float64}, Vector{Int}, Vector{Float64})
        )
        @test length(JET.get_reports(rep)) == 0

        rep = JET.report_call(
            remake_buffer, (typeof(sc), NTuple{3, Float64}, Vector{Int}, Vector{Float64})
        )
        @test length(JET.get_reports(rep)) == 0
    end
end

using SymbolicIndexingInterface
using Test

struct SystemMockup
    static::Bool
    vars::Vector{Symbol}
    params::Vector{Symbol}
    indepvar::Union{Symbol, Nothing}
end

SymbolicIndexingInterface.is_variable(sys::SystemMockup, sym) = sym in sys.vars
function SymbolicIndexingInterface.variable_index(sys::SystemMockup, sym, t = nothing)
    if !constant_structure(sys) && t === nothing
        error("time index must be present")
    end
    return findfirst(isequal(sym), variable_symbols(sys, t))
end
function SymbolicIndexingInterface.variable_symbols(sys::SystemMockup, i = nothing)
    return constant_structure(sys) ? sys.vars : circshift(sys.vars, i)
end
SymbolicIndexingInterface.is_parameter(sys::SystemMockup, sym) = sym in sys.params
function SymbolicIndexingInterface.parameter_index(sys::SystemMockup, sym)
    return findfirst(isequal(sym), sys.params)
end
SymbolicIndexingInterface.parameter_symbols(sys::SystemMockup) = sys.params
function SymbolicIndexingInterface.is_independent_variable(sys::SystemMockup, sym)
    return sys.indepvar !== nothing && isequal(sym, sys.indepvar)
end
function SymbolicIndexingInterface.independent_variable_symbols(sys::SystemMockup)
    if sys.indepvar === nothing
        return []
    else
        return [sys.indepvar]
    end
end
function SymbolicIndexingInterface.is_observed(sys::SystemMockup, sym)
    return is_variable(sys, sym) || is_parameter(sys, sym) || is_independent_variable(sys, sym)
end
function SymbolicIndexingInterface.observed(sys::SystemMockup, sym, states = nothing)
    if !constant_structure(sys) && states === nothing
        error("States required")
    end
    states = states isa Vector ? states : variable_symbols(sys, states)
    if is_variable(sys, sym)
        return is_time_dependent(sys) ?
            (u, p, t) -> u[findfirst(isequal(sym), states)] :
            (u, p) -> u[findfirst(isequal(sym), states)]
    end
    idx = parameter_index(sys, sym)
    if idx !== nothing
        return is_time_dependent(sys) ? (u, p, t) -> p[idx] : (u, p) -> p[idx]
    end
    if is_independent_variable(sys, sym)
        return is_time_dependent(sys) ? (u, p, t) -> t : (u, p) -> 1
    end
end
SymbolicIndexingInterface.is_time_dependent(sys::SystemMockup) = isequal(sys.indepvar, :t)
SymbolicIndexingInterface.constant_structure(sys::SystemMockup) = sys.static
SymbolicIndexingInterface.all_variable_symbols(sys::SystemMockup) = sys.vars
function SymbolicIndexingInterface.all_symbols(sys::SystemMockup)
    return vcat(sys.vars, sys.params, independent_variable_symbols(sys))
end

sys = SystemMockup(true, [:x, :y, :z], [:a, :b, :c], :t)

@test all(is_variable.((sys,), [:x, :y, :z]))
@test all(.!is_variable.((sys,), [:a, :b, :c, :t, :p, :q, :r]))
@test all(variable_index.((sys,), [:x, :z, :y]) .== [1, 3, 2])
@test all(variable_index.((sys,), [:a, :b, :c, :t, :p, :q, :r]) .=== nothing)
@test all(is_parameter.((sys,), [:a, :b, :c]))
@test all(.!is_parameter.((sys,), [:x, :y, :z, :t, :p, :q, :r]))
@test all(parameter_index.((sys,), [:c, :a, :b]) .== [3, 1, 2])
@test all(parameter_index.((sys,), [:x, :y, :z, :t, :p, :q, :r]) .=== nothing)
@test all(.!is_timeseries_parameter.((sys,), [:x, :y, :z, :t, :p, :q, :r])) # fallback even if not implemented
@test all(timeseries_parameter_index.((sys,), [:x, :y, :z, :t, :p, :q, :r]) .=== nothing) # fallback
@test is_independent_variable(sys, :t)
@test all(.!is_independent_variable.((sys,), [:x, :y, :z, :a, :b, :c, :p, :q, :r]))
@test all(is_observed.((sys,), [:x, :y, :z, :a, :b, :c, :t]))
@test all(observed(sys, :x)(1:3, 4:6, 1.5) .== 1)
@test all(observed(sys, :y)(1:3, 4:6, 1.5) .== 2)
@test all(observed(sys, :z)(1:3, 4:6, 1.5) .== 3)
@test observed(sys, :a)(1:3, 4:6, 1.5) == 4
@test observed(sys, :b)(1:3, 4:6, 1.5) == 5
@test observed(sys, :c)(1:3, 4:6, 1.5) == 6
@test observed(sys, :t)(1:3, 4:6, 1.5) == 1.5
@test is_time_dependent(sys)
@test constant_structure(sys)
@test variable_symbols(sys) == [:x, :y, :z]
@test parameter_symbols(sys) == [:a, :b, :c]
@test independent_variable_symbols(sys) == [:t]
@test all_variable_symbols(sys) == [:x, :y, :z]
@test sort(all_symbols(sys)) == [:a, :b, :c, :t, :x, :y, :z]
@test default_values(sys) == Dict() # fallback even if not implemented

sys = SystemMockup(true, [:x, :y, :z], [:a, :b, :c], nothing)

@test !is_time_dependent(sys)
@test all(observed(sys, :x)(1.0:3.0, 4:6) .== 1.0)
@test all(observed(sys, :y)(1.0:3.0, 4:6) .== 2.0)
@test all(observed(sys, :z)(1.0:3.0, 4:6) .== 3.0)
@test observed(sys, :a)(1:3, 4:6) == 4
@test observed(sys, :b)(1:3, 4:6) == 5
@test observed(sys, :c)(1:3, 4:6) == 6
@test constant_structure(sys)
@test variable_symbols(sys) == [:x, :y, :z]
@test parameter_symbols(sys) == [:a, :b, :c]
@test independent_variable_symbols(sys) == []
@test all_variable_symbols(sys) == [:x, :y, :z]
@test sort(all_symbols(sys)) == [:a, :b, :c, :x, :y, :z]

sys = SystemMockup(false, [:x, :y, :z], [:a, :b, :c], :t)
@test !constant_structure(sys)
for variable in [:x, :y, :z, :a, :b, :c, :t]
    @test_throws ErrorException variable_index(sys, variable)
    @test_throws ErrorException observed(sys, variable)
end
@test all(variable_index.((sys,), [:z, :y, :x], 1) .== [1, 3, 2])
@test all(variable_index.((sys,), [:a, :b, :c, :t], 1) .== nothing)
@test all(observed(sys, :x, 2)(1:3, 4:6, 1.5) .== 3)
@test all(observed(sys, :y, 2)(1:3, 4:6, 1.5) .== 1)
@test all(observed(sys, :z, 2)(1:3, 4:6, 1.5) .== 2)
@test observed(sys, :a, 2)(1:3, 4:6, 1.5) == 4
@test observed(sys, :b, 2)(1:3, 4:6, 1.5) == 5
@test observed(sys, :c, 2)(1:3, 4:6, 1.5) == 6
@test observed(sys, :t, 2)(1:3, 4:6, 1.5) == 1.5
@test_throws Exception variable_symbols(sys)
@test variable_symbols(sys, 1) == [:z, :x, :y]
@test variable_symbols(sys, 2) == [:y, :z, :x]
@test variable_symbols(sys, 3) == [:x, :y, :z]
@test parameter_symbols(sys) == [:a, :b, :c]
@test independent_variable_symbols(sys) == [:t]
@test all_variable_symbols(sys) == [:x, :y, :z]
@test sort(all_symbols(sys)) == [:a, :b, :c, :t, :x, :y, :z]

using SymbolicIndexingInterface
using SymbolicIndexingInterface: TypeGroupedIndexes, OOPSetter, _subset_values
using Test

# Two distinct index types, mimicking providers whose parameter indexes carry
# the storage location in their type (e.g. the portions of
# `ModelingToolkit.MTKParameters`). Such providers compute buffer eltype
# promotion in `remake_buffer` from `eltype(idxs)`, which requires the OOP
# setters to pass concretely typed index collections.
struct IndexKindA
    i::Int
end
struct IndexKindB
    i::Int
end

@testset "TypeGroupedIndexes partitioning" begin
    tgi = TypeGroupedIndexes(Any[IndexKindA(1), IndexKindB(1), IndexKindA(2)])
    @test length(tgi.groups) == 2
    (g1, p1, v1), (g2, p2, v2) = tgi.groups
    @test g1 isa Vector{IndexKindA}
    @test g1 == [IndexKindA(1), IndexKindA(2)]
    @test p1 == [1, 3]
    @test v1 === Val((1, 3))
    @test g2 isa Vector{IndexKindB}
    @test g2 == [IndexKindB(1)]
    # contiguous position runs compact to ranges so the `Val`-encoded form
    # stays O(1) in the number of indexes
    @test p2 == 2:2
    @test v2 === Val(2:2)

    tgi = TypeGroupedIndexes(Any[IndexKindA(1), IndexKindA(2), IndexKindB(1)])
    (_, p1, v1), (_, p2, v2) = tgi.groups
    @test p1 == 1:2
    @test v1 === Val(1:2)
    @test p2 == 3:3
    @test v2 === Val(3:3)
end

@testset "_subset_values on tuples is exact" begin
    val = (1.0f0, [2.0, 3.0], :sym)
    @test @inferred(_subset_values(val, [1, 3], Val((1, 3)))) === (1.0f0, :sym)
    @test @inferred(_subset_values(val, 2:3, Val(2:3))) == ([2.0, 3.0], :sym)
    @test @inferred(_subset_values(val, 2:2, Val(2:2))) == ([2.0, 3.0],)
    @test @inferred(_subset_values([1.0, 2.0, 3.0], [1, 3], Val((1, 3)))) == [1.0, 3.0]
end

struct TwoKindSys end
SymbolicIndexingInterface.is_variable(::TwoKindSys, sym) = false
SymbolicIndexingInterface.variable_index(::TwoKindSys, sym) = nothing
SymbolicIndexingInterface.is_parameter(::TwoKindSys, sym) = sym in (:a, :b, :c)
function SymbolicIndexingInterface.parameter_index(::TwoKindSys, sym)
    return if sym === :a
        IndexKindA(1)
    elseif sym === :b
        IndexKindB(1)
    elseif sym === :c
        IndexKindB(2)
    else
        nothing
    end
end

struct TwoKindParams{TA, TB, TC}
    a::TA
    b::TB
    c::TC
end

struct TwoKindProb{P}
    u0::Vector{Float64}
    p::P
end
SymbolicIndexingInterface.state_values(prob::TwoKindProb) = prob.u0
SymbolicIndexingInterface.parameter_values(prob::TwoKindProb) = prob.p

function SymbolicIndexingInterface.remake_buffer(
        ::TwoKindSys, oldbuf::TwoKindParams, idxs, vals
    )
    # the contract under test: implementations must never receive an
    # abstractly typed index collection
    @test isconcretetype(eltype(idxs))
    buf = oldbuf
    for (idx, val) in zip(idxs, vals)
        if idx isa IndexKindA
            buf = TwoKindParams(val, buf.b, buf.c)
        elseif idx == IndexKindB(1)
            buf = TwoKindParams(buf.a, val, buf.c)
        else
            buf = TwoKindParams(buf.a, buf.b, val)
        end
    end
    return buf
end

@testset "setp_oop groups mixed index types" begin
    sys = TwoKindSys()
    prob = TwoKindProb(Float64[], TwoKindParams(0.0, 0.0, 0.0))

    set_mixed = setp_oop(sys, [:a, :b, :c])
    @test set_mixed.idxs isa TypeGroupedIndexes
    newps = set_mixed(prob, [1.0, 2.0, 3.0])
    @test newps.a == 1.0
    @test newps.b == 2.0
    @test newps.c == 3.0
    # value type changes flow through
    newps2 = set_mixed(prob, [1, 2, 3])
    @test newps2.a === 1
    @test newps2.b === 2
    @test newps2.c === 3

    # heterogeneous `Tuple` values subset correctly across groups
    newps3 = set_mixed(prob, (1.5f0, [2.5], :sym))
    @test newps3.a === 1.5f0
    @test newps3.b == [2.5]
    @test newps3.c === :sym

    # homogeneous index types stay a plain concrete vector
    set_homog = setp_oop(sys, [:b, :c])
    @test set_homog.idxs isa Vector{IndexKindB}
    newps3 = set_homog(prob, [5.0, 6.0])
    @test newps3.b == 5.0
    @test newps3.c == 6.0
end

@testset "setsym_oop groups mixed index types" begin
    sys = TwoKindSys()
    prob = TwoKindProb(Float64[], TwoKindParams(0.0, 0.0, 0.0))

    setter = setsym_oop(sys, [:a, :b])
    _, newps = setter(prob, [1.5, 2.5])
    @test newps.a == 1.5
    @test newps.b == 2.5
end

# A provider whose `remake_buffer` is type-stable per concrete index vector,
# to check the grouped setter chain infers exactly (mirrors the
# "Type-stability of `remake_buffer`" downstream ModelingToolkit test, where
# values are a heterogeneous `Tuple` such as `(Float16(1), Dual[...])`).
struct StableTwoKindSys end
SymbolicIndexingInterface.is_variable(::StableTwoKindSys, sym) = false
SymbolicIndexingInterface.variable_index(::StableTwoKindSys, sym) = nothing
SymbolicIndexingInterface.is_parameter(::StableTwoKindSys, sym) = sym in (:x, :y)
function SymbolicIndexingInterface.parameter_index(::StableTwoKindSys, sym)
    return sym === :x ? IndexKindA(1) : sym === :y ? IndexKindB(1) : nothing
end

struct PairParams{X, Y}
    x::X
    y::Y
end

function SymbolicIndexingInterface.remake_buffer(
        ::StableTwoKindSys, oldbuf::PairParams, idxs::Vector{IndexKindA}, vals
    )
    return PairParams(vals[end], oldbuf.y)
end
function SymbolicIndexingInterface.remake_buffer(
        ::StableTwoKindSys, oldbuf::PairParams, idxs::Vector{IndexKindB}, vals
    )
    return PairParams(oldbuf.x, vals[end])
end

@testset "grouped setp_oop infers exactly for heterogeneous Tuple values" begin
    sys = StableTwoKindSys()
    ps = PairParams(0.0, [0.0])

    setter = setp_oop(sys, [:x, :y])
    @test setter.idxs isa TypeGroupedIndexes
    newps = @inferred setter(ps, (1.5f0, [2.5, 3.5]))
    @test newps isa PairParams{Float32, Vector{Float64}}
    @test newps.x === 1.5f0
    @test newps.y == [2.5, 3.5]
end

@testset "BatchedInterface setsym_oop groups mixed index types" begin
    sys = TwoKindSys()
    prob = TwoKindProb(Float64[], TwoKindParams(0.0, 0.0, 0.0))

    bi = BatchedInterface((sys, [:a, :b]))
    setter = setsym_oop(bi)
    _, newps = setter(prob, 1, [1.5, 2.5])
    @test newps.a == 1.5
    @test newps.b == 2.5
    ((_, newps2),) = setter(prob, [3.5, 4.5])
    @test newps2.a == 3.5
    @test newps2.b == 4.5
end

# Defining Solution Wrapper Fallbacks

The simplest case is when the type contains an object that already implements the interface.
All its methods can simply be forwarded to that object. To do so, SymbolicIndexingInterface.jl
provides the [`symbolic_container`](@ref) method. For example,

```julia
struct MySolutionWrapper{T<:SciMLBase.AbstractTimeseriesSolution}
  sol::T
  # other properties...
end

symbolic_container(sys::MySolutionWrapper) = sys.sol
```

`MySolutionWrapper` wraps an `AbstractTimeseriesSolution` which already implements the interface.
Since `symbolic_container` will return the wrapped solution, all method calls such as
`is_parameter(sys::MySolutionWrapper, sym)` will be forwarded to `is_parameter(sys.sol, sym)`.

In cases where some methods need to function differently than those of the wrapped type, they can be selectively
defined. For example, suppose `MySolutionWrapper` does not support observed quantities. The following
method can be defined (in addition to the one above):

```julia
is_observed(sys::MySolutionWrapper, sym) = false
```

# Implementing the Complete Symbolic Indexing Interface

## Index Provider Interface
This tutorial will show how to define the entire Symbolic Indexing Interface on an
`ExampleSystem`:

```@example implementing_sii
using SymbolicIndexingInterface
struct ExampleSystem
  state_index::Dict{Symbol,Int}
  parameter_index::Dict{Symbol,Int}
  independent_variable::Union{Symbol,Nothing}
  defaults::Dict{Symbol, Float64}
  # mapping from observed variable to Expr to calculate its value
  observed::Dict{Symbol,Expr}
end
```

Not all the methods in the interface are required. Some only need to be implemented if a type
supports specific functionality. Consider the following struct, which needs to implement the interface:

### Mandatory methods

#### Simple Indexing Functions

These are the simple functions which describe how to turn symbols into indices.

```@example implementing_sii
function SymbolicIndexingInterface.is_variable(sys::ExampleSystem, sym)
  haskey(sys.state_index, sym)
end

function SymbolicIndexingInterface.variable_index(sys::ExampleSystem, sym)
  get(sys.state_index, sym, nothing)
end

function SymbolicIndexingInterface.variable_symbols(sys::ExampleSystem)
  collect(keys(sys.state_index))
end

function SymbolicIndexingInterface.is_parameter(sys::ExampleSystem, sym)
  haskey(sys.parameter_index, sym)
end

function SymbolicIndexingInterface.parameter_index(sys::ExampleSystem, sym)
  get(sys.parameter_index, sym, nothing)
end

function SymbolicIndexingInterface.parameter_symbols(sys::ExampleSystem)
  collect(keys(sys.parameter_index))
end

function SymbolicIndexingInterface.is_independent_variable(sys::ExampleSystem, sym)
  # note we have to check separately for `nothing`, otherwise
  # `is_independent_variable(p, nothing)` would return `true`.
  sys.independent_variable !== nothing && sym === sys.independent_variable
end

function SymbolicIndexingInterface.independent_variable_symbols(sys::ExampleSystem)
  sys.independent_variable === nothing ? [] : [sys.independent_variable]
end

function SymbolicIndexingInterface.is_time_dependent(sys::ExampleSystem)
  sys.independent_variable !== nothing
end

SymbolicIndexingInterface.constant_structure(::ExampleSystem) = true

function SymbolicIndexingInterface.all_variable_symbols(sys::ExampleSystem)
  return vcat(
    collect(keys(sys.state_index)),
    collect(keys(sys.observed)),
  )
end

function SymbolicIndexingInterface.all_symbols(sys::ExampleSystem)
  return vcat(
    all_variable_symbols(sys),
    collect(keys(sys.parameter_index)),
    sys.independent_variable === nothing ? Symbol[] : sys.independent_variable
  )
end

function SymbolicIndexingInterface.default_values(sys::ExampleSystem)
  return sys.defaults
end
```

#### Observed Equation Handling

These are for handling symbolic expressions and generating equations which are not directly
in the solution vector.

```@example implementing_sii
using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(@__MODULE__)

# this type accepts `Expr` for observed expressions involving state/parameter/observed
# variables
SymbolicIndexingInterface.is_observed(sys::ExampleSystem, sym) = sym isa Expr || sym isa Symbol && haskey(sys.observed, sym)

function SymbolicIndexingInterface.observed(sys::ExampleSystem, sym::Expr)
  # generate a function with the appropriate signature
  if is_time_dependent(sys)
    fn_expr = :(
      function gen(u, p, t)
        # assign a variable for each state symbol it's value in u
        $([:($var = u[$idx]) for (var, idx) in pairs(sys.state_index)]...)
        # assign a variable for each parameter symbol it's value in p
        $([:($var = p[$idx]) for (var, idx) in pairs(sys.parameter_index)]...)
        # assign a variable for the independent variable
        $(sys.independent_variable) = t
        # return the value of the expression
        return $sym
      end
    )
  else
    fn_expr = :(
      function gen(u, p)
        # assign a variable for each state symbol it's value in u
        $([:($var = u[$idx]) for (var, idx) in pairs(sys.state_index)]...)
        # assign a variable for each parameter symbol it's value in p
        $([:($var = p[$idx]) for (var, idx) in pairs(sys.parameter_index)]...)
        # return the value of the expression
        return $sym
      end
    )
  end
  return @RuntimeGeneratedFunction(fn_expr)
end
```

In case a type does not support such observed quantities, `is_observed` must be
defined to always return `false`, and `observed` does not need to be implemented.

The same process can be followed for [`parameter_observed`](@ref). In-place versions
can also be implemented for `parameter_observed`.

#### Note about constant structure

Note that the method definitions are all assuming `constant_structure(p) == true`.

In case `constant_structure(p) == false`, the following methods would change:
- `constant_structure(::ExampleSystem) = false`
- `variable_index(sys::ExampleSystem, sym)` would become
  `variable_index(sys::ExampleSystem, sym, i)` where `i` is the time index at which
  the index of `sym` is required.
- `variable_symbols(sys::ExampleSystem)` would become
  `variable_symbols(sys::ExampleSystem, i)` where `i` is the time index at which
  the variable symbols are required.
- `observed(sys::ExampleSystem, sym)` would become
  `observed(sys::ExampleSystem, sym, i)` where `i` is either the time index at which
  the index of `sym` is required or a `Vector` of state symbols at the current time index.

### Optional methods

Note that `observed` is optional if `is_observed` is always `false`, or the type is
only responsible for identifying observed values and `observed` will always be called
on a type that wraps this type. An example is `ModelingToolkit.AbstractSystem`, which
can identify whether a value is observed, but cannot implement `observed` itself.

## Value Provider Interface

Other interface methods relate to indexing functions. If a type contains the values of
parameter variables, it must implement [`parameter_values`](@ref). This allows the
default definitions of [`getp`](@ref) and [`setp`](@ref) to work. While `setp` is
not typically useful for solution objects, it may be useful for integrators. Typically,
the default implementations for `getp` and `setp` will suffice, and manually defining
them is not necessary.

```@example implementing_sii
function SymbolicIndexingInterface.parameter_values(sys::ExampleSystem)
  sys.p
end
```

If a type contains the value of state variables, it can define [`state_values`](@ref) to
enable the usage of [`getsym`](@ref) and [`setsym`](@ref). These methods return getter/
setter functions to access or update the value of a state variable (or a collection of
them). If the type also supports generating [`observed`](@ref) functions, `getsym` also
enables returning functions to access the value of arbitrary expressions involving
the system's symbols. This also requires that the type implement
[`parameter_values`](@ref) and [`current_time`](@ref) (if the system is time-dependent).

Consider the following `ExampleIntegrator`

```@example implementing_sii
mutable struct ExampleIntegrator
  u::Vector{Float64}
  p::Vector{Float64}
  t::Float64
  sys::ExampleSystem
end

# define a fallback for the interface methods
SymbolicIndexingInterface.symbolic_container(integ::ExampleIntegrator) = integ.sys
SymbolicIndexingInterface.state_values(sys::ExampleIntegrator) = sys.u
SymbolicIndexingInterface.parameter_values(sys::ExampleIntegrator) = sys.p
SymbolicIndexingInterface.current_time(sys::ExampleIntegrator) = sys.t
```

Then the following example would work:
```@example implementing_sii
sys = ExampleSystem(Dict(:x => 1, :y => 2, :z => 3), Dict(:a => 1, :b => 2), :t, Dict(), Dict())
integrator = ExampleIntegrator([1.0, 2.0, 3.0], [4.0, 5.0], 6.0, sys)
getx = getsym(sys, :x)
getx(integrator) # 1.0

get_expr = getsym(sys, :(x + y + t))
get_expr(integrator) # 13.0

setx! = setsym(sys, :y)
setx!(integrator, 0.0)
getx(integrator) # 0.0
```

In case a type stores timeseries data (such as solutions), then it must also implement
the [`Timeseries`](@ref) trait. The type would then return a timeseries from
[`state_values`](@ref) and [`current_time`](@ref) and the function returned from
[`getsym`](@ref) would then return a timeseries as well. For example, consider the
`ExampleSolution` below:

```julia
struct ExampleSolution
  u::Vector{Vector{Float64}}
  t::Vector{Float64}
  p::Vector{Float64}
  sys::ExampleSystem
end

# define a fallback for the interface methods
SymbolicIndexingInterface.symbolic_container(sol::ExampleSolution) = sol.sys
SymbolicIndexingInterface.parameter_values(sol::ExampleSolution) = sol.p
# define the trait
SymbolicIndexingInterface.is_timeseries(::Type{ExampleSolution}) = Timeseries()
# both state_values and current_time return a timeseries, which must be
# the same length
SymbolicIndexingInterface.state_values(sol::ExampleSolution) = sol.u
SymbolicIndexingInterface.current_time(sol::ExampleSolution) = sol.t
```

Then the following example would work:
```julia
# using the same system that the ExampleIntegrator used
sol = ExampleSolution([[1.0, 2.0, 3.0], [1.5, 2.5, 3.5]], [6.0, 7.0], [4.0, 5.0], sys)
getx = getsym(sys, :x)
getx(sol) # [1.0, 1.5]

get_expr = getsym(sys, :(x + y + t))
get_expr(sol) # [9.0, 11.0]

get_arr = getsym(sys, [:y, :(x + a)])
get_arr(sol) # [[2.0, 5.0], [2.5, 5.5]]

get_tuple = getsym(sys, (:z, :(z * t)))
get_tuple(sol) # [(3.0, 18.0), (3.5, 24.5)]
```

Note that `setsym` is not designed to work for `Timeseries` objects.

If a type needs to perform some additional actions when updating the state/parameters
or if it is not possible to return a mutable reference to the state/parameter vector
which can directly be modified, the functions [`set_state!`](@ref) and/or
[`set_parameter!`](@ref) can be used. For example, suppose our `ExampleIntegrator`
had an additional field `u_modified::Bool` to allow it to keep track of when a
discontinuity occurs and handle it appropriately. This flag needs to be set to `true`
whenever the state is modified. The `set_state!` function can then be implemented as
follows:

```julia
function SymbolicIndexingInterface.set_state!(integrator::ExampleIntegrator, val, idx)
  integrator.u[idx] = val
  integrator.u_modified = true
end
```

### Using `finalize_parameters_hook!`

The function [`finalize_parameters_hook!`](@ref) is called exactly _once_ every time the
function returned by `setp` is called. This allows performing any additional bookkeeping
required when parameter values are updated. [`set_parameter!`](@ref) also allows performing
similar functionality, but is called for every parameter that is updated, instead of just
once. Thus, `finalize_parameters_hook!` is better for expensive computations that can be
performed for a bulk parameter update.

## The `ParameterIndexingProxy`

[`ParameterIndexingProxy`](@ref) is a wrapper around another type which implements the
interface and allows using [`getp`](@ref) and [`setp`](@ref) to get and set parameter 
values. This allows for a cleaner interface for parameter indexing. Consider the
following example for `ExampleIntegrator`:

```@example implementing_sii
function Base.getproperty(obj::ExampleIntegrator, sym::Symbol)
  if sym === :ps
    return ParameterIndexingProxy(obj)
  else
    return getfield(obj, sym)
  end
end
```

This enables the following API:

```@example implementing_sii
integrator = ExampleIntegrator([1.0, 2.0, 3.0], [4.0, 5.0], 6.0, sys)

integrator.ps[:a] # 4.0
getp(integrator, :a)(integrator) # functionally the same as above

integrator.ps[:b] = 3.0
setp(integrator, :b)(integrator, 3.0) # functionally the same as above
```

The parameters will display as a table:
```@example implementing_sii
integrator.ps
```

## Parameter Timeseries

If a solution object includes modified parameter values (such as through callbacks) during the
simulation, it must implement several additional functions for correct functioning of
[`getsym`](@ref) and [`getp`](@ref). [`ParameterTimeseriesCollection`](@ref) helps in
implementing parameter timeseries objects. The following mockup gives an example of
correct implementation of these functions and the indexing syntax they enable.

```@example param_timeseries
using SymbolicIndexingInterface

# First, we must implement a parameter object that knows where the parameters in
# each parameter timeseries are stored
struct MyParameterObject
    p::Vector{Float64}
    disc_idxs::Vector{Vector{Int}}
end

# To be able to access parameter values
SymbolicIndexingInterface.parameter_values(mpo::MyParameterObject) = mpo.p
# Update the parameter object with new values
# Here, we don't need the index provider but it may be necessary for other implementations
function SymbolicIndexingInterface.with_updated_parameter_timeseries_values(
      ::SymbolCache, mpo::MyParameterObject, args::Pair...)
    for (ts_idx, val) in args
        mpo.p[mpo.disc_idxs[ts_idx]] = val
    end
    return mpo
end

struct ExampleSolution2
    sys::SymbolCache
    u::Vector{Vector{Float64}}
    t::Vector{Float64}
    p::MyParameterObject # the parameter object. Only some parameters are timeseries params
    p_ts::ParameterTimeseriesCollection
end

# Add the `:ps` property to automatically wrap in `ParameterIndexingProxy`
function Base.getproperty(fs::ExampleSolution2, s::Symbol)
    s === :ps ? ParameterIndexingProxy(fs) : getfield(fs, s)
end
# Use the contained `SymbolCache` for indexing
SymbolicIndexingInterface.symbolic_container(fs::ExampleSolution2) = fs.sys
# State indexing methods
SymbolicIndexingInterface.state_values(fs::ExampleSolution2) = fs.u
SymbolicIndexingInterface.current_time(fs::ExampleSolution2) = fs.t
# By default, `parameter_values` refers to the last value
SymbolicIndexingInterface.parameter_values(fs::ExampleSolution2) = fs.p
SymbolicIndexingInterface.get_parameter_timeseries_collection(fs::ExampleSolution2) = fs.p_ts
# Mark the object as a timeseries object
SymbolicIndexingInterface.is_timeseries(::Type{ExampleSolution2}) = Timeseries()
# Mark the object as a parameter timeseries object
SymbolicIndexingInterface.is_parameter_timeseries(::Type{ExampleSolution2}) = Timeseries()
```

We will also need a timeseries object which will store individual parameter timeseries.
`DiffEqArray` in `RecursiveArrayTools.jl` satisfies this use case, but we will implement
one manually here.

```@example param_timeseries
struct MyDiffEqArray
  t::Vector{Float64}
  u::Vector{Vector{Float64}}
end

# Must be a timeseries object, and implement `current_time` and `state_values`
SymbolicIndexingInterface.is_timeseries(::Type{MyDiffEqArray}) = Timeseries()
SymbolicIndexingInterface.current_time(a::MyDiffEqArray) = a.t
SymbolicIndexingInterface.state_values(a::MyDiffEqArray) = a.u
```

Now we can create an example object and observe the new functionality. Note that
`sol.ps[sym, args...]` is identical to `getp(sol, sym)(sol, args...)`. In a real
application, the solution object will be populated during the solve process. We manually
construct the object here for demonstration.

```@example param_timeseries
sys = SymbolCache(
  [:x, :y, :z], [:a, :b, :c, :d], :t;
  # specify that :b, :c and :d are timeseries parameters
  # :b and :c belong to the same timeseries
  # :d is in a different timeseries
  timeseries_parameters = Dict(
    :b => ParameterTimeseriesIndex(1, 1),
    :c => ParameterTimeseriesIndex(1, 2),
    :d => ParameterTimeseriesIndex(2, 1),
  ))
b_c_timeseries = MyDiffEqArray(
  collect(0.0:0.1:1.0),
  [[0.25i, 0.35i] for i in 1:11]
)
d_timeseries = MyDiffEqArray(
  collect(0.0:0.2:1.0),
  [[0.17i] for i in 1:6]
)
p = MyParameterObject(
  # parameter values at the final time
  [4.2, b_c_timeseries.u[end]..., d_timeseries.u[end]...],
  [[2, 3], [4]]
)
sol = ExampleSolution2(
    sys,
    [i * ones(3) for i in 1:5], # u
    collect(0.0:0.25:1.0), # t
    p,
    ParameterTimeseriesCollection([b_c_timeseries, d_timeseries], deepcopy(p))
)
sol.ps[:a] # returns the value of non-timeseries parameter
```

```@example param_timeseries
sol.ps[:b] # returns the timeseries of :b
```

```@example param_timeseries
sol.ps[:b, 3] # index at a specific index in the parameter timeseries
```

```@example param_timeseries
sol.ps[:b, [3, 6, 8]] # index using arrays
```

```@example param_timeseries
idxs = @show rand(Bool, 11) # boolean mask for indexing
sol.ps[:b, idxs]
```

```@example param_timeseries
sol.ps[[:a, :b]] # :a has the same value at all time points
```

```@example param_timeseries
# throws an error since :b and :d belong to different timeseries
try
  sol.ps[[:b, :d]]
catch e
  showerror(stdout, e)
end
```

```@example param_timeseries
sol.ps[:(b + c)] # observed quantities work too
```

```@example param_timeseries
getsym(sol, :b)(sol) # works
```

```@example param_timeseries
try
  getsym(sol, [:b, :d])(sol) # errors since :b and :d belong to different timeseries
catch e
  showerror(stdout, e)
end
```

## Custom containers

A custom container object (such as `ModelingToolkit.MTKParameters`) should implement
[`remake_buffer`](@ref) to allow creating a new buffer with updated values, possibly
with different types. This is already implemented for `AbstractArray`s (including static
arrays).

# Implementing the `SymbolicTypeTrait` for a type

The `SymbolicTypeTrait` is used to identify values that can act as symbolic variables. It
has three variants:

- [`NotSymbolic`](@ref) for quantities that are not symbolic. This is the default for all
  types.
- [`ScalarSymbolic`](@ref) for quantities that are symbolic, and represent a single
  logical value.
- [`ArraySymbolic`](@ref) for quantities that are symbolic, and represent an array of
  values. Types implementing this trait must return an array of `ScalarSymbolic` variables
  of the appropriate size and dimensions when `collect`ed.

The trait is implemented through the [`symbolic_type`](@ref) function. Consider the following
example types:

```julia
struct MySym
  name::Symbol
end

struct MySymArr{N}
  name::Symbol
  size::NTuple{N,Int}
end
```

They must implement the following functions:

```julia
SymbolicIndexingInterface.symbolic_type(::Type{MySym}) = ScalarSymbolic()
SymbolicIndexingInterface.hasname(::MySym) = true
SymbolicIndexingInterface.getname(sym::MySym) = sym.name

SymbolicIndexingInterface.symbolic_type(::Type{<:MySymArr}) = ArraySymbolic()
SymbolicIndexingInterface.hasname(::MySymArr) = true
SymbolicIndexingInterface.getname(sym::MySymArr) = sym.name
function Base.collect(sym::MySymArr)
  [
    MySym(Symbol(sym.name, :_, join(idxs, "_")))
    for idxs in Iterators.product(Base.OneTo.(sym.size)...)
  ]
end
```

[`hasname`](@ref) is not required to always be `true` for symbolic types. For example,
`Symbolics.Num` returns `false` whenever the wrapped value is a number, or an expression.

Introducing a type to represent expression trees:

```julia
struct MyExpr
  op::Function
  args::Vector{Union{MyExpr, MySym, MySymArr, Number, Array}}
end
```

[`symbolic_evaluate`](@ref) can be implemented as follows:

```julia
function symbolic_evaluate(expr::Union{MySym, MySymArr}, syms::Dict)
  get(syms, expr, expr)
end
function symbolic_evaluate(expr::MyExpr, syms::Dict)
  for i in eachindex(expr.args)
    if expr.args[i] isa Union{MySym, MySymArr, MyExpr}
      expr.args[i] = symbolic_evaluate(expr.args[i], syms)
    end
  end
  if all(x -> symbolic_type(x) === NotSymbolic(), expr.args)
    return expr.op(expr.args...)
  end
end
```

Note the evaluation of the operation if all of the arguments are not symbolic. This is
required since `symbolic_evaluate` must return an evaluated value if all symbolic variables
are substituted.

# Terminology

SymbolicIndexingInterface.jl uses various library-specific terminology throughout its
documentation. This page attempts to provide comprehensive explanations of the terms
used.

## Indexes

An index is an object that defines how to extract specific data from a data structure.
Indexes may be anything from integer indexes into arrays, to custom types that contain
information specific to a particular data structure.

In code samples, an index is typically denoted with the name `idx` or `i`.

## Symbolic variables

Symbolic variables are objects that represent quantities (states, parameters, time, etc.)
or collections of quantities used in a numerical simulation in a more human-accessible
manner. Typically the values of these quantities are stored in custom data structures
and referred to using indexes that do not convey any semantic meaning to users. Symbolic
variables cannot directly be used to access values from these data structures and need
to be translated into indexes.

In code samples, a symbolic variable is typically denoted with the name `sym`.

Symbolic variables are also sometimes referred to as "symbolic indices".

## Index providers

Index providers translate symbolic variables into indexes. In general, an "index" can
be anything from integer indexes into an array, or custom types that define how to
index into complicated data structures. `nothing` is reserved to denote the absence of
an index, in cases where the index provider is unaware of a particular symbolic variable.
It cannot be used as an index. ModelingToolkit.jl systems are examples of index providers.

In code samples, an index provider is typically denoted with the name `indp`.

## Value providers

Value providers store values of symbolic variables. Given an appropriate index from an
index provider, value providers return the value (or values) stored at that index. The
problem, integrator and solution types in SciML are all examples of value providers.
Each value provider is (directly or indirectly) associated with an index provider that
defines the set of valid symbolic variables for that value provider, and the corresponding
indexes.

A value provider may not store values for all symbolic variables in the corresponding index
provider. For example, a parameter object (even a plain `Array` storing parameter values)
is a value provider specifically for the symbolic variables referring to parameters.

In code samples, a value provider is typically denoted with the name `valp`.

!!! note
    It is important to note that an object may be both a value- and index- provider. For
    example, SciML's problem, integrator and solution types are both value- and index-
    providers. This allows for several syntactic improvements. The [`symbolic_container`](@ref)
    function is useful in defining such objects.

### Timeseries objects

Timeseries objects are value providers which implement the [`Timeseries`](@ref) variant of
the [`is_timeseries`](@ref) trait.

### Parameter timeseries objects

Parameter timeseries objects are timeseries objects which implement the
[`Timeseries`](@ref) variant of the [`is_parameter_timeseries`](@ref) trait.

# Using the SciML Symbolic Indexing Interface

This tutorial will cover ways to use the symbolic indexing interface for types that
implement it. SciML's core types (problems, solutions, and iterator (integrator) types)
all support this symbolic indexing interface which allows for domain-specific interfaces
(such as ModelingToolkit, Catalyst, etc.) to seamlessly blend their symbolic languages with
the types obtained from SciML. Other tutorials will focus on how users can make use of the
interface for their own DSL, this tutorial will simply focus on what the user experience
looks like for DSL which have set it up.

We recommend any DSL implementing the symbolic indexing interface to link to this tutorial
as a full description of the functionality.

!!! note
    While this tutorial focuses on demonstrating the symbolic indexing interface for ODEs,
    note that the same functionality works across all of the other problem types, such as
    optimization problems, nonlinear problems, nonlinear solutions, etc.

## Symbolic Indexing of Differential Equation Solutions

Consider the following example:

```@example Usage
using ModelingToolkit, OrdinaryDiffEq, SymbolicIndexingInterface, Plots
using ModelingToolkit: t_nounits as t, D_nounits as D

@parameters σ ρ β
@variables x(t) y(t) z(t) w(t)

eqs = [D(D(x)) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
    w ~ x + y + z]

@mtkbuild sys = ODESystem(eqs, t)
```

The system has 4 state variables, 3 parameters, and one observed variable:

```@example Usage
ModelingToolkit.observed(sys)
```

Solving the system,

```@example Usage
u0 = [D(x) => 2.0,
    x => 1.0,
    y => 0.0,
    z => 0.0]

p = [σ => 28.0,
    ρ => 10.0,
    β => 8 / 3]

tspan = (0.0, 100.0)
prob = ODEProblem(sys, u0, tspan, p, jac = true)
sol = solve(prob, Tsit5())
```

We can obtain the timeseries of any time-dependent variable using `getindex`

```@example Usage
sol[x]
```

This also works for arrays or tuples of variables, including observed quantities and
independent variables, for interpolating solutions, and plotting:

```@example Usage
sol[[x, y]]
```

```@example Usage
sol[(t, w)]
```

```@example Usage
sol(1.3, idxs=x)
```

```@example Usage
sol(1.3, idxs=[x, w])
```

```@example Usage
sol(1.3, idxs=[:y, :z])
```

```@example Usage
plot(sol, idxs=x)
```

If necessary, `Symbol`s can be used to refer to variables. This is only valid for
symbolic variables for which [`hasname`](@ref) returns `true`. The `Symbol` used must
match the one returned by [`getname`](@ref) for the variable.

```@example Usage
hasname(x)
```

```@example Usage
getname(x)
```

```@example Usage
sol[(:x, :w)]
```

Note how when indexing with an array, the returned type is a `Vector{Array{Float64}}`,
and when using a `Tuple`, the returned type is `Vector{Tuple{Float64, Float64}}`.
To obtain the value of all state variables, we can use the shorthand:

```@example Usage
sol[solvedvariables] # equivalent to sol[variable_symbols(sol)]
```

This does not include the observed variable `w`. To include observed variables in the
output, the following shorthand is used:
```@example Usage
sol[allvariables] # equivalent to sol[all_variable_symbols(sol)]
```

### Evaluating expressions

`getsym` also generates functions for expressions if the object passed to it supports
[`observed`](@ref). For example:

```@example Usage
getsym(prob, x + y + z)(prob)
```

To evaluate this function using values other than the ones contained in `prob`, we need
an object that supports [`state_values`](@ref), [`parameter_values`](@ref),
[`current_time`](@ref). SymbolicIndexingInterface provides the [`ProblemState`](@ref) type,
which has trivial implementations of the above functions. We can thus do:

```@example Usage
temp_state = ProblemState(; u = [0.1, 0.2, 0.3, 0.4], p = parameter_values(prob))
getsym(prob, x + y + z)(temp_state)
```

Note that providing all of the state vector, parameter object and time may not be
necessary if the function generated by `observed` does not access them. ModelingToolkit.jl
generates functions that access the parameters regardless of whether they are used in the
expression, and thus it needs to be provided to the `ProblemState`.

## Parameter Indexing: Getting and Setting Parameter Values

Parameters cannot be obtained using the `sol[x]` syntax described above, and instead require using [`getp`](@ref) and [`setp`](@ref).

!!! note
    The reason why parameters use a separate syntax is to be able to ensure type stability
    of the `sol[x]` indexing. Without separating the parameter indexing, the return type of
    symbolic indexing could be anything a parameter can be, which is general is not the same
    type as state variables!

```@example Usage
σ_getter = getp(sys, σ)
σ_getter(sol) # can also pass `prob`
```

Note that this also supports arrays/tuples of parameter symbols:

```@example Usage
σ_ρ_getter = getp(sys, (σ, ρ))
σ_ρ_getter(sol)
```

Now suppose the system has to be solved with a different value of the parameter `β`.

```@example Usage
β_setter = setp(sys, β)
β_setter(prob, 3)
```

The updated parameter values can be checked using [`parameter_values`](@ref).

```@example Usage
parameter_values(prob)
```

When solving the new system, note that the parameter getter functions still work on the new
solution object.

```@example Usage
sol2 = solve(prob, Tsit5())
σ_getter(sol)
```

```@example Usage
σ_ρ_getter(sol)
```

To set the entire parameter vector at once, [`setp`](@ref) can be used
(note that the order of symbols passed to `setp` must match the order of values in the array).

```@example Usage
setp(prob, parameter_symbols(prob))(prob, [29.0, 11.0, 2.5])
parameter_values(prob)
```

!!! note
    These getters and setters generate high-performance functions for the specific chosen
    symbols or collection of symbols. Caching the getter/setter function and reusing it
    on other problem/solution instances can be the key to achieving good performance. Note
    that this caching is allowed only when the symbolic system is unchanged (it's fine for
    the numerical values to have changed, but not the underlying equations).

## Re-creating a buffer

To re-create a buffer (of unknowns or parameters) use [`remake_buffer`](@ref). This allows
changing the type of values in the buffer (for example, changing the value of a parameter
from `Float64` to `Float32`).

```@example Usage
remake_buffer(sys, prob.p, Dict(σ => 1f0, ρ => 2f0, β => 3f0))
```

# Simple Demonstration of a Symbolic System Structure

In this tutorial we will show how to implement a system structure type for defining the
symbolic indexing of a domain-specific language. This tutorial will show how the
`SymbolCache` type is defined to take in arrays of symbols for its independent, dependent,
and parameter variable names and uses that to define the symbolic indexing interface.

## Defining the ODE

For this example, we will use the Robertson equations:

```math
\begin{aligned}
\frac{dy_1}{dt} &= -0.04y₁ + 10^4 y_2 y_3 \\
\frac{dy_2}{dt} &= 0.04 y_1 - 10^4 y_2 y_3 - 3*10^7 y_{2}^2 \\
\frac{dy_3}{dt} &= 3*10^7 y_{2}^2 \\
\end{aligned}
```

The in-place function for this ODE system can be defined as:

```@example symbolcache
function rober!(du, u, p, t)
    y₁, y₂, y₃ = u
    k₁, k₂, k₃ = p
    du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
    du[2] = k₁ * y₁ - k₂ * y₂^2 - k₃ * y₂ * y₃
    du[3] = k₂ * y₂^2
    nothing
end
```

To add symbolic names for the states in this example, a [`SymbolCache`](@ref) can be
created and passed as the `sys` keyword argument to the `ODEFunction` constructor,
as shown below:

```@example symbolcache
using OrdinaryDiffEq, SymbolicIndexingInterface

sys = SymbolCache([:y₁, :y₂, :y₃])
odefun = ODEFunction(rober!; sys = sys)
nothing # hide
```

This is then used to create and solve the `ODEProblem`

```@example symbolcache
prob = ODEProblem(odefun, [1.0, 0.0, 0.0], (0.0, 1e5), [0.04, 3e7, 1e4])
sol = solve(prob, Rosenbrock23())
```

The solution can now be indexed symbolically:

```@example symbolcache
sol[:y₁]
```

```@example symbolcache
sol(1e3, idxs=:y₁)
```

However, we did not give names to the parameters or the independent variables. They can
be specified using `SymbolCache` as well:

```@example symbolcache
sys = SymbolCache([:y₁, :y₂, :y₃], [:k₁, :k₂, :k₃], :t)
odefun = ODEFunction(rober!; sys = sys)
prob = ODEProblem(odefun, [1.0, 0.0, 0.0], (0.0, 1e5), [0.04, 3e7, 1e4])
sol = solve(prob, Rosenbrock23())
getk1 = getp(sys, :k₁)

getk1(prob)
```

```@example symbolcache
getk1(sol)
```

```@example symbolcache
sol[:t]
```

# Interface Functions

## Index provider interface

### Mandatory methods

```@docs
is_variable
variable_index
variable_symbols
is_parameter
parameter_index
parameter_symbols
is_independent_variable
independent_variable_symbols
is_observed
default_values
is_time_dependent
constant_structure
all_variable_symbols
all_symbols
solvedvariables
allvariables
```

### Optional Methods

```@docs
symbolic_container
```

#### Observed equation handling

```@docs
observed
parameter_observed
```

#### Historical index providers

```@docs
is_markovian
```

#### Parameter timeseries

If the index provider contains parameters that change during the course of the simulation
at discrete time points, it must implement the following methods to ensure correct
functioning of [`getsym`](@ref) and [`getp`](@ref) for value providers that save the parameter
timeseries. Note that there can be multiple parameter timeseries, in case different parameters
may change at different times.

```@docs
is_timeseries_parameter
timeseries_parameter_index
ParameterTimeseriesIndex
get_all_timeseries_indexes
ContinuousTimeseries
```

## Value provider interface

### State indexing

```@docs
Timeseries
NotTimeseries
is_timeseries
state_values
set_state!
current_time
getsym
getu
setsym
setu
```

!!! note
    `getu` and `setu` have been renamed to [`getsym`](@ref) and [`setsym`](@ref) respectively.

#### Historical value providers

```@docs
get_history_function
```

### Parameter indexing

```@docs
parameter_values
set_parameter!
finalize_parameters_hook!
getp
setp
setp_oop
ParameterIndexingProxy
show_params
```

#### Parameter timeseries

If a solution object saves a timeseries of parameter values that are updated during the
simulation (such as by callbacks), it must implement the following methods to ensure
correct functioning of [`getsym`](@ref) and [`getp`](@ref).

Parameter timeseries support requires that the value provider store the different
timeseries in a [`ParameterTimeseriesCollection`](@ref).

```@docs
is_parameter_timeseries
get_parameter_timeseries_collection
ParameterTimeseriesCollection
with_updated_parameter_timeseries_values
```

### Batched Queries and Updates

```@docs
BatchedInterface
associated_systems
setsym_oop
```

## Container objects

```@docs
remake_buffer
```

# Symbolic Trait

```@docs
ScalarSymbolic
ArraySymbolic
NotSymbolic
symbolic_type
hasname
getname
symbolic_evaluate
```

# Types

```@docs
SymbolCache
ProblemState
```
